package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTUsuario;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTUsuario;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping("/api/v1.0/users")
public class UserController {

    private final DaoUzyTUsuario userRepository;

    @Autowired
    public UserController(DaoUzyTUsuario userRepository) {
        this.userRepository = userRepository;
    }

    @GetMapping("/by-email/{email}")
    public ResponseEntity<ModelUzyTUsuario> getUserByEmail(@PathVariable String email) {
        ModelUzyTUsuario user = userRepository.findByEmail(email);
        if (user != null) {
            return ResponseEntity.ok(user);
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
