package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTCatalogosGenerales;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTCatalogosGenerales.IServiceUzyTCatalogosGenerales;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/catalagosgen")
public class UzyTCatalogosGeneralesController {

    private final IServiceUzyTCatalogosGenerales serviceUzyTCatalogosGenerales;

    public UzyTCatalogosGeneralesController(IServiceUzyTCatalogosGenerales serviceUzyTCatalogosGenerales) {
        this.serviceUzyTCatalogosGenerales = serviceUzyTCatalogosGenerales;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTCatalogosGenerales> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTCatalogosGenerales.ListarPorID(id), HttpStatus.OK);
    }


    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTCatalogosGenerales>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTCatalogosGenerales.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTCatalogosGenerales> guardar(@RequestBody DtoUzyTCatalogosGenerales dtoUzyTCatalogosGenerales) {
        return new  ResponseEntity<>(serviceUzyTCatalogosGenerales.guardar(dtoUzyTCatalogosGenerales), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTCatalogosGenerales> editar(@PathVariable Long id, @RequestBody DtoUzyTCatalogosGenerales dtoUzyTCatalogosGenerales) {
        return new  ResponseEntity<>(serviceUzyTCatalogosGenerales.editar(id, dtoUzyTCatalogosGenerales), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTCatalogosGenerales.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
