package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTClasificadorPresup;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTClasificadorPresup.IServiceUzyTClasificadorPresup;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/clasificadorP")
public class UzyTClasificadorPresupController {

    private final IServiceUzyTClasificadorPresup serviceUzyTClasificadorPresup;

    public UzyTClasificadorPresupController(IServiceUzyTClasificadorPresup serviceUzyTClasificadorPresup) {
        this.serviceUzyTClasificadorPresup = serviceUzyTClasificadorPresup;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTClasificadorPresup> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTClasificadorPresup.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/obtenerClasificadorPresup")
    public ResponseEntity<List<DtoUzyTClasificadorPresup> > obtenerClasificadorPresup() {
        return new ResponseEntity<>(serviceUzyTClasificadorPresup.obtenerClasificadorPresup(), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTClasificadorPresup>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTClasificadorPresup.ListarRegistros(), HttpStatus.OK);
    }



    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTClasificadorPresup> guardar(@Valid @RequestBody DtoUzyTClasificadorPresup dtoUzyTClasificadorPresup) {
        DtoUzyTClasificadorPresup savedDto = serviceUzyTClasificadorPresup.guardar(dtoUzyTClasificadorPresup);
        return ResponseEntity.ok(savedDto);
    }




    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTClasificadorPresup> editar(@PathVariable Long id, @RequestBody DtoUzyTClasificadorPresup dtoUzyTClasificadorPresup) {
        return new ResponseEntity<>(serviceUzyTClasificadorPresup.editar(id, dtoUzyTClasificadorPresup), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTClasificadorPresup.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
