package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTLineaOperativa;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTLineaOperativa.IServiceUzyTLineaOperativa;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/lineaoperativa")
public class UzyTLineaOperativaController {

    private final IServiceUzyTLineaOperativa serviceUzyTLineaOperativa;

    public UzyTLineaOperativaController(IServiceUzyTLineaOperativa serviceUzyTLineaOperativa) {
        this.serviceUzyTLineaOperativa = serviceUzyTLineaOperativa;
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTLineaOperativa> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTLineaOperativa.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTLineaOperativa>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTLineaOperativa.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTLineaOperativa> guardar(@RequestBody DtoUzyTLineaOperativa dtoUzyTLineaOperativa) {
        return new  ResponseEntity<>(serviceUzyTLineaOperativa.guardar(dtoUzyTLineaOperativa), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTLineaOperativa> editar(@PathVariable Long id, @RequestBody DtoUzyTLineaOperativa dtoUzyTLineaOperativa) {
        return new  ResponseEntity<>(serviceUzyTLineaOperativa.editar(id, dtoUzyTLineaOperativa), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTLineaOperativa.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }


}
