package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTMenu;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTMenu.IServiceUzyTMenu;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/menu")
public class UzyTMenuController {
    private final IServiceUzyTMenu serviceUzyTMenu;

    @Autowired
    public UzyTMenuController(IServiceUzyTMenu serviceUzyTMenu) {
        this.serviceUzyTMenu = serviceUzyTMenu;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTMenu ListarPorID(@PathVariable Long id) {
            return serviceUzyTMenu.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTMenu>> ListarRegistros() {
        List<DtoUzyTMenu> uzyTMenuList = serviceUzyTMenu.ListarRegistros();
        return ResponseEntity.ok(uzyTMenuList);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTMenu> guardar(@RequestBody DtoUzyTMenu dtoUzyTMenu) {
        DtoUzyTMenu createdUzyTMenu = serviceUzyTMenu.guardar(dtoUzyTMenu);
        return ResponseEntity.status(HttpStatus.CREATED).body(createdUzyTMenu);
    }

    @PutMapping("/editar/{id}")
    public DtoUzyTMenu editar(@PathVariable Long id, @RequestBody DtoUzyTMenu dtoUzyTMenu) {
            return serviceUzyTMenu.editar(id, dtoUzyTMenu);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTMenu.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
