package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTProvincia;

import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTProvincia.IServiceUzyTProvincia;


import org.springframework.beans.factory.annotation.Autowired;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/provincia")
public class UzyTProvinciaController {

    private final IServiceUzyTProvincia serviceUzyTProvincia;

    @Autowired
    public UzyTProvinciaController(IServiceUzyTProvincia serviceUzyTProvincia) {
        this.serviceUzyTProvincia = serviceUzyTProvincia;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTProvincia> ListarPorID(@PathVariable String id) {
        return ResponseEntity.ok(serviceUzyTProvincia.ListarPorID(id));

    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTProvincia>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTProvincia.ListarRegistros(), HttpStatus.OK);

    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTProvincia> guardar(@RequestBody DtoUzyTProvincia DtoUzyTProvincia) {
        return new ResponseEntity<>(serviceUzyTProvincia.guardar(DtoUzyTProvincia), HttpStatus.OK);

    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTProvincia> editar(@PathVariable String id,
                                                   @RequestBody DtoUzyTProvincia DtoUzyTProvincia) {
        return new ResponseEntity<>(serviceUzyTProvincia.editar(id, DtoUzyTProvincia), HttpStatus.OK);

    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable String id) {
        boolean eliminado = serviceUzyTProvincia.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
