package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTaValorPar.IServiceUzyTaValorPar;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/valorpar")
public class UzyTaValorParController {
    private final IServiceUzyTaValorPar serviceUzyTaValorPar;
    public UzyTaValorParController(IServiceUzyTaValorPar serviceUzyTaValorPar) {
        this.serviceUzyTaValorPar = serviceUzyTaValorPar;
    }
    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTaValorPar> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTaValorPar.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTaValorPar>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTaValorPar.ListarRegistros(), HttpStatus.OK);
    }

    //Servicio para obtener los datos de valorPar relacionados con ParaEva
    @GetMapping("/datosRealacionadosParaEva/{id}")
    public ResponseEntity<List<DtoUzyTaValorPar>> findByIdDatosRelacionadosConParaEva(@PathVariable("id") Long id) {
        List<DtoUzyTaValorPar> result = serviceUzyTaValorPar.findByIdDatosRelacionadosConParaEva(id);
        return new ResponseEntity<>(result, HttpStatus.OK);
    }

    //Servicio para obtener los datos de paraeva relacionados con ValorPar
    @GetMapping("/todosDatosRelacionados")
    public ResponseEntity<List<DtoUzyTaValorPar>> getAllDatosRelacionadosParaEva() {
        List<DtoUzyTaValorPar> result = serviceUzyTaValorPar.getAllDatosRelacionadosParaEva();
        return new ResponseEntity<>(result, HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTaValorPar> guardar(@Valid @RequestBody DtoUzyTaValorPar dtoUzyTaValorPar) {
        DtoUzyTaValorPar savedDto = serviceUzyTaValorPar.guardar(dtoUzyTaValorPar);
        return ResponseEntity.ok(savedDto);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTaValorPar> editar(@PathVariable Long id, @RequestBody DtoUzyTaValorPar dtoUzyTaValorPar) {
        return new  ResponseEntity<>(serviceUzyTaValorPar.editar(id, dtoUzyTaValorPar), HttpStatus.OK);
    }



    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTaValorPar.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
