package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActProy;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActProy.IServiceUzyTavActProy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/actproy")
public class UzyTavActProyController {
    private final IServiceUzyTavActProy serviceUzyTavActProy;

    public UzyTavActProyController(IServiceUzyTavActProy serviceUzyTavActProy) {
        this.serviceUzyTavActProy = serviceUzyTavActProy;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavActProy ListarPorID(@PathVariable Long id) {
        return serviceUzyTavActProy.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavActProy> ListarRegistros() {
        return serviceUzyTavActProy.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavActProy guardar(@Valid @RequestBody DtoUzyTavActProy dtoUzyTavActProy) {
        return serviceUzyTavActProy.guardar(dtoUzyTavActProy);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavActProy editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavActProy dtoUzyTavActProy) {
        return serviceUzyTavActProy.editar(id, dtoUzyTavActProy);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavActProy.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
