package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActaPrueba;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActaPrueba.IServiceUzyTavActaPrueba;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/actaprueba")
public class UzyTavActaPruebaController {
    private final
    IServiceUzyTavActaPrueba serviceUzyTavActaPrueba;

    public UzyTavActaPruebaController(IServiceUzyTavActaPrueba serviceUzyTavActaPrueba) {
        this.serviceUzyTavActaPrueba = serviceUzyTavActaPrueba;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavActaPrueba> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavActaPrueba.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavActaPrueba>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavActaPrueba.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavActaPrueba> guardar(@RequestBody DtoUzyTavActaPrueba dtoUzyTavActaPrueba) {
        return new  ResponseEntity<>(serviceUzyTavActaPrueba.guardar(dtoUzyTavActaPrueba), HttpStatus.OK);
    }




    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavActaPrueba> editar(@PathVariable Long id, @RequestBody DtoUzyTavActaPrueba dtoUzyTavActaPrueba) {
        return new  ResponseEntity<>(serviceUzyTavActaPrueba.editar(id, dtoUzyTavActaPrueba), HttpStatus.OK);
    }



    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavActaPrueba.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}

