package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActaResponsa;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActaResponsa.IServiceUzyTavActaResponsa;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/actaresponsa")
public class UzyTavActaResponsaController {
    private final IServiceUzyTavActaResponsa serviceUzyTavActaResponsa;

    public UzyTavActaResponsaController(IServiceUzyTavActaResponsa serviceUzyTavActaResponsa) {
        this.serviceUzyTavActaResponsa = serviceUzyTavActaResponsa;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavActaResponsa ListarPorID(@PathVariable Long id) {
        return serviceUzyTavActaResponsa.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavActaResponsa> ListarRegistros() {
        return serviceUzyTavActaResponsa.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavActaResponsa guardar(@Valid @RequestBody DtoUzyTavActaResponsa dtoUzyTavActaResponsa) {
        return serviceUzyTavActaResponsa.guardar(dtoUzyTavActaResponsa);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavActaResponsa editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavActaResponsa dtoUzyTavActaResponsa) {
        return serviceUzyTavActaResponsa.editar(id,dtoUzyTavActaResponsa);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavActaResponsa.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
