package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActasPerfil_Proyec;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActasPerfil_Proyec.IServiceUzyTavActasPerfil_Proyec;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.List;
@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/actasperfilProyec")
public class UzyTavActasPerfil_ProyecController {

    private final IServiceUzyTavActasPerfil_Proyec serviceUzyTavActasPerfilProyec;

    public UzyTavActasPerfil_ProyecController(IServiceUzyTavActasPerfil_Proyec serviceUzyTavActasPerfilProyec) {
        this.serviceUzyTavActasPerfilProyec = serviceUzyTavActasPerfilProyec;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavActasPerfil_Proyec ListarPorID(@PathVariable Long id) {
        return serviceUzyTavActasPerfilProyec.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavActasPerfil_Proyec> ListarRegistros() {
        return serviceUzyTavActasPerfilProyec.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavActasPerfil_Proyec guardar(@Valid @RequestBody DtoUzyTavActasPerfil_Proyec dtoUzyTavActasPerfilProyec) {
        return serviceUzyTavActasPerfilProyec.guardar(dtoUzyTavActasPerfilProyec);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavActasPerfil_Proyec editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavActasPerfil_Proyec dtoUzyTavActasPerfilProyec) {
        return serviceUzyTavActasPerfilProyec.editar(id, dtoUzyTavActasPerfilProyec);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavActasPerfilProyec.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
