package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActivProg;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActivProg.IServiceUzyTavActivProg;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/activprog")
public class UzyTavActivProgController {
    private final IServiceUzyTavActivProg serviceUzyTavActivProg;

    public UzyTavActivProgController(IServiceUzyTavActivProg serviceUzyTavActivProg) {
        this.serviceUzyTavActivProg = serviceUzyTavActivProg;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavActivProg ListarPorID(@PathVariable Long id) {
        return serviceUzyTavActivProg.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavActivProg> ListarRegistros() {
        return serviceUzyTavActivProg.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavActivProg guardar(@Valid @RequestBody DtoUzyTavActivProg dtoUzyTavActivProg) {
        return serviceUzyTavActivProg.guardar(dtoUzyTavActivProg);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavActivProg editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavActivProg dtoUzyTavActivProg) {
        return serviceUzyTavActivProg.editar(id, dtoUzyTavActivProg);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavActivProg.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
