package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavAnualValor;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavAnualValor.IServiceUzyTavAnualValor;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/anualvalor")
public class UzyTavAnualValorController {
    private final
    IServiceUzyTavAnualValor serviceUzyTavAnualValor;

    public UzyTavAnualValorController(IServiceUzyTavAnualValor serviceUzyTavAnualValor) {
        this.serviceUzyTavAnualValor = serviceUzyTavAnualValor;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavAnualValor> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavAnualValor.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavAnualValor>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavAnualValor.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavAnualValor> guardar(@RequestBody DtoUzyTavAnualValor dtoUzyTavAnualValor) {
        return new  ResponseEntity<>(serviceUzyTavAnualValor.guardar(dtoUzyTavAnualValor), HttpStatus.OK);
    }




    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavAnualValor> editar(@PathVariable Long id, @RequestBody DtoUzyTavAnualValor dtoUzyTavAnualValor) {
        return new  ResponseEntity<>(serviceUzyTavAnualValor.editar(id, dtoUzyTavAnualValor), HttpStatus.OK);
    }



    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavAnualValor.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
