package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabComca;

import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabComca.IServiceUzyTavCabComca;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/cabcomca")
public class UzyTavCabComcaController {
    private final IServiceUzyTavCabComca serviceUzyTavCabComca;

    public UzyTavCabComcaController(IServiceUzyTavCabComca serviceUzyTavCabComca) {
        this.serviceUzyTavCabComca = serviceUzyTavCabComca;
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavCabComca> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavCabComca.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavCabComca>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavCabComca.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavCabComca> guardar(@RequestBody DtoUzyTavCabComca dtoUzyTavCabComca) {
        return new  ResponseEntity<>(serviceUzyTavCabComca.guardar(dtoUzyTavCabComca), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavCabComca> editar(@PathVariable Long id, @RequestBody DtoUzyTavCabComca dtoUzyTavCabComca) {
        return new  ResponseEntity<>(serviceUzyTavCabComca.editar(id, dtoUzyTavCabComca), HttpStatus.OK);
    }



    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavCabComca.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
