package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabParaevaf.IServiceUzyTavCabParaevaf;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/cabparaevaf")
public class UzyTavCabParaevafController {

    private final IServiceUzyTavCabParaevaf serviceUzyTavCabParaevaf;

    public UzyTavCabParaevafController(IServiceUzyTavCabParaevaf serviceUzyTavCabParaevaf) {
        this.serviceUzyTavCabParaevaf = serviceUzyTavCabParaevaf;
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavCabParaevaf> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavCabParaevaf.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/datosRealacionadosConParaEva2/{id}")
    public List<DtoUzyTavCabParaevaf> findByIdDatosConParaEvaTipo2(@PathVariable("id") Long id) {
        return serviceUzyTavCabParaevaf.findByIdDatosConParaEvaTipo2(id);
    }


    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavCabParaevaf>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavCabParaevaf.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavCabParaevaf> guardar(@Valid @RequestBody DtoUzyTavCabParaevaf dtoUzyTavCabParaevaf) {
        DtoUzyTavCabParaevaf savedDto = serviceUzyTavCabParaevaf.guardar(dtoUzyTavCabParaevaf);
        return ResponseEntity.ok(savedDto);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavCabParaevaf> editar(@PathVariable Long id, @RequestBody DtoUzyTavCabParaevaf dtoUzyTavCabParaevaf) {
        return new  ResponseEntity<>(serviceUzyTavCabParaevaf.editar(id, dtoUzyTavCabParaevaf), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavCabParaevaf.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
