package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabeValp.IServiceUzyTavCabeValp;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/cabevalp")
public class UzyTavCabeValpController {

    private final IServiceUzyTavCabeValp serviceUzyTavCabeValp;

    public UzyTavCabeValpController(IServiceUzyTavCabeValp serviceUzyTavCabeValp) {
        this.serviceUzyTavCabeValp = serviceUzyTavCabeValp;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavCabeValp> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavCabeValp.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavCabeValp>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavCabeValp.ListarRegistros(), HttpStatus.OK);
    }

    @GetMapping("/findByIdDatosPorProyecID/{uzytavproyec_id}")
    public ResponseEntity<List<DtoUzyTavCabeValp>> findByIdDatosPorProyecID(@PathVariable Long uzytavproyec_id) {
        return new ResponseEntity<>(serviceUzyTavCabeValp.findByIdDatosPorProyecID(uzytavproyec_id), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavCabeValp> guardar(@RequestBody DtoUzyTavCabeValp dtoUzyTavCabeValp) {
        return new  ResponseEntity<>(serviceUzyTavCabeValp.guardar(dtoUzyTavCabeValp), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavCabeValp> editar(@PathVariable Long id, @RequestBody DtoUzyTavCabeValp dtoUzyTavCabeValp) {
        return new  ResponseEntity<>(serviceUzyTavCabeValp.editar(id, dtoUzyTavCabeValp), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavCabeValp.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
