package ec.edu.espe.movilidad.MovilidadWS.Controller;


import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfObj;

import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConfObj.IServiceUzyTavConfObj;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/ConfObj")
public class UzyTavConfObjController {

    private final IServiceUzyTavConfObj serviceUzyTavConfObj;

    public UzyTavConfObjController(IServiceUzyTavConfObj serviceUzyTavConfObj) {
        this.serviceUzyTavConfObj = serviceUzyTavConfObj;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavConfObj> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavConfObj.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavConfObj>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavConfObj.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavConfObj> guardar(@Valid @RequestBody DtoUzyTavConfObj dtoUzyTavConfObj) {
        DtoUzyTavConfObj savedDto = serviceUzyTavConfObj.guardar(dtoUzyTavConfObj);
        return ResponseEntity.ok(savedDto);
    }



    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavConfObj> editar(@PathVariable Long id, @RequestBody DtoUzyTavConfObj dtoUzyTavConfObj) {
        return new ResponseEntity<>(serviceUzyTavConfObj.editar(id, dtoUzyTavConfObj), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavConfObj.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
