package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfTipo;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConfTipo.IServiceUzyTavConfTipo;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/ConfTipo")
public class UzyTavConfTipoController {

    private final IServiceUzyTavConfTipo serviceUzyTavConfTipo;

    public UzyTavConfTipoController(IServiceUzyTavConfTipo serviceUzyTavConfTipo) {
        this.serviceUzyTavConfTipo = serviceUzyTavConfTipo;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavConfTipo> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavConfTipo.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavConfTipo>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavConfTipo.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavConfTipo> guardar(@Valid @RequestBody DtoUzyTavConfTipo dtoUzyTavConfTipo) {
        DtoUzyTavConfTipo savedDto = serviceUzyTavConfTipo.guardar(dtoUzyTavConfTipo);
        return ResponseEntity.ok(savedDto);
    }



    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavConfTipo> editar(@PathVariable Long id, @RequestBody DtoUzyTavConfTipo dtoUzyTavConfTipo) {
        return new ResponseEntity<>(serviceUzyTavConfTipo.editar(id, dtoUzyTavConfTipo), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavConfTipo.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
