package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfiguracion;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConfiguracion.IServiceUzyTavConfiguracion;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import java.util.List;
import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;
@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/configuracion")
public class UzyTavConfiguracionController {

    private final IServiceUzyTavConfiguracion serviceUzyTavConfiguracion;

    @Autowired
    public UzyTavConfiguracionController( IServiceUzyTavConfiguracion serviceUzyTavConfiguracion ){
        this.serviceUzyTavConfiguracion = serviceUzyTavConfiguracion;
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavConfiguracion.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/CedVicerrector/{cedula}")
    public ResponseEntity<DtoUzyTavConfiguracion> buscarPorCedulaVicerrector(@PathVariable String cedula) {
        return new ResponseEntity<>(serviceUzyTavConfiguracion.buscarPorCedulaVicerrector(cedula), HttpStatus.OK);
    }

    @GetMapping("/CedDirector/{cedula}")
    public ResponseEntity<DtoUzyTavConfiguracion> buscarPorCedulaDirector(@PathVariable String cedula) {
        return new ResponseEntity<>(serviceUzyTavConfiguracion.buscarPorCedulaDirector(cedula), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavConfiguracion>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavConfiguracion.ListarRegistros(), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavConfiguracion> guardar(@RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.guardar(dtoUzyTavConfiguracion), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> editar(@PathVariable Long id, @RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.editar(id, dtoUzyTavConfiguracion), HttpStatus.OK);
    }


    @PutMapping("/editarHorasDocente/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> editarHorasDocente(@PathVariable Long id, @RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.editarHorasDocente(id, dtoUzyTavConfiguracion), HttpStatus.OK);
    }


    @PutMapping("/editarHorasEstudiante/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> editarHorasEstudiante(@PathVariable Long id, @RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.editarHorasEstudiante(id, dtoUzyTavConfiguracion), HttpStatus.OK);
    }


    @PutMapping("/editarDatosVicerrector/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> editarDatosVicerrector(@PathVariable Long id, @RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.editarDatosVicerrector(id, dtoUzyTavConfiguracion), HttpStatus.OK);
    }


    @PutMapping("/editarDatosDirector/{id}")
    public ResponseEntity<DtoUzyTavConfiguracion> editarDatosDirector(@PathVariable Long id, @RequestBody DtoUzyTavConfiguracion dtoUzyTavConfiguracion) {
        return new  ResponseEntity<>(serviceUzyTavConfiguracion.editarDatosDirector(id, dtoUzyTavConfiguracion), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<Void> eliminar(@PathVariable Long id) {
        serviceUzyTavConfiguracion.eliminar(id);
        return ResponseEntity.ok().build();
    }

}
