package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConsolca.IServiceUzyTavConsolca;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/consolca")
public class UzyTavConsolcaController {


    private final IServiceUzyTavConsolca serviceUzyTavConsolca;

    public UzyTavConsolcaController(IServiceUzyTavConsolca serviceUzyTavConsolca) {
        this.serviceUzyTavConsolca = serviceUzyTavConsolca;
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavConsolca> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavConsolca.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavConsolca>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavConsolca.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavConsolca> guardar(@RequestBody DtoUzyTavConsolca dtoUzyTavConsolca) {
        return new  ResponseEntity<>(serviceUzyTavConsolca.guardar(dtoUzyTavConsolca), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavConsolca> editar(@PathVariable Long id, @RequestBody DtoUzyTavConsolca dtoUzyTavConsolca) {
        return new  ResponseEntity<>(serviceUzyTavConsolca.editar(id, dtoUzyTavConsolca), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavConsolca.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
