package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDesigDoc;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDesigDoc.IServiceUzyTavDesigDoc;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/desigdoc")
public class UzyTavDesigDocController {

    private final IServiceUzyTavDesigDoc serviceUzyTavDesigDoc;

    public UzyTavDesigDocController(IServiceUzyTavDesigDoc serviceUzyTavDesigDoc) {
        this.serviceUzyTavDesigDoc = serviceUzyTavDesigDoc;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavDesigDoc ListarPorID(@PathVariable Long id) {
        return serviceUzyTavDesigDoc.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavDesigDoc> ListarRegistros() {
        return serviceUzyTavDesigDoc.ListarRegistros();
    }
    @PostMapping("/guardar")
    public DtoUzyTavDesigDoc guardar(@Valid @RequestBody DtoUzyTavDesigDoc dtoUzyTavDesigDoc) {
        return serviceUzyTavDesigDoc.guardar(dtoUzyTavDesigDoc);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavDesigDoc editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavDesigDoc dtoUzyTavDesigDoc) {
        return serviceUzyTavDesigDoc.editar(id, dtoUzyTavDesigDoc);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavDesigDoc.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
