package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDesigEstu;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDesigEstu.IServiceUzyTavDesigEstu;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/desigestu")
public class UzyTavDesigEstuController {
    private final IServiceUzyTavDesigEstu serviceUzyTavDesigEstu;

    public UzyTavDesigEstuController(IServiceUzyTavDesigEstu serviceUzyTavDesigEstu) {
        this.serviceUzyTavDesigEstu = serviceUzyTavDesigEstu;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavDesigEstu ListarPorID(@PathVariable Long id) {
        return serviceUzyTavDesigEstu.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavDesigEstu> ListarRegistros() {
        return serviceUzyTavDesigEstu.ListarRegistros();
    }
    @PostMapping("/guardar")
    public DtoUzyTavDesigEstu guardar(@Valid @RequestBody DtoUzyTavDesigEstu dtoUzyTavDesigEstu) {
        return serviceUzyTavDesigEstu.guardar(dtoUzyTavDesigEstu);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavDesigEstu editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavDesigEstu dtoUzyTavDesigEstu) {
        return serviceUzyTavDesigEstu.editar(id, dtoUzyTavDesigEstu);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavDesigEstu.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
