package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDetActproy;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDetActproy.IServiceUzyTavDetActproy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/detactproy")
public class UzyTavDetActproyController {
    private final IServiceUzyTavDetActproy serviceUzyTavDetActproy;

    public UzyTavDetActproyController(IServiceUzyTavDetActproy serviceUzyTavDetActproy) {
        this.serviceUzyTavDetActproy = serviceUzyTavDetActproy;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavDetActproy ListarPorID(@PathVariable Long id) {
        return serviceUzyTavDetActproy.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavDetActproy> ListarRegistros() {
        return serviceUzyTavDetActproy.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavDetActproy guardar(@Valid @RequestBody DtoUzyTavDetActproy dtoUzyTavDetActproy) {
        return serviceUzyTavDetActproy.guardar(dtoUzyTavDetActproy);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavDetActproy editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavDetActproy dtoUzyTavDetActproy) {
        return serviceUzyTavDetActproy.editar(id, dtoUzyTavDetActproy);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavDetActproy.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
