package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDetComca;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDetComca.IServiceUzyTavDetComca;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/detcomca")
public class UzyTavDetComcaController {

    private final  IServiceUzyTavDetComca serviceUzyTavDetComca;

    public UzyTavDetComcaController(IServiceUzyTavDetComca serviceUzyTavDetComca) {
        this.serviceUzyTavDetComca = serviceUzyTavDetComca;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavDetComca> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavDetComca.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavDetComca>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavDetComca.ListarRegistros(), HttpStatus.OK);
    }

    @GetMapping("/datosRealacionadosconCabComca/{id}")
    public ResponseEntity<List<DtoUzyTavDetComca>> findByIdconDatosCabComca(@PathVariable("id") Long id) {
        return new ResponseEntity<>(serviceUzyTavDetComca.findByIdconDatosCabComca(id), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavDetComca> guardar(@Valid @RequestBody DtoUzyTavDetComca dtoUzyTavDetComca) {
        DtoUzyTavDetComca savedDto = serviceUzyTavDetComca.guardar(dtoUzyTavDetComca);
        return ResponseEntity.ok(savedDto);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavDetComca> editar(@PathVariable Long id, @RequestBody DtoUzyTavDetComca dtoUzyTavDetComca) {
        return new  ResponseEntity<>(serviceUzyTavDetComca.editar(id, dtoUzyTavDetComca), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavDetComca.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
