package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDocParti;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDocParti.IServiceUzyTavDocParti;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/docparti")
public class UzyTavDocPartiController {
    private final IServiceUzyTavDocParti serviceUzyTavDocParti;

    public UzyTavDocPartiController(IServiceUzyTavDocParti serviceUzyTavDocParti) {
        this.serviceUzyTavDocParti = serviceUzyTavDocParti;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavDocParti> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavDocParti.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavDocParti>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavDocParti.ListarRegistros(), HttpStatus.OK);
    }


    @GetMapping("/datosRelacionadosConProyecto/{proyecID}")
    public ResponseEntity<List<DtoUzyTavDocParti>> obtenerDocPartiPorProyecto(@PathVariable Long proyecID) {
        return new ResponseEntity<>(serviceUzyTavDocParti.obtenerDocPartiPorProyecto(proyecID), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavDocParti> guardar(@RequestBody DtoUzyTavDocParti dtoUzyTavDocParti) {
        return new ResponseEntity<>(serviceUzyTavDocParti.guardar(dtoUzyTavDocParti), HttpStatus.OK);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavDocParti> editar(@PathVariable Long id,
                                                    @RequestBody DtoUzyTavDocParti dtoUzyTavDocParti) {
        return new ResponseEntity<>(serviceUzyTavDocParti.editar(id, dtoUzyTavDocParti), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavDocParti.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}

