package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavEstuParti;

import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavEstuParti.IServiceUzyTavEstuParti;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/estuparti")
public class UzyTavEstuPartiController {
    private final IServiceUzyTavEstuParti serviceUzyTavEstuParti;

    public UzyTavEstuPartiController(IServiceUzyTavEstuParti serviceUzyTavEstuParti) {
        this.serviceUzyTavEstuParti = serviceUzyTavEstuParti;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavEstuParti> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavEstuParti.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/datosRelacionadosConProyecto/{proyecID}")
    public ResponseEntity<List<DtoUzyTavEstuParti>> obtenerDocPartiPorProyecto(@PathVariable Long proyecID) {
        return new ResponseEntity<>(serviceUzyTavEstuParti.obtenerEstuPartiPorProyecto(proyecID), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavEstuParti>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavEstuParti.ListarRegistros(), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavEstuParti> guardar(@RequestBody DtoUzyTavEstuParti dtoUzyTavEstuParti) {
        return new ResponseEntity<>(serviceUzyTavEstuParti.guardar(dtoUzyTavEstuParti), HttpStatus.OK);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavEstuParti> editar(@PathVariable Long id,
                                                     @RequestBody DtoUzyTavEstuParti dtoUzyTavEstuParti) {
        return new ResponseEntity<>(serviceUzyTavEstuParti.editar(id, dtoUzyTavEstuParti), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavEstuParti.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
