package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavEvalProy;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavEvalProy.IServiceUzyTavEvalProy;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/evalproy")
public class UzyTavEvalProyController {


    private final IServiceUzyTavEvalProy serviceUzyTavEvalProy;

    public UzyTavEvalProyController(IServiceUzyTavEvalProy serviceUzyTavEvalProy) {
        this.serviceUzyTavEvalProy = serviceUzyTavEvalProy;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavEvalProy> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavEvalProy.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavEvalProy>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavEvalProy.ListarRegistros(), HttpStatus.OK);
    }
    @GetMapping("/findByIdDatosPorCabeValpID/{uzytavcabevalp_id}")
    public ResponseEntity<List<DtoUzyTavEvalProy>> findByIdDatosPorCabeValpID(@PathVariable Long uzytavcabevalp_id) {
        return new ResponseEntity<>(serviceUzyTavEvalProy.findByIdDatosPorCabeValpID(uzytavcabevalp_id), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavEvalProy> guardar(@RequestBody DtoUzyTavEvalProy dtoUzyTavEvalProy) {
        return new  ResponseEntity<>(serviceUzyTavEvalProy.guardar(dtoUzyTavEvalProy), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavEvalProy> editar(@PathVariable Long id, @RequestBody DtoUzyTavEvalProy dtoUzyTavEvalProy) {
        return new  ResponseEntity<>(serviceUzyTavEvalProy.editar(id, dtoUzyTavEvalProy), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavEvalProy.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
