package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavHorEjec;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavHorEjec.IServiceUzyTavHorEjec;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/horaejec")
public class UzyTavHorEjecController {
    private  final IServiceUzyTavHorEjec serviceUzyTavHorEjec;

    public UzyTavHorEjecController(IServiceUzyTavHorEjec serviceUzyTavHorEjec) {
        this.serviceUzyTavHorEjec = serviceUzyTavHorEjec;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavHorEjec ListarPorID(@PathVariable Long id) {
        return serviceUzyTavHorEjec.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavHorEjec> ListarRegistros() {
        return serviceUzyTavHorEjec.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavHorEjec guardar(@Valid @RequestBody DtoUzyTavHorEjec dtoUzyTavHorEjec) {
        return serviceUzyTavHorEjec.guardar(dtoUzyTavHorEjec);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavHorEjec editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavHorEjec dtoUzyTavHorEjec) {
        return serviceUzyTavHorEjec.editar(id, dtoUzyTavHorEjec);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavHorEjec.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
