package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavInstProy;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavInstProy.IServiceUzyTavInstProy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/instproy")
public class UzyTavInstProyController {

    private final IServiceUzyTavInstProy serviceUzyTavInstProy;

    public UzyTavInstProyController(IServiceUzyTavInstProy serviceUzyTavInstProy) {
        this.serviceUzyTavInstProy = serviceUzyTavInstProy;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavInstProy ListarPorID(@PathVariable Long id) {
        return serviceUzyTavInstProy.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavInstProy> ListarRegistros() {
        return serviceUzyTavInstProy.ListarRegistros();
    }

    @GetMapping("/obtenerRegistrosTavInsituc/{uzytavinstituc_id}")
    public List<DtoUzyTavInstProy> obtenerRegistrosTavInsituc(@PathVariable Long uzytavinstituc_id) {
        return serviceUzyTavInstProy.obtenerRegistrosTavInsituc(uzytavinstituc_id);
    }

    @GetMapping("/obtenerRegistrosProyec/{uzytavproyec_id}")
    public List<DtoUzyTavInstProy> obtenerRegistrosProyec(@PathVariable Long uzytavproyec_id) {
        return serviceUzyTavInstProy.obtenerRegistrosProyec(uzytavproyec_id);
    }

    @PostMapping("/guardar")
    public DtoUzyTavInstProy guardar(@Valid @RequestBody DtoUzyTavInstProy dtoUzyTavInstProy) {
        return serviceUzyTavInstProy.guardar(dtoUzyTavInstProy);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavInstProy editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavInstProy dtoUzyTavInstProy) {
        return serviceUzyTavInstProy.editar(id, dtoUzyTavInstProy);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavInstProy.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
