package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavInstituc;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavInstituc.IServiceUzyTavInstituc;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/instituc")

public class UzyTavInstitucController {

    @Autowired
    IServiceUzyTavInstituc serviceUzyTavInstituc;

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavInstituc> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavInstituc.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavInstituc>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavInstituc.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavInstituc> guardar(@RequestBody DtoUzyTavInstituc dtoUzyTavInstituc) {
        DtoUzyTavInstituc creado = serviceUzyTavInstituc.guardar(dtoUzyTavInstituc);
        return ResponseEntity.status(HttpStatus.CREATED).body(creado);

    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavInstituc> editar(@PathVariable Long id, @RequestBody DtoUzyTavInstituc dtoUzyTavInstituc) {
        return new  ResponseEntity<>(serviceUzyTavInstituc.editar(id, dtoUzyTavInstituc), HttpStatus.OK);
    }




    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavInstituc.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
