package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavLinea;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavLinea.IServiceUzyTavLinea;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/linea")
public class UzyTavLineaController {

    @Autowired
    private IServiceUzyTavLinea serviceUzyTavLinea;

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavLinea> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavLinea.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavLinea>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavLinea.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavLinea> guardar(@RequestBody DtoUzyTavLinea dtoUzyTavLinea) {
        return new ResponseEntity<>(serviceUzyTavLinea.guardar(dtoUzyTavLinea), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavLinea> editar(@PathVariable Long id, @RequestBody DtoUzyTavLinea dtoUzyTavLinea) {
        return new ResponseEntity<>(serviceUzyTavLinea.editar(id, dtoUzyTavLinea), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavLinea.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
