package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivoBVivir;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavObjetivoBVivir.IServiceUzyTavObjetivoBVivir;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/objetivosbuenvivir")
public class UzyTavObjetivoBVivirController {


    private final IServiceUzyTavObjetivoBVivir serviceUzyTavObjetivoBVivir;

    public UzyTavObjetivoBVivirController(IServiceUzyTavObjetivoBVivir serviceUzyTavObjetivoBVivir) {
        this.serviceUzyTavObjetivoBVivir = serviceUzyTavObjetivoBVivir;
    }

    @GetMapping("/getByParentId/{parentId}")
    public ResponseEntity<List<DtoUzyTavObjetivoBVivir>> ListarPorIdPadre(@PathVariable Long parentId) {
        return new ResponseEntity<>(serviceUzyTavObjetivoBVivir.findByUzytavobjetivo_b_vivirid_padre(parentId), HttpStatus.OK);
    }


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavObjetivoBVivir> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavObjetivoBVivir.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavObjetivoBVivir>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavObjetivoBVivir.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavObjetivoBVivir> guardar(@Valid @RequestBody DtoUzyTavObjetivoBVivir dtoUzyTavObjetivoBVivir) {
        DtoUzyTavObjetivoBVivir savedDto = serviceUzyTavObjetivoBVivir.guardar(dtoUzyTavObjetivoBVivir);
        return ResponseEntity.ok(savedDto);
    }



    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavObjetivoBVivir> editar(@PathVariable Long id, @RequestBody DtoUzyTavObjetivoBVivir dtoUzyTavObjetivoBVivir) {
        return new  ResponseEntity<>(serviceUzyTavObjetivoBVivir.editar(id, dtoUzyTavObjetivoBVivir), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavObjetivoBVivir.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
