package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivosEstraInsti;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavObjetivosEstraInsti.IServiceUzyTavObjetivosEstraInsti;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/objetivosEstraInsti")
public class UzyTavObjetivosEstraInstiController {

    private final IServiceUzyTavObjetivosEstraInsti serviceUzyTavObjetivosEstraInsti;

    public UzyTavObjetivosEstraInstiController(IServiceUzyTavObjetivosEstraInsti serviceUzyTavObjetivosEstraInsti) {
        this.serviceUzyTavObjetivosEstraInsti = serviceUzyTavObjetivosEstraInsti;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavObjetivosEstraInsti> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavObjetivosEstraInsti.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/obtenerEstraInstiPadre")
    public ResponseEntity<List<DtoUzyTavObjetivosEstraInsti>> obtenerEstraInstiPadre() {
        return new ResponseEntity<>(serviceUzyTavObjetivosEstraInsti.obtenerEstraInstiPadre(), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavObjetivosEstraInsti>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavObjetivosEstraInsti.ListarRegistros(), HttpStatus.OK);
    }

    @GetMapping("/obtenerPorPadreId/{padreId}")
    public ResponseEntity<List<DtoUzyTavObjetivosEstraInsti>> obtenerPorPadreId(@PathVariable Long padreId) {
        return new ResponseEntity<>(serviceUzyTavObjetivosEstraInsti.obtenerPorPadreId(padreId), HttpStatus.OK);
    }



    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavObjetivosEstraInsti> guardar(@Valid @RequestBody DtoUzyTavObjetivosEstraInsti dtoUzyTavObjetivosEstraInsti) {
        DtoUzyTavObjetivosEstraInsti savedDto = serviceUzyTavObjetivosEstraInsti.guardar(dtoUzyTavObjetivosEstraInsti);
        return ResponseEntity.ok(savedDto);
    }




    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavObjetivosEstraInsti> editar(@PathVariable Long id, @RequestBody DtoUzyTavObjetivosEstraInsti dtoUzyTavObjetivosEstraInsti) {
        return new ResponseEntity<>(serviceUzyTavObjetivosEstraInsti.editar(id, dtoUzyTavObjetivosEstraInsti), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavObjetivosEstraInsti.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
