package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavOpcionInstitucion;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavOpcionInstitucion.IServiceUzyTavOpcionInstitucion;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/opcioninstitucion")

public class UzyTavOpcionInstitucionController {

    private final IServiceUzyTavOpcionInstitucion serviceUzyTavOpcionInstitucion;

    public UzyTavOpcionInstitucionController(IServiceUzyTavOpcionInstitucion serviceUzyTavOpcionInstitucion) {
        this.serviceUzyTavOpcionInstitucion = serviceUzyTavOpcionInstitucion;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavOpcionInstitucion> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavOpcionInstitucion.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavOpcionInstitucion>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavOpcionInstitucion.ListarRegistros(), HttpStatus.OK);
    }

    @GetMapping("/registrosRelacionadosConPrograma/{programaId}")
    public ResponseEntity<List<DtoUzyTavOpcionInstitucion>> ListarRegistrosRelacionadosConPrograma(@PathVariable Long programaId) {
        return new ResponseEntity<>(serviceUzyTavOpcionInstitucion.ListarRegistrosRelacionadosConPrograma(programaId), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavOpcionInstitucion> guardar(@RequestBody DtoUzyTavOpcionInstitucion dtoUzyTavOpcionInstitucion) {
        DtoUzyTavOpcionInstitucion creado = serviceUzyTavOpcionInstitucion.guardar(dtoUzyTavOpcionInstitucion);
        return ResponseEntity.status(HttpStatus.OK).body(creado);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavOpcionInstitucion> editar(@PathVariable Long id,
                                                             @RequestBody DtoUzyTavOpcionInstitucion modelUzyTavOpcionInstitucion) {
        return new ResponseEntity<>(serviceUzyTavOpcionInstitucion.editar(id, modelUzyTavOpcionInstitucion),
                HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavOpcionInstitucion.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
