package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavParametros_Det;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavParametros_Det.IServiceUzyTavParametros_Det;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/parametrosdet")
public class UzyTavParametros_DetController {

    private final IServiceUzyTavParametros_Det serviceUzyTavParametrosDet;

    public UzyTavParametros_DetController(IServiceUzyTavParametros_Det serviceUzyTavParametrosDet) {
        this.serviceUzyTavParametrosDet = serviceUzyTavParametrosDet;
    }
    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavParametros_Det> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavParametrosDet.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavParametros_Det>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavParametrosDet.ListarRegistros(), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavParametros_Det> guardar(@RequestBody DtoUzyTavParametros_Det dtoUzyTavParametrosDet) {
        return new ResponseEntity<>(serviceUzyTavParametrosDet.guardar(dtoUzyTavParametrosDet), HttpStatus.OK);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavParametros_Det> editar(@PathVariable Long id,
                                                    @RequestBody DtoUzyTavParametros_Det dtoUzyTavParametrosDet) {
        return new ResponseEntity<>(serviceUzyTavParametrosDet.editar(id, dtoUzyTavParametrosDet), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavParametrosDet.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
