package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPlanVPrograma;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPlanVPrograma.IServiceUzyTavPlanVPrograma;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/planvprograma")
public class UzyTavPlanVProgramaController {

    private final IServiceUzyTavPlanVPrograma serviceUzyTavPlanVPrograma;

    public UzyTavPlanVProgramaController(IServiceUzyTavPlanVPrograma serviceUzyTavPlanVPrograma) {
        this.serviceUzyTavPlanVPrograma = serviceUzyTavPlanVPrograma;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavPlanVPrograma> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavPlanVPrograma.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavPlanVPrograma>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavPlanVPrograma.ListarRegistros(), HttpStatus.OK);
    }


    @GetMapping("/obtenerRegistrosPorProgramaID/{programaId}")
    public ResponseEntity<List<DtoUzyTavPlanVPrograma>> obtenerRegistrosPorProgramaID(@PathVariable Long programaId) {
        return new ResponseEntity<>(serviceUzyTavPlanVPrograma.obtenerRegistrosPorProgramaID(programaId), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavPlanVPrograma> guardar(@Valid @RequestBody DtoUzyTavPlanVPrograma dtoUzyTavPlanVPrograma) {
        DtoUzyTavPlanVPrograma savedDto = serviceUzyTavPlanVPrograma.guardar(dtoUzyTavPlanVPrograma);
        return ResponseEntity.ok(savedDto);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavPlanVPrograma> editar(@PathVariable Long id, @RequestBody DtoUzyTavPlanVPrograma dtoUzyTavPlanVPrograma) {
        return new ResponseEntity<>(serviceUzyTavPlanVPrograma.editar(id, dtoUzyTavPlanVPrograma), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavPlanVPrograma.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
