package ec.edu.espe.movilidad.MovilidadWS.Controller;

import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPobla;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPobla.IServiceUzyTavPobla;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/pobla")
public class UzyTavPoblaController {

    private final  IServiceUzyTavPobla serviceUzyTavPobla;

    public UzyTavPoblaController(IServiceUzyTavPobla serviceUzyTavPobla) {
        this.serviceUzyTavPobla = serviceUzyTavPobla;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavPobla> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavPobla.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavPobla>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavPobla.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavPobla> guardar(@Valid @RequestBody DtoUzyTavPobla dtoUzyTavPobla) {
        DtoUzyTavPobla savedDto = serviceUzyTavPobla.guardar(dtoUzyTavPobla);
        return ResponseEntity.ok(savedDto);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavPobla> editar(@PathVariable Long id, @RequestBody DtoUzyTavPobla dtoUzyTavPobla) {
        return new  ResponseEntity<>(serviceUzyTavPobla.editar(id, dtoUzyTavPobla), HttpStatus.OK);
    }




}