package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_Eplanv;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPrograma_Eplanv.IServiceUzyTavPrograma_Eplanv;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/programaeplanv")
public class UzyTavPrograma_EplanvController {

    private final IServiceUzyTavPrograma_Eplanv serviceUzyTavProgramaEplanv;

    public UzyTavPrograma_EplanvController(IServiceUzyTavPrograma_Eplanv serviceUzyTavProgramaEplanv) {
        this.serviceUzyTavProgramaEplanv = serviceUzyTavProgramaEplanv;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavPrograma_Eplanv> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavProgramaEplanv.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavPrograma_Eplanv>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavProgramaEplanv.ListarRegistros(), HttpStatus.OK);
    }
    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavPrograma_Eplanv> guardar(@Valid @RequestBody DtoUzyTavPrograma_Eplanv dtoUzyTavProgramaEplanv) {
        DtoUzyTavPrograma_Eplanv savedDto = serviceUzyTavProgramaEplanv.guardar(dtoUzyTavProgramaEplanv);
        return ResponseEntity.ok(savedDto);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavPrograma_Eplanv> editar(@PathVariable Long id, @RequestBody DtoUzyTavPrograma_Eplanv dtoUzyTavProgramaEplanv) {
        return new  ResponseEntity<>(serviceUzyTavProgramaEplanv.editar(id, dtoUzyTavProgramaEplanv), HttpStatus.OK);
    }



    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavProgramaEplanv.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
