package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPrograma_V.IServiceUzyTavPrograma_V;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/programav")
public class UzyTavPrograma_VController {

    private final IServiceUzyTavPrograma_V serviceUzyTavProgramaV;

    @Autowired
    public UzyTavPrograma_VController(IServiceUzyTavPrograma_V serviceUzyTavProgramaV) {
        this.serviceUzyTavProgramaV = serviceUzyTavProgramaV;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavPrograma_V> ListarPorID(@PathVariable Long id) {
        try {
            DtoUzyTavPrograma_V dto = serviceUzyTavProgramaV.ListarPorID(id);
            return ResponseEntity.ok(dto);
        } catch (ResourceNotFoundException e) {
            return ResponseEntity.notFound().build();
        }
    }



    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavPrograma_V>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavProgramaV.ListarRegistros(), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavPrograma_V> guardar(@RequestBody DtoUzyTavPrograma_V dtoUzyTavProgramaV) {
        DtoUzyTavPrograma_V savedDto = serviceUzyTavProgramaV.guardar(dtoUzyTavProgramaV);


        return ResponseEntity.ok(savedDto);
    }

    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavPrograma_V> editar(@PathVariable Long id, @RequestBody DtoUzyTavPrograma_V dtoUzyTavProgramaV) {
        return new ResponseEntity<>(serviceUzyTavProgramaV.editar(id, dtoUzyTavProgramaV), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavProgramaV.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
