package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoSubLineaLinea;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavProlin;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavProlin.IServiceUzyTavProlin;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/prolin")
public class UzyTavProlinController {

    @Autowired
    private IServiceUzyTavProlin serviceUzyTavProlin;


    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavProlin> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavProlin.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavProlin>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavProlin.ListarRegistros(), HttpStatus.OK);
    }

    @GetMapping("/obtenerRegistrosPorSubLinea/{sublineaID}")
    public ResponseEntity<List<DtoUzyTavProlin>> obtenerRegistrosPorSubLinea(@PathVariable Long sublineaID) {
        return new ResponseEntity<>(serviceUzyTavProlin.obtenerRegistrosPorSubLinea(sublineaID), HttpStatus.OK);
    }

    @GetMapping("/obtenerRegistrosPorProyecto/{proyecID}")
    public ResponseEntity<List<DtoUzyTavProlin>> obtenerTavProlinPorProyecID(@PathVariable Long proyecID) {
        return new ResponseEntity<>(serviceUzyTavProlin.obtenerTavProlinPorProyecID(proyecID), HttpStatus.OK);
    }


    @GetMapping("/obtenerSubLineaLinea/{proyecID}")
    public ResponseEntity<List<DtoSubLineaLinea>> obtenerSubLineaLinea(@PathVariable Long proyecID) {
        return new ResponseEntity<>(serviceUzyTavProlin.obtenerSubLineaLinea(proyecID), HttpStatus.OK);
    }

    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavProlin> guardar(@RequestBody DtoUzyTavProlin dtoUzyTavProlin) {
        return new  ResponseEntity<>(serviceUzyTavProlin.guardar(dtoUzyTavProlin), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavProlin> editar(@PathVariable Long id, @RequestBody DtoUzyTavProlin dtoUzyTavProlin) {
        return new  ResponseEntity<>(serviceUzyTavProlin.editar(id, dtoUzyTavProlin), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavProlin.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
