package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoCabcomcaIdConparaevaID;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavProyec;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavProyec.IServiceUzyTavProyec;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/proyec")
public class UzyTavProyecController {
    private final IServiceUzyTavProyec serviceUzyTavProyec;

    public UzyTavProyecController(IServiceUzyTavProyec serviceUzyTavProyec) {
        this.serviceUzyTavProyec = serviceUzyTavProyec;
    }

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavProyec> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavProyec.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/findAllByUserIdAndRole/{userId}")
    public ResponseEntity<List<DtoUzyTavProyec>> findAllByUserIdAndRole(@PathVariable Long userId) {
        return new ResponseEntity<>(serviceUzyTavProyec.findAllByUserIdAndRole(userId), HttpStatus.OK);
    }

    @GetMapping("/findCabcomcaIdConparaevaIdByProyecId/{idProyect}")
    public ResponseEntity<List<DtoCabcomcaIdConparaevaID>> findCabcomcaIdConparaevaIdByProyecId(@PathVariable Long idProyect) {
        return new ResponseEntity<>(serviceUzyTavProyec.findCabcomcaIdConparaevaIdByProyecId(idProyect), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavProyec>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavProyec.ListarRegistros(), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavProyec> guardar(@RequestBody DtoUzyTavProyec dtoUzyTavProyec) {
        DtoUzyTavProyec creado = serviceUzyTavProyec.guardar(dtoUzyTavProyec);
        return ResponseEntity.status(HttpStatus.OK).body(creado);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavProyec> editar(@PathVariable Long id, @RequestBody DtoUzyTavProyec dtoUzyTavProyec) {
        return new ResponseEntity<>(serviceUzyTavProyec.editar(id, dtoUzyTavProyec), HttpStatus.OK);
    }

    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavProyec.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }

}
