package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavResponsableProg;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavResponsableProg.IServiceUzyTavResponsableProg;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/responsableprog")
public class UzyTavResponsableProgController {

    private final IServiceUzyTavResponsableProg serviceUzyTavResponsableProg;

    public UzyTavResponsableProgController(IServiceUzyTavResponsableProg serviceUzyTavResponsableProg) {
        this.serviceUzyTavResponsableProg = serviceUzyTavResponsableProg;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavResponsableProg ListarPorID(@PathVariable Long id) {
        return serviceUzyTavResponsableProg.ListarPorID(id);
    }

    @GetMapping("/obtenerRegistrosPorUsuarioIDandProyectID/{iddocente}/{uzytavproyec_id}")
    public List<DtoUzyTavResponsableProg> obtenerRegistrosPorUsuarioIDandProyectID(@PathVariable Long iddocente,
                                                                                    @PathVariable Long uzytavproyec_id) {
        return serviceUzyTavResponsableProg.obtenerRegistrosPorUsuarioIDandProyectID(iddocente,uzytavproyec_id );
    }

    @GetMapping("/obtenerRegistrosPorProyectID/{uzytavproyec_id}")
    public List<DtoUzyTavResponsableProg> obtenerRegistrosPorProyectID(@PathVariable Long uzytavproyec_id) {
        return serviceUzyTavResponsableProg.obtenerRegistrosPorProyectID(uzytavproyec_id );
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavResponsableProg> ListarRegistros() {
        return serviceUzyTavResponsableProg.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavResponsableProg guardar(@Valid @RequestBody DtoUzyTavResponsableProg dtoUzyTavResponsableProg) {
        return serviceUzyTavResponsableProg.guardar(dtoUzyTavResponsableProg);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavResponsableProg editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavResponsableProg dtoUzyTavResponsableProg) {
        return serviceUzyTavResponsableProg.editar(id, dtoUzyTavResponsableProg);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavResponsableProg.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
