package ec.edu.espe.movilidad.MovilidadWS.Controller;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavSeguim;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavSeguim.IServiceUzyTavSeguim;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.ResponseEntity;
import javax.validation.Valid;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION + "/seguim")
public class UzyTavSeguimController {
    private final IServiceUzyTavSeguim serviceUzyTavSeguim;

    public UzyTavSeguimController(IServiceUzyTavSeguim serviceUzyTavSeguim) {
        this.serviceUzyTavSeguim = serviceUzyTavSeguim;
    }

    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavSeguim ListarPorID(@PathVariable Long id) {
        return serviceUzyTavSeguim.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavSeguim> ListarRegistros() {
        return serviceUzyTavSeguim.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavSeguim guardar(@Valid @RequestBody DtoUzyTavSeguim dtoUzyTavSeguim) {
        return serviceUzyTavSeguim.guardar(dtoUzyTavSeguim);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavSeguim editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavSeguim dtoUzyTavSeguim) {
        return serviceUzyTavSeguim.editar(id, dtoUzyTavSeguim);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavSeguim.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
