package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavSubLinea;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavSubLinea.IServiceUzyTavSubLinea;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/sublinea")
public class UzyTavSubLineaController {

    @Autowired
    private IServiceUzyTavSubLinea serviceUzyTavSubLinea;

    @GetMapping("/exampleFindId/{id}")
    public ResponseEntity<DtoUzyTavSubLinea> ListarPorID(@PathVariable Long id) {
        return new ResponseEntity<>(serviceUzyTavSubLinea.ListarPorID(id), HttpStatus.OK);
    }

    @GetMapping("/getAll")
    public ResponseEntity<List<DtoUzyTavSubLinea>> ListarRegistros() {
        return new ResponseEntity<>(serviceUzyTavSubLinea.ListarRegistros(), HttpStatus.OK);
    }


    @GetMapping("/obtenerRegistrosPorLinea/{lineaID}")
    public ResponseEntity<List<DtoUzyTavSubLinea>> obtenerRegistrosPorLinea(@PathVariable Long lineaID) {
        return new ResponseEntity<>(serviceUzyTavSubLinea.obtenerRegistrosPorLinea(lineaID), HttpStatus.OK);
    }


    @PostMapping("/guardar")
    public ResponseEntity<DtoUzyTavSubLinea> guardar(@RequestBody DtoUzyTavSubLinea dtoUzyTavSubLinea) {
        return new  ResponseEntity<>(serviceUzyTavSubLinea.guardar(dtoUzyTavSubLinea), HttpStatus.OK);
    }


    @PutMapping("/editar/{id}")
    public ResponseEntity<DtoUzyTavSubLinea> editar(@PathVariable Long id, @RequestBody DtoUzyTavSubLinea dtoUzyTavSubLinea) {
        return new  ResponseEntity<>(serviceUzyTavSubLinea.editar(id, dtoUzyTavSubLinea), HttpStatus.OK);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id){
        boolean eliminado = serviceUzyTavSubLinea.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
