package ec.edu.espe.movilidad.MovilidadWS.Controller;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavTipres;
import ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavTipres.IServiceUzyTavTipres;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

import java.util.List;

import static ec.edu.espe.movilidad.MovilidadWS.Constant.GlobalConstants.V1_API_VERSION;

@RestController
@CrossOrigin(origins = "http://localhost:4200")
@RequestMapping(V1_API_VERSION+"/tavtipres")
public class UzyTavTipresController {
    private final IServiceUzyTavTipres serviceUzyTavTipres;

    public UzyTavTipresController(IServiceUzyTavTipres serviceUzyTavTipres) {
        this.serviceUzyTavTipres = serviceUzyTavTipres;
    }
    @GetMapping("/exampleFindId/{id}")
    public DtoUzyTavTipres ListarPorID(@PathVariable Long id) {
        return serviceUzyTavTipres.ListarPorID(id);
    }

    @GetMapping("/getAll")
    public List<DtoUzyTavTipres> ListarRegistros() {
        return serviceUzyTavTipres.ListarRegistros();
    }

    @PostMapping("/guardar")
    public DtoUzyTavTipres guardar(@Valid @RequestBody DtoUzyTavTipres dtoUzyTavTipres) {
        return serviceUzyTavTipres.guardar(dtoUzyTavTipres);
    }


    @PutMapping("/editar/{id}")
    public DtoUzyTavTipres editar(@PathVariable Long id, @Valid @RequestBody DtoUzyTavTipres dtoUzyTavTipres) {
        return serviceUzyTavTipres.editar(id, dtoUzyTavTipres);
    }


    @DeleteMapping("/eliminar/{id}")
    public ResponseEntity<String> eliminar(@PathVariable Long id) {
        boolean eliminado = serviceUzyTavTipres.eliminar(id);
        if (eliminado) {
            return ResponseEntity.ok("El registro se eliminó exitosamente.");
        } else {
            return ResponseEntity.notFound().build();
        }
    }
}
