package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTPerfil;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTUsuario;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Set;

@Repository
public interface DaoUzyTUsuario extends JpaRepository<ModelUzyTUsuario, Long> {


    @Query("SELECT u FROM ModelUzyTUsuario u WHERE LOWER(u.uzytusuario_nombres) LIKE CONCAT('%', LOWER(:usuario), '%') OR LOWER(u.uzytusuario_apellidos) LIKE CONCAT('%', LOWER(:usuario), '%')")
    List<ModelUzyTUsuario> findByUsuario(@Param("usuario") String usuario);


    @Query("SELECT u FROM ModelUzyTUsuario u WHERE u.uzytusuario_email_institucional = :email")
    ModelUzyTUsuario findByEmail(@Param("email") String email);


    @Query("SELECT u.uzytperfils FROM ModelUzyTUsuario u WHERE u.uzytusuario_id = :uzytusuario_id")
    Set<ModelUzyTPerfil> findPerfilesByUsuarioId(@Param("uzytusuario_id") Long uzytusuario_id);

    @Query("SELECT u.uzytperfils FROM ModelUzyTUsuario u WHERE u.uzytusuario_email_institucional = :email")
    Set<ModelUzyTPerfil> findPerfilesByUsuarioEmail(@Param("email") String email);

    @Query("SELECT u FROM ModelUzyTUsuario u ORDER BY u.uzytusuario_id DESC")
    List<ModelUzyTUsuario> findAll();

    @Query("SELECT u FROM ModelUzyTUsuario u JOIN u.uzytperfils p " +
            "WHERE p.uzytperfil_nombre = 'Administrador del Sistema' AND u.uzytusuario_email_institucional = :email")
    ModelUzyTUsuario findByEmailPerfilAdmin(@Param("email") String email);
}
