package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoClaspreClassPresupNombre;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavClasPre;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavClasPre extends JpaRepository<ModelUzyTavClasPre, Long> {


    @Query("SELECT c FROM ModelUzyTavClasPre c WHERE c.uzytclasificador_presup.uzytclasificador_presup_id = :presupID")
    List<ModelUzyTavClasPre> obtenerClasificadorPresup(@Param("presupID") Long presupID);


    @Query("SELECT new ec.edu.espe.movilidad.MovilidadWS.Dto.DtoClaspreClassPresupNombre(c.uzytavclaspre_id, c.uzytclasificador_presup.uzytclasificador_presup_id, c.uzytclasificador_presup.uzytclasificador_presup_nombre) FROM ModelUzyTavClasPre c " +
            "INNER JOIN c.uzytclasificador_presup p " +
            "ON p.uzytclasificador_presup_id = c.uzytclasificador_presup.uzytclasificador_presup_id")
    List<DtoClaspreClassPresupNombre> obtenerTodosClasificadorPresupNombre();


    @Query("SELECT new ec.edu.espe.movilidad.MovilidadWS.Dto.DtoClaspreClassPresupNombre(c.uzytavclaspre_id, c.uzytclasificador_presup.uzytclasificador_presup_id, c.uzytclasificador_presup.uzytclasificador_presup_nombre) FROM ModelUzyTavClasPre c " +
            "INNER JOIN c.uzytclasificador_presup p " +
            "ON p.uzytclasificador_presup_id = c.uzytclasificador_presup.uzytclasificador_presup_id " +
            "WHERE c.uzytavclaspre_id= :claspreID")
    List<DtoClaspreClassPresupNombre> obtenerClasificadorPresupNombre(@Param("claspreID") Long claspreID);

    @Query("SELECT cp FROM ModelUzyTavClasPre cp ORDER BY cp.uzytavclaspre_id DESC")
    List<ModelUzyTavClasPre> findAll();

}
