package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoConParaevaParaEvaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConparaEva;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface DaoUzyTavConparaEva extends JpaRepository<ModelUzyTavConparaEva, Long> {


    @Query(value = "SELECT a FROM ModelUzyTavConparaEva a WHERE a.uzytavconparaeva_tipo = 1 ")
    Optional<List<ModelUzyTavConparaEva>> findAllEnable();



    @Query(value = "SELECT i FROM ModelUzyTavConparaEva i WHERE i.uzytavconparaeva_tipo = 2 ")
    Optional<List<ModelUzyTavConparaEva>> noActivo();

    //Obtener todos los datos relacionados con la tabla TavParaeva
    @Query("SELECT c, p FROM ModelUzyTavConparaEva c INNER JOIN c.uzytavparaevaSet p")
    List<ModelUzyTavConparaEva> getAllDatosRelacionadosTavParaeva();

    //Obtener los datos relacionados con la tava TavParaeva mediante un ID
    @Query("SELECT c, p FROM ModelUzyTavConparaEva c INNER JOIN c.uzytavparaevaSet p WHERE c.uzytavconparaeva_id = :id")
    List<ModelUzyTavConparaEva> findByIdDatosRelacionadosTavParaeva(@Param("id") Long id);


    @Query("SELECT new ec.edu.espe.movilidad.MovilidadWS.Dto.DtoConParaevaParaEvaValorPar(" +
            "c.uzytavconparaeva_id, " +
            "c.uzytavconparaeva_descrip, " +
            "p.uzytavparaeva_descrip, " +
            "v.uzytavalorpar_descrip, " +
            "v.uzytavalorpar_puntaje) " +
            "FROM ModelUzyTavConparaEva c " +
            "LEFT JOIN c.uzytavparaevaSet p " +
            "LEFT JOIN p.uzyTaValorParSet v WHERE  c.uzytavconparaeva_id = :conparaevaID")
    List<DtoConParaevaParaEvaValorPar> findByIdDatosRelacionadosConParaevaParaEvaValorPar(@Param("conparaevaID") Long conparaevaID);


    @Query("SELECT c FROM ModelUzyTavConparaEva c ORDER BY c.uzytavconparaeva_id DESC")
    List<ModelUzyTavConparaEva> findAll();
}
