package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivosEstraInsti;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavObjetivosEstraInsti extends JpaRepository<ModelUzyTavObjetivosEstraInsti, Long> {

    //Obtener los datos relacionados ordeados
    @Query("SELECT c FROM ModelUzyTavObjetivosEstraInsti c WHERE c.uzyTavObjetivosEstraInstiPadre IS NULL AND c.UZYTTIPESTR_CODE = 1")
    List<ModelUzyTavObjetivosEstraInsti> obtenerEstraInstiPadre();

    //Obtener los registros por el ID del padre
    @Query("SELECT c FROM ModelUzyTavObjetivosEstraInsti c WHERE c.uzyTavObjetivosEstraInstiPadre.UZYTAVOBJETIVOS_ESTRA_INSTI_ID = :padreId")
    List<ModelUzyTavObjetivosEstraInsti> obtenerPorPadreId(@Param("padreId") Long padreId);

    @Query("SELECT c FROM ModelUzyTavObjetivosEstraInsti c ORDER BY c.UZYTAVOBJETIVOS_ESTRA_INSTI_ID DESC")
    List<ModelUzyTavObjetivosEstraInsti> findAll();

}
