package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavParaEva;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;
import java.util.List;

@Repository
public interface DaoUzyTavParaEva extends JpaRepository<ModelUzyTavParaEva, Long> {
    // CONSULTA PARA OBTENER LOS VALORES RELACIONADOS

    //Obtener todos los datos relacionados con la tabla ConParaEva
    @Query("SELECT p, c FROM ModelUzyTavParaEva p INNER JOIN p.uzytavconparaeva c")
    List<ModelUzyTavParaEva> getAllDatosConParaEva();


    //Obtener los datos relacionados con la tabla ConParaEva mediante un id, además que tengan tipo 1= Parametros de evaluacion inicial
    @Query("SELECT p FROM ModelUzyTavParaEva p INNER JOIN p.uzytavconparaeva c WHERE c.uzytavconparaeva_id = :id AND c.uzytavconparaeva_tipo = 1")
    List<ModelUzyTavParaEva> findByIdDatosConParaEvaTipo1(@Param("id") Long id);



    //Obtener los datos relacionados con la tabla ConParaEva mediante un id, además que tengan tipo 2= Parametros de evaluacion final
    @Query("SELECT p FROM ModelUzyTavParaEva p INNER JOIN p.uzytavconparaeva c WHERE c.uzytavconparaeva_id = :id AND c.uzytavconparaeva_tipo = 2")
    List<ModelUzyTavParaEva> findByIdDatosConParaEvaTipo2(@Param("id") Long id);


    // obtener solo los valores de la tabla UZYTAVPARAEVA mediante la relación del campo UZYTAVCABPARAEVAF_ID de la tabla UZYTAVPARAEVA


    @Query("SELECT p FROM ModelUzyTavParaEva p WHERE p.uzytavcabparaevaf_id = :id")
    List<ModelUzyTavParaEva> findByDatosUzytavcabparaevafId(@Param("id") Long id);

    @Query("SELECT p FROM ModelUzyTavParaEva p ORDER BY p.uzytavparaeva_id DESC")
    List<ModelUzyTavParaEva> findAll();
}
