package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPresup;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavPresup extends JpaRepository<ModelUzyTavPresup, Long> {

    @Query("SELECT tp FROM ModelUzyTavPresup tp JOIN tp.uzytavproyec p WHERE p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavPresup> obtenerTavPresupPorProyecID(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavPresup tp JOIN tp.uzytavproyec p WHERE tp.uzytavpresup_tipo = 1 AND p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavPresup> obtenerTavPresupPorProyecIDandTipo1(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavPresup tp JOIN tp.uzytavproyec p WHERE tp.uzytavpresup_tipo  = 2 AND p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavPresup> obtenerTavPresupPorProyecIDandTipo2(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavPresup tp JOIN tp.uzytavproyec p WHERE tp.uzytavpresup_tipo  = 3 AND p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavPresup> obtenerTavPresupPorProyecIDandTipo3(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavPresup tp ORDER BY tp.uzytavpresup_id DESC")
    List<ModelUzyTavPresup> findAll();
}
