package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProgObj;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavProgObj extends JpaRepository<ModelUzyTavProgObj, Long> {

    @Query("SELECT tp FROM ModelUzyTavProgObj tp JOIN tp.uzytavprograma_v p WHERE p.uzytavprograma_v_id = :programaId")
    List<ModelUzyTavProgObj> obtenerTavProgObjPorPrograma(@Param("programaId") Long programaId);


    @Query("SELECT tp FROM ModelUzyTavProgObj tp JOIN tp.uzytavproyec py WHERE py.uzytavproyec_id = :proyectoID")
    List<ModelUzyTavProgObj> obtenerTavProgObjPorProyecto(@Param("proyectoID") Long proyectoID);

    @Query("SELECT tp FROM ModelUzyTavProgObj tp ORDER BY tp.uzytavprog_obj_code DESC")
    List<ModelUzyTavProgObj> findAll();
}
