package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoSubLineaLinea;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProlin;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavProlin extends JpaRepository<ModelUzyTavProlin, Long> {

    @Query("SELECT pl FROM ModelUzyTavProlin pl JOIN pl.UZYTAVSUBLINEA sb WHERE sb.uzytavsublinea_ID = :sublineaID")
    List<ModelUzyTavProlin> obtenerRegistrosPorSubLinea(@Param("sublineaID") Long sublineaID);

    @Query("SELECT new ec.edu.espe.movilidad.MovilidadWS.Dto.DtoSubLineaLinea(p.uzytavprolin_ID, p.UZYTAVSUBLINEA.uzytavsublinea_ID, " +
            "p.uzytavproyec.uzytavproyec_id, p.UZYTAVSUBLINEA.uzytavsublinea_DESCRIPCION, " +
            "p.UZYTAVSUBLINEA.UZYTAVLINEA.uzytavlinea_ID, " +
            "p.UZYTAVSUBLINEA.uzytavlinea_UNESCO," +
            "p.UZYTAVSUBLINEA.UZYTAVLINEA.uzytavlinea_DESCRIPCION) " +
            "FROM ModelUzyTavProlin p " +
            "WHERE p.uzytavproyec.uzytavproyec_id = :proyecID")
    List<DtoSubLineaLinea> obtenerSubLineaLinea(@Param("proyecID") Long proyecID);


    @Query("SELECT pl FROM ModelUzyTavProlin pl JOIN pl.uzytavproyec p WHERE p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavProlin> obtenerTavProlinPorProyecID(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavProlin tp ORDER BY tp.uzytavprolin_ID DESC")
    List<ModelUzyTavProlin> findAll();
}
