package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoCabcomcaIdConparaevaID;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavProyec extends JpaRepository<ModelUzyTavProyec, Long> {

    @Query("SELECT NEW ec.edu.espe.movilidad.MovilidadWS.Dto.DtoCabcomcaIdConparaevaID(p.uzytavcabcomca.uzytavcabcomca_id, p.uzytavconparaeva.uzytavconparaeva_id) " +
            "FROM ModelUzyTavProyec p " +
            "WHERE p.uzytavproyec_id = :idProyect")
    List<DtoCabcomcaIdConparaevaID> findCabcomcaIdConparaevaIdByProyecId(@Param("idProyect") Long idProyect);
    @Query("SELECT p FROM ModelUzyTavProyec p ORDER BY p.uzytavproyec_id DESC")
    List<ModelUzyTavProyec> findAll();

    @Query("SELECT p FROM ModelUzyTavProyec p " +
            "JOIN p.uzytusuario ur " +
            "JOIN ur.uzytperfils perfil " +
            "WHERE (:userId is null OR p.uzytusuario.uzytusuario_id = :userId) " +
            "AND (perfil.uzytperfil_nombre = 'Director de Proyecto' OR :userId is null)")
    List<ModelUzyTavProyec> findAllByUserIdAndRole(@Param("userId") Long userId);

}
