package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavResponsableProg;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavResponsableProg extends JpaRepository<ModelUzyTavResponsableProg, Long> {
    @Query("SELECT rp FROM ModelUzyTavResponsableProg rp " +
            "JOIN rp.iddocente u" +
            " JOIN rp.uzytavproyec p" +
            " WHERE u.uzytusuario_id = :iddocente " +
            "AND p.uzytavproyec_id = :uzytavproyec_id")
    List<ModelUzyTavResponsableProg> obtenerRegistrosPorUsuarioIDandProyectID (@Param("iddocente") Long iddocente, @Param("uzytavproyec_id") Long uzytavproyec_id);
    @Query("SELECT rp FROM ModelUzyTavResponsableProg rp " +
            " JOIN rp.uzytavproyec p" +
            " WHERE p.uzytavproyec_id = :uzytavproyec_id")
    List<ModelUzyTavResponsableProg> obtenerRegistrosPorProyectID (@Param("uzytavproyec_id") Long uzytavproyec_id);
}