package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavZonaDetalle;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzyTavZonaDetalle extends JpaRepository<ModelUzyTavZonaDetalle, Long> {

    @Query("SELECT zd FROM ModelUzyTavZonaDetalle zd JOIN zd.uzytavprograma_v p WHERE p.uzytavprograma_v_id = :programaId")
    List<ModelUzyTavZonaDetalle> obtenerZonaDetallePorPrograma(@Param("programaId") Long programaId);

    @Query("SELECT zd FROM ModelUzyTavZonaDetalle zd JOIN zd.uzytavproyec p WHERE p.uzytavproyec_id = :proyecID")
    List<ModelUzyTavZonaDetalle> obtenerZonaDetallePorProyec(@Param("proyecID") Long proyecID);

    @Query("SELECT tp FROM ModelUzyTavZonaDetalle tp ORDER BY tp.uzytavzona_detalle_id DESC")
    List<ModelUzyTavZonaDetalle> findAll();
}
