package ec.edu.espe.movilidad.MovilidadWS.Dao;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzytavObjetivoPrograma;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface DaoUzytavObjetivoPrograma extends JpaRepository<ModelUzytavObjetivoPrograma, Long> {
    @Query("SELECT tp FROM ModelUzytavObjetivoPrograma tp JOIN tp.uzytavprograma_v p WHERE p.uzytavprograma_v_id = :programaId")
    List<ModelUzytavObjetivoPrograma> obtenerObjetivoprogramaPorPrograma(@Param("programaId") Long programaId);


    @Query("SELECT tp FROM ModelUzytavObjetivoPrograma tp JOIN tp.uzytavproyec p WHERE p.uzytavproyec_id = :proyectID")
    List<ModelUzytavObjetivoPrograma> obtenerObjetivoprogramaPorProyecto(@Param("proyectID") Long proyectID);


    @Query("SELECT op FROM ModelUzytavObjetivoPrograma op ORDER BY op.uzytavobjetivo_programa_id DESC")
    List<ModelUzytavObjetivoPrograma> findAll();
}
