package ec.edu.espe.movilidad.MovilidadWS.Dto;

import lombok.Data;

import javax.validation.constraints.*;
import java.time.LocalDate;
import java.util.Set;

@Data
public class DtoUzyTUsuario {

    @Positive(message = "El campo uzytusuario_id debe ser un número positivo")
    private Long uzytusuario_id;
    @Size(max = 20)
    private String uzytusuario_cc;
    @Size(max = 100)
    private String uzytusuario_clave;
    @Size(max = 60)

    private String uzytusuario_nombres;
    @NotNull(message = "El campo de uzytusuario_apellidos no puede ser nulo")
    @Size(max = 60)
    private String uzytusuario_apellidos;
    @Email(message = "El campo 'uzytusuario_email' debe ser una dirección de correo electrónico válida: usuario@example.com")
    @Size(max = 100)
    private String uzytusuario_email;
    @PastOrPresent(message = "La fecha de registro debe ser anterior o igual a la fecha actual")
    //PastOrPresent PASADO O PRESENTE EN EL INGRESO DE LAS FECHAS
    private LocalDate uzytusuario_fecharegistro; //LocalDate Se guarda la fecha sin el tiempo
    @Size(max = 1)
    @Pattern(regexp = "[AI]", message = "El campo uzytusuario_estado solo puede ser A=Activo; I= Inactivo")
    private String uzytusuario_estado;
    private Integer uzytusuario_mail_sinformul;
    private Integer uzytusuario_mail_incompletos;
    @Size(max = 30)
    private String uzytusuario_tipo_doc;
    @Size(max = 30)
    private String uzytusuario_cod_senescyt;
    @PastOrPresent(message = "La fecha de registro debe ser anterior o igual a la fecha actual")
    //PastOrPresent PASADO O PRESENTE EN EL INGRESO DE LAS FECHAS
    private LocalDate uzytusuario_fecha_act_micuenta;
    @Size(max = 6)
    private String uzytusuario_hexadecimalid;
    @Size(max = 25)
    private String uzytusuario_tratamiento;
    private Integer uzytusuario_modificacion;
    @Size(max = 1)
    @Pattern(regexp = "[ADCE]", message = "El campo uzytusuario_tipo_user solo puede ser A=Aspirante; D=Docente de Nivelación; C=Coordinador Logístico; E=Evaluadores")
    private String uzytusuario_tipo_user;
    @Email(message = "El campo 'uzytusuario_email' debe ser una dirección de correo electrónico válida: usuario@espe.edu.ec")
    @Size(max = 100)
    private String uzytusuario_email_institucional;
    @Size(max = 10)
    private String uzytusuario_telefono_fijo;
    @Size(max = 10)
    private String uzytusuario_telefono_celular;
    @Size(max = 9)
    private String spriden_id;
    @Positive
    private Integer spriden_pidm;
    @Size(max = 200)
    private String uzytusuario_clave_tmp;
    @Size(max = 20)
    private String spbpers_name_prefix;
    @Size(max = 1, message = "El campo spbpers_sex debe tener exactamente un carácter")
    @Pattern(regexp = "[MF]", message = "El campo spbpers_sex solo puede ser 'M' para Masculino o 'F' para Femenino")
    private String spbpers_sex;
    @Size(max = 40)
    private String uzytusuario_campus;
    @Size(max = 20)
    private String uzytusuario_departamento;
    @Size(max = 250)
    private String uzytusuario_foto;
    @Size(max = 3)
    private String uzytusuario_CAMPUS_CODE;
    @Size(max = 4)
    private String uzytusuario_DEPARTAMENTO_CODE;

    @Size(max = 2)
    private String uzytusuario_CAMPUS_ABREV_CODE;
    @Size(max = 2)
    private String uzytusuario_DPTO_ABREV_CODE;

    private Set<DtoUzyTPerfil> uzytperfils;

}
