package ec.edu.espe.movilidad.MovilidadWS.Dto;

import lombok.Data;

import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.Positive;
import javax.validation.constraints.Size;
import java.math.BigDecimal;
import java.time.LocalDate;

@Data
public class DtoUzyTavActivProg {
    @Positive(message = "El campo UZYTAVACTIVPROG_ID debe ser un número positivo")
    private Long uzytavactivprog_id;
    @Positive(message = "El campo UZYTAVPROGRAMA_V_ID debe ser un número positivo")
    private Long uzytavprograma_v_id;
    @Positive(message = "El campo UZYTAVPROYEC_ID debe ser un número positivo")
    private Long uzytavproyec_id;

    @Size(max = 500)
    private String uzytavactivprog_descripcion;
    private LocalDate uzytavactivprog_fecha_ini;
    private LocalDate uzytavactivprog_fecha_fin;

    @DecimalMin(value = "0.01", message = "El presupuesto debe ser mayor o igual a 0.01")
    @DecimalMax(value = "999999.99", message = "El presupuesto no puede ser mayor a 999999.99")
    private BigDecimal uzytavactivprog_presupuesto;
    private Integer uzytavactivprog_beneficiarios;
    private Long uzytavactivprog_anio;
    @DecimalMin(value = "0.01", message = "El presupuesto debe ser mayor o igual a 0.01")
    @DecimalMax(value = "999999.99", message = "El presupuesto no puede ser mayor a 999999.99")
    private BigDecimal uzytavactivprog_presupuesto2;
}
