package ec.edu.espe.movilidad.MovilidadWS.Dto;

import lombok.Data;


import javax.validation.constraints.*;
import java.util.Date;

@Data
public class DtoUzyTavProyec {
    @Positive(message = "El campo uzytavproyec_id debe ser un número positivo")
    private Long uzytavproyec_id;
    @Positive(message = "El campo uzytavprograma_v_id debe ser un número positivo")
    private Long uzytavprograma_v_id;
    @Size(max = 500)
    private String uzytavproyec_nombre;
    @Positive(message = "El campo uzytavproyec_aporuni debe ser un número positivo")
    private Integer uzytavproyec_aporuni;
    @Positive(message = "El campo uzytavproyec_aporuni_valor debe ser un número positivo")
    private Integer uzytavproyec_aporuni_valor;
    @Positive(message = "El campo uzytavproyec_entiaupi debe ser un número positivo")
    private Integer uzytavproyec_entiaupi;
    @Positive(message = "El campo uzytavproyec_contraparte debe ser un número positivo")
    private Integer uzytavproyec_contraparte;
    private Date uzytavproyec_fecha_presenta;
    private Date uzytavproyec_fecha_inicio;
    private Date uzytavproyec_fecha_finaliza;
    @Size(max = 3000)
    private String uzytavproyec_bienes;
    @Size(max = 3000)
    private String uzytavproyec_servicios;
    @Size(max = 3000)
    private String uzytavproyec_bien_servicio;
    @Size(max = 3000)
    private String uzytavproyec_situactual;
    @Size(max = 3000)
    private String uzytavproyec_diagnostico;
    @Size(max = 3000)
    private String uzytavproyec_lineabase;
    @Positive(message = "El campo uzytavproyec_directos_hombres debe ser un número positivo")
    private Integer uzytavproyec_directos_hombres;
    @Positive(message = "El campo uzytavproyec_directos_mujeres debe ser un número positivo")
    private Integer uzytavproyec_directos_mujeres;
    @Positive(message = "El campo uzytavproyec_directos_discapac debe ser un número positivo")
    private Integer uzytavproyec_directos_discapac;
    @Positive(message = "El campo uzytavproyec_inidirectos_hombres debe ser un número positivo")
    private Integer uzytavproyec_inidirectos_hombres;
    @Positive(message = "El campo uzytavproyec_inidirectos_mujeres debe ser un número positivo")
    private Integer uzytavproyec_inidirectos_mujeres;
    @Size(max = 3000)
    private String uzytavproyec_factoresc;
    @Size(max = 3000)
    private String uzytavproyec_restriccion;
    @Size(max = 3000)
    private String uzytavproyec_viabilidad;
    @Size(max = 3000)
    private String uzytavproyec_perderia;
    @Size(max = 3000)
    private String uzytavproyec_resultados;
    @Size(max = 3000)
    private String uzytavproyec_impacto;
    @Size(max = 3000)
    private String uzytavproyec_sostenibilidad;
    @Positive(message = "El campo uzytavproyec_inidirectos_discapa debe ser un número positivo")
    private Integer uzytavproyec_inidirectos_discapa;
    @Size(max = 1)
    @Pattern(regexp = "[CI]", message = "El campo uzytavproyec_tipo_proy solo puede ser Gasto Corriente =C, Fondos de Inversión =I")
    private String uzytavproyec_tipo_proy;
    @Size(max = 4)
    private String stvsubj_code;
    @Size(max = 20)
    private String uzytavproyec_codigo;
    @Positive(message = "El campo uzytavconvoca_id debe ser un número positivo")
    private Long uzytavconvoca_id;
    @Size(max = 100)
    private String uzytavproyec_aprob_con_dep_nom;
    @Size(max = 250)
    private String uzytavproyec_aprob_con_dep_url;
    @Size(max = 5)
    private String uzytavproyec_estado;
    @Positive(message = "El campo uzytavcabcomca_id debe ser un número positivo")
    private Long uzytavcabcomca_id;
    @Positive(message = "El campo uzytavconparaeva_id debe ser un número positivo")
    private Long uzytavconparaeva_id;
    private Date uzytavproyec_fecha_c;
    @Size(max = 100)
    private String uzytavproyec_nombre_pdf_acta;
    @Size(max = 250)
    private String uzytavproyec_url_pdf_acta;
    @Size(max = 250)
    private String uzytavproyec_observacio_c;
    @Size(max = 1000)
    private String uzytavproyec_mensaje_correo;
    @Size(max = 500)
    private String uzytavproyec_asunto_correo;
    @Size(max = 100)
    @Email(message = "El campo 'uzytavproyec_direccion_correo' debe ser una dirección de correo electrónico válida: usuario@example.com")
    private String uzytavproyec_direccion_correo;
    @Positive(message = "El campo uzytavproyec_directos_ejec debe ser un número positivo")
    private Integer uzytavproyec_directos_ejec;
    private String uzytavproyec_situactual2;
    private String uzytavproyec_diagnostico2;
    @Size(max = 100)
    private String uzytavproyec_nombre_pdf_memo;
    @Size(max = 250)
    private String uzytavproyec_url_pdf_memo;
    @Size(max = 1)
    @Pattern(regexp = "[SI]", message = "El campo uzytavconparaeva_adjunto_acta solo puede ser S=Si, N=No")
    private String uzytavconparaeva_adjunto_acta;
    @Size(max = 1)
    @Pattern(regexp = "[SI]", message = "El campo uzytavconparaeva_adjunto_memo solo puede ser S=Si, N=No")
    private String uzytavconparaeva_adjunto_memo;
    @Positive(message = "El campo uzytavproyec_cobertura debe ser un número positivo")
    @Min(value = 1, message = "El campo uzytavproyec_cobertura solo puede ser 1=Nacional, 2=Provincial, 3=Cantonal, 4=Parroquial")
    @Max(value = 4, message = "El campo uzytavproyec_cobertura solo puede ser 1=Nacional, 2=Provincial, 3=Cantonal, 4=Parroquial")
    private Integer uzytavproyec_cobertura;
    @Positive(message = "El campo uzytavproyec_directos_ninios debe ser un número positivo")
    private Integer uzytavproyec_directos_ninios;
    @Positive(message = "El campo uzytavproyec_indirectos_ninios debe ser un número positivo")
    private Integer uzytavproyec_indirectos_ninios;
    @Size(max = 500)
    private String uzytavproyec_cierre_prod;
    @Size(max = 500)
    private String uzytavproyec_cierre_bien;
    @Size(max = 500)
    private String uzytavproyec_cierre_resul;
    @Size(max = 500)
    private String uzytavproyec_cierre_aplic;
    @Size(max = 500)
    private String uzytavproyec_cierre_imp;
    @Size(max = 500)
    private String uzytavproyec_cierre_rest;
    @Size(max = 500)
    private String uzytavproyec_cierre_comen;
    @Positive(message = "El campo uzytavconparaevalf_code debe ser un número positivo")
    private Long uzytavconparaevalf_code;
    private Date uzytavproyec_fecha_v;
    @Size(max = 250)
    private String uzytavproyec_observacio_v;
    @Size(max = 1)
    @Pattern(regexp = "[AI]", message = "El campo uzytavproyec_estado_activo solo puede ser A=Activo; I= Inactivo")
    private String uzytavproyec_estado_activo;
    private Date uzytavproyec_fecha_cierre;
    private Date uzytavproyec_fecha_evaluacion;
    private Date uzytavproyec_fecha_mail_avance;
    private String uzytavproyec_lineabase2;
    @Positive(message = "El campo uzytavproyec_indirectos debe ser un número positivo")
    private Integer uzytavproyec_indirectos;
    @Size(max = 3)
    private String stvcamp_code;
    @Size(max = 4)
    private String stvmajr_code;
    @Size(max = 100)
    private String uzytavproyec_com_part1_nom;
    @Size(max = 250)
    private String uzytavproyec_com_part1_url;
    @Size(max = 100)
    private String uzytavproyec_com_part2_nom;
    @Size(max = 250)
    private String uzytavproyec_com_part2_url;
    private Date uzytavproyec_fecha_finp;
    @Size(max = 25)
    private String uzytavproyec_aprob_con_dep_nro;
    private Date uzytavproyec_aprob_con_dep_fec;
    @Size(max = 100)
    private String uzytavproyec_aprob_viitt_nom;
    @Size(max = 250)
    private String uzytavproyec_aprob_viitt_url;
    @Size(max = 25)
    private String uzytavproyec_aprob_viitt_nro;
    private Date uzytavproyec_aprob_viitt_fec;
    @Size(max = 25)
    private String uzytavproyec_cons_acad_nroacta;
    @Size(max = 250)
    private String uzytavproyec_carta_com_url;
    @Size(max = 100)
    private String uzytavproyec_carta_com_nom;
    private Date uzytavproyec_fecha_fin_ejec;
    private Date uzytavproyec_fecmax_correc;
    @Positive(message = "El campo uzytavproyec_secuencial debe ser un número positivo")
    private Integer uzytavproyec_secuencial;
    @Positive(message = "El campo uzytparametros_det_id debe ser un número positivo")
    private Long uzytparametros_det_id;
    @Positive(message = "El campo uzytparametros_det_id_cobertura debe ser un número positivo")
    private Long uzytparametros_det_id_cobertura;
    @Positive(message = "El campo uzytavactaprueba_id debe ser un número positivo")
    private Long uzytavactaprueba_id;
    @Size(max = 3000)
    private String uzytavproyec_efecto_esperado;
    @Positive(message = "El campo uzytavproyec_tipo debe ser un número positivo")
    private Integer uzytavproyec_tipo;
    @Size(max = 1000)
    private String uzytavproyec_descripcion_pobl;
    @Size(max = 100)
    private String uzytavproyec_com_part3_nom;
    @Size(max = 250)
    private String uzytavproyec_com_part3_url;
    @Positive(message = "El campo uzytcata_gen_id debe ser un número positivo")
    private Long uzytcata_gen_id;
    @Positive(message = "El campo uzytusuario_id debe ser un número positivo")
    private Long uzytusuario_id;

    private DtoUzyTUsuario uzytusuario;
    @Positive(message = "El campo uzytavactasperfil_PROYEC_ID debe ser un número positivo")
    private Long uzytavactasperfil_PROYEC_ID;

}
