package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTCanton;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTCanton;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTProvincia;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTCantonMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTCantonMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTCanton entityToDto(ModelUzyTCanton entity) {
        return modelMapper.map(entity, DtoUzyTCanton.class);
    }

    public ModelUzyTCanton dtoToEntity(DtoUzyTCanton dto) {
        ModelUzyTCanton entity = modelMapper.map(dto, ModelUzyTCanton.class);
        String provinciaID = dto.getUzytprovincia_id();
        ModelUzyTProvincia provincia = entityManager.find(ModelUzyTProvincia.class, provinciaID );
        entity.setUzytprovincia(provincia);
        return entity;
    }

    public List<DtoUzyTCanton> entitiesToDtos(List<ModelUzyTCanton> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
