package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTCatalogosGenerales;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTCatalogosGenerales;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTCatalogosGeneralesMapper {
    private final ModelMapper modelMapper;

    public UzyTCatalogosGeneralesMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }

    public DtoUzyTCatalogosGenerales entityToDto(ModelUzyTCatalogosGenerales entity) {
        return modelMapper.map(entity, DtoUzyTCatalogosGenerales.class);
    }

    public ModelUzyTCatalogosGenerales dtoToEntity(DtoUzyTCatalogosGenerales dto) {
        return modelMapper.map(dto, ModelUzyTCatalogosGenerales.class);
    }
    public List<DtoUzyTCatalogosGenerales> entitiesToDtos(List<ModelUzyTCatalogosGenerales> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTCatalogosGenerales, DtoUzyTCatalogosGenerales>() {
            @Override
            protected void configure() {
                map().setUzytcata_gen_id(source.getUzytcata_gen_id());
            }
        });
    }

}
