package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTClasificadorPresup;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTClasificadorPresup;
import org.modelmapper.ModelMapper;

import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTClasificadorPresupMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTClasificadorPresupMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTClasificadorPresup entityToDto(ModelUzyTClasificadorPresup entity) {
        DtoUzyTClasificadorPresup dto = modelMapper.map(entity, DtoUzyTClasificadorPresup.class);
        dto.setClasificadorPresupPadre(entity.getClasificadorPresup() != null // asigno el objeto clasificadorPresupPadre
                ? entityToDto(entity.getClasificadorPresup())                 //si tiene padre entra en bucle hasta que sea nulo el clasificador presupuestario padre
                : null);
        return dto;
    }




    public ModelUzyTClasificadorPresup dtoToEntity(DtoUzyTClasificadorPresup dto) {
        ModelUzyTClasificadorPresup entity = modelMapper.map(dto, ModelUzyTClasificadorPresup.class);
        if (dto.getClasificadorPresupPadre() != null) {
            ModelUzyTClasificadorPresup clasificadorPresup = entityManager.find(
                    ModelUzyTClasificadorPresup.class, dto.getClasificadorPresupPadre());
            entity.setClasificadorPresup(clasificadorPresup);
        }
        return entity;
    }
    public List<DtoUzyTClasificadorPresup> entitiesToDtos(List<ModelUzyTClasificadorPresup> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }


}
