package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTLineaOperativa;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTLineaOperativa;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTLineaOperativaMapper {
    private final ModelMapper modelMapper;
    public UzyTLineaOperativaMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }

    public DtoUzyTLineaOperativa entityToDto(ModelUzyTLineaOperativa entity) {
        return modelMapper.map(entity, DtoUzyTLineaOperativa.class);
    }

    public ModelUzyTLineaOperativa dtoToEntity(DtoUzyTLineaOperativa dto) {
        return modelMapper.map(dto, ModelUzyTLineaOperativa.class);
    }
    public List<DtoUzyTLineaOperativa> entitiesToDtos(List<ModelUzyTLineaOperativa> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTLineaOperativa, DtoUzyTLineaOperativa>() {
            @Override
            protected void configure() {
                map().setUzytavlineaoperativa_ID(source.getUzytavlineaoperativa_ID());

            }
        });
    }
}
