package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTMenu;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTMenu;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;
import org.modelmapper.ModelMapper;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTMenuMapper {

    private final ModelMapper modelMapper;


    public UzyTMenuMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }
    public DtoUzyTMenu entityToDto(ModelUzyTMenu entity) {
        return modelMapper.map(entity, DtoUzyTMenu.class);
    }

    public ModelUzyTMenu dtoToEntity(DtoUzyTMenu dto) {
        return modelMapper.map(dto, ModelUzyTMenu.class);
    }

    public List<DtoUzyTMenu> entitiesToDtos(List<ModelUzyTMenu> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTMenu, DtoUzyTMenu>() {
            @Override
            protected void configure() {
                map().setUzytmenuId(source.getUzytmenuId());
            }
        });
    }
}
