package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTParroquia;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTCanton;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTParroquia;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTParroquiaMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTParroquiaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTParroquia entityToDto(ModelUzyTParroquia entity) {
        return modelMapper.map(entity, DtoUzyTParroquia.class);
    }

    public ModelUzyTParroquia dtoToEntity(DtoUzyTParroquia dto) {
        ModelUzyTParroquia entity = modelMapper.map(dto, ModelUzyTParroquia.class);
        String cantonID = dto.getUzytcanton_id();
        ModelUzyTCanton canton = entityManager.find(ModelUzyTCanton.class, cantonID );
        entity.setUzytcanton(canton);
        return entity;
    }

    public List<DtoUzyTParroquia> entitiesToDtos(List<ModelUzyTParroquia> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
