package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavParaEva;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTaValorParMapper {
    private final ModelMapper modelMapper;

    private final EntityManager entityManager;
    public UzyTaValorParMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTaValorPar entityToDto(ModelUzyTaValorPar entity) {
        return modelMapper.map(entity, DtoUzyTaValorPar.class);
    }

    public List<DtoUzyTaValorPar> entitiesToDtos(List<ModelUzyTaValorPar> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    public ModelUzyTaValorPar dtoToEntity(DtoUzyTaValorPar dto) {
        ModelUzyTaValorPar entity = modelMapper.map(dto, ModelUzyTaValorPar.class);
        Long paraevaId = dto.getUzytavparaeva_id();
        ModelUzyTavParaEva paraeva = entityManager.find(ModelUzyTavParaEva.class, paraevaId);
        entity.setUzyTavParaEva(paraeva);
        return entity;
    }


    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTaValorPar, DtoUzyTaValorPar>() {
            @Override
            protected void configure() {
                map().setUzytavaloruzytparametros_id(source.getUzytavaloruzytparametros_id());
                map().setUzytavparaeva_id(source.getUzyTavParaEva().getUzytavparaeva_id());
            }
        });
    }
}
