package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActProy;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavActProy;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzytavObjetivoPrograma;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavActProyMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavActProyMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;

    }

    public DtoUzyTavActProy entityToDto(ModelUzyTavActProy entity) {
        return modelMapper.map(entity, DtoUzyTavActProy.class);
    }

    public ModelUzyTavActProy dtoToEntity(DtoUzyTavActProy dto) {
        ModelUzyTavActProy entity = modelMapper.map(dto, ModelUzyTavActProy.class);
        Long ObjetivoID = dto.getUzytavobjetivo_programa_id();
        if(ObjetivoID !=null){
            ModelUzytavObjetivoPrograma objetivoPrograma = entityManager.find(ModelUzytavObjetivoPrograma.class,ObjetivoID );
            entity.setUzytavobjetivoPrograma(objetivoPrograma);
        }
        return entity;
    }

    public List<DtoUzyTavActProy> entitiesToDtos(List<ModelUzyTavActProy> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
