package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActivProg;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavActivProg;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavActivProgMapper {

    private final EntityManager entityManager;
    private final ModelMapper modelMapper;

    public UzyTavActivProgMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTavActivProg entityToDto(ModelUzyTavActivProg entity) {
        return modelMapper.map(entity, DtoUzyTavActivProg.class);
    }

    public ModelUzyTavActivProg dtoToEntity(DtoUzyTavActivProg dto) {
        ModelUzyTavActivProg entity = modelMapper.map(dto, ModelUzyTavActivProg.class);

        Long proyectoID = dto.getUzytavproyec_id();

        Long programaID = dto.getUzytavprograma_v_id();

        if(proyectoID != null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyectoID);
            entity.setUzytavproyec(proyec);
        }
        if(programaID !=null){
            ModelUzyTavPrograma_V programa = entityManager.find(ModelUzyTavPrograma_V.class,programaID);
            entity.setUzytavprograma_v(programa);
        }


        return entity;
    }

    public List<DtoUzyTavActivProg> entitiesToDtos(List<ModelUzyTavActivProg> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }


}
