package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavAnexoSPR;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavAnexoSPR;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabParaevaf;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;


import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavAnexoSPRMapper {
    private final ModelMapper modelMapper;

    public UzyTavAnexoSPRMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }

    public DtoUzyTavAnexoSPR entityToDto(ModelUzyTavAnexoSPR entity) {
        return modelMapper.map(entity, DtoUzyTavAnexoSPR.class);
    }

    public ModelUzyTavAnexoSPR dtoToEntity(DtoUzyTavAnexoSPR dto) {
        return modelMapper.map(dto, ModelUzyTavAnexoSPR.class);
    }
    public List<DtoUzyTavAnexoSPR> entitiesToDtos(List<ModelUzyTavAnexoSPR> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavAnexoSPR, DtoUzyTavAnexoSPR>() {
            @Override
            protected void configure() {
                map().setUzytavanexospr_id(source.getUzytavanexospr_id());
                map().setUzytusuario_id(source.getUzytusuario().getUzytusuario_id());
            }
        });
    }

}
