package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavAnualValor;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavAnualValor;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPresup;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavAnualValorMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;


    public UzyTavAnualValorMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavAnualValor entityToDto(ModelUzyTavAnualValor entity) {
        return modelMapper.map(entity, DtoUzyTavAnualValor.class);
    }

    public ModelUzyTavAnualValor dtoToEntity(DtoUzyTavAnualValor dto) {
        ModelUzyTavAnualValor entity = modelMapper.map(dto, ModelUzyTavAnualValor.class);
        Long presupID = dto.getUzytavpresup_id();
        ModelUzyTavPresup presup = entityManager.find(ModelUzyTavPresup.class, presupID);
        entity.setUzytavpresup(presup);
        return entity;
    }

    public List<DtoUzyTavAnualValor> entitiesToDtos(List<ModelUzyTavAnualValor> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavAnualValor, DtoUzyTavAnualValor>() {
            @Override
            protected void configure() {
                map().setUzytavanualvalor_id(source.getUzytavanualvalor_id());
                map().setUzytavpresup_id(source.getUzytavpresup().getUzytavpresup_id());
            }
        });
    }
}
