package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabComca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabComca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConsolca;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavCabComcaMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;
    public UzyTavCabComcaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavCabComca entityToDto(ModelUzyTavCabComca entity) {
        return modelMapper.map(entity, DtoUzyTavCabComca.class);
    }

    public ModelUzyTavCabComca dtoToEntity(DtoUzyTavCabComca dto) {
        ModelUzyTavCabComca entity = modelMapper.map(dto, ModelUzyTavCabComca.class);
        Long consolcaID = dto.getUzytavconsolca_id();
        if (consolcaID != null) {
            ModelUzyTavConsolca valorPar = entityManager.find(ModelUzyTavConsolca.class, consolcaID);
            entity.setUzytavconsolca(valorPar);
        }
        return entity;
    }
    public List<DtoUzyTavCabComca> entitiesToDtos(List<ModelUzyTavCabComca> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavCabComca, DtoUzyTavCabComca>() {
            @Override
            protected void configure() {
                map().setUzytavcabcomca_id(source.getUzytavcabcomca_id());
                map().setUzytavconsolca_id(source.getUzytavconsolca().getUzytavconsolca_id());
            }
        });
    }
}
