package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConparaEva;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavCabParaevafMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavCabParaevafMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTavCabParaevaf entityToDto(ModelUzyTavCabParaevaf entity) {
        return modelMapper.map(entity, DtoUzyTavCabParaevaf.class);
    }

    public ModelUzyTavCabParaevaf dtoToEntity(DtoUzyTavCabParaevaf dto) {
        ModelUzyTavCabParaevaf entity = modelMapper.map(dto, ModelUzyTavCabParaevaf.class);
        Long conparaevaID = dto.getUzytavconparaeva_id();
        ModelUzyTavConparaEva conparaEva = entityManager.find(ModelUzyTavConparaEva.class, conparaevaID);
        entity.setUzytavconparaeva(conparaEva);

        return entity;
    }

    public List<DtoUzyTavCabParaevaf> entitiesToDtos(List<ModelUzyTavCabParaevaf> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}

