package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavDetComca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavCabeValpMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavCabeValpMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavCabeValp entityToDto(ModelUzyTavCabeValp entity) {
        return modelMapper.map(entity, DtoUzyTavCabeValp.class);
    }

    public ModelUzyTavCabeValp dtoToEntity(DtoUzyTavCabeValp dto) {
        ModelUzyTavCabeValp entity = modelMapper.map(dto, ModelUzyTavCabeValp.class);
        Long proyecID = dto.getUzytavproyec_id();
        Long consolcaID = dto.getUzytavconsolca_id();
        Long detcomcaID = dto.getUzytavdetcomca_id();
        if(proyecID !=null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyecID);
            entity.setUzytavproyec(proyec);
        }
        if(consolcaID !=null){
            ModelUzyTavConsolca consolca = entityManager.find(ModelUzyTavConsolca.class, consolcaID);
            entity.setUzytavconsolca(consolca);
        }
        if(detcomcaID != null){
            ModelUzyTavDetComca detComca = entityManager.find(ModelUzyTavDetComca.class, detcomcaID);
            entity.setUzytavdetcomca(detComca);
        }

        return entity;
    }
    public List<DtoUzyTavCabeValp> entitiesToDtos(List<ModelUzyTavCabeValp> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavCabeValp, DtoUzyTavCabeValp>() {
            @Override
            protected void configure() {
                map().setUzytavcabevalp_id(source.getUzytavcabevalp_id());
                map().setUzytavproyec_id(source.getUzytavproyec().getUzytavproyec_id());
                map().setUzytavdetcomca_id(source.getUzytavdetcomca().getUzytavdetcomca_id());
                map().setUzytavconsolca_id(source.getUzytavconsolca().getUzytavconsolca_id());
            }
        });
    }
}

