package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavClasPre;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTClasificadorPresup;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavClasPre;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavClasPreMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;
    @Autowired
    UzyTClasificadorPresupMapper  mapperUzyTClasificadorPresup;
    public UzyTavClasPreMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavClasPre entityToDto(ModelUzyTavClasPre entity) {
        DtoUzyTavClasPre dto = modelMapper.map(entity, DtoUzyTavClasPre.class);
        dto.setUzytclasificador_presup(mapperUzyTClasificadorPresup.entityToDto(entity.getUzytclasificador_presup()));
        return dto;
    }



    public ModelUzyTavClasPre dtoToEntity(DtoUzyTavClasPre dto) {
        ModelUzyTavClasPre entity = modelMapper.map(dto, ModelUzyTavClasPre.class);
        Long presupId = dto.getUzytclasificador_presup_id();
        ModelUzyTClasificadorPresup presup = entityManager.find(ModelUzyTClasificadorPresup.class, presupId);
        entity.setUzytclasificador_presup(presup);
        return entity;
    }
    public List<DtoUzyTavClasPre> entitiesToDtos(List<ModelUzyTavClasPre> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavClasPre, DtoUzyTavClasPre>() {
            @Override
            protected void configure() {
                map().setUzytavclaspre_id(source.getUzytavclaspre_id());
            }
        });
    }


}
