package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfObj;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConfObj;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConfTipo;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavConfObjMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavConfObjMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavConfObj entityToDto(ModelUzyTavConfObj entity) {
        return modelMapper.map(entity, DtoUzyTavConfObj.class);
    }

    public ModelUzyTavConfObj dtoToEntity(DtoUzyTavConfObj dto) {
        ModelUzyTavConfObj entity = modelMapper.map(dto, ModelUzyTavConfObj.class);
        Long conftipoID = dto.getUzytavconftipo_id();
        ModelUzyTavConfTipo confTipo = entityManager.find(ModelUzyTavConfTipo.class, conftipoID);
        entity.setUzytavconftipo(confTipo);
        return entity;
    }

    public List<DtoUzyTavConfObj> entitiesToDtos(List<ModelUzyTavConfObj> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavConfObj, DtoUzyTavConfObj>() {
            @Override
            protected void configure() {
                map().setUzytavconfobj_id(source.getUzytavconfobj_id());
                map().setUzytavconftipo_id(source.getUzytavconftipo().getUzytavconftipo_id());
            }
        });
    }
}
