package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfTipo;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConfTipo;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavConfTipoMapper {

    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavConfTipoMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavConfTipo entityToDto(ModelUzyTavConfTipo entity) {
        return modelMapper.map(entity, DtoUzyTavConfTipo.class);
    }

    public ModelUzyTavConfTipo dtoToEntity(DtoUzyTavConfTipo dto) {
        ModelUzyTavConfTipo entity = modelMapper.map(dto, ModelUzyTavConfTipo.class);
        return entity;
    }

    public List<DtoUzyTavConfTipo> entitiesToDtos(List<ModelUzyTavConfTipo> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavConfTipo, DtoUzyTavConfTipo>() {
            @Override
            protected void configure() {
                map().setUzytavconftipo_id(source.getUzytavconftipo_id());
            }
        });
    }
}
