package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConparaEva;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConparaEva;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavConparaEvaMapper {
    private final ModelMapper modelMapper;

    public UzyTavConparaEvaMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }

    public DtoUzyTavConparaEva entityToDto(ModelUzyTavConparaEva entity) {
        return modelMapper.map(entity, DtoUzyTavConparaEva.class);
    }

    public ModelUzyTavConparaEva dtoToEntity(DtoUzyTavConparaEva dto) {
        return modelMapper.map(dto, ModelUzyTavConparaEva.class);
    }


    public List<DtoUzyTavConparaEva> entitiesToDtos(List<ModelUzyTavConparaEva> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavConparaEva, DtoUzyTavConparaEva>() {
            @Override
            protected void configure() {
                map().setUzytavconparaeva_id(source.getUzytavconparaeva_id());
            }
        });
    }
}
