package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavConsolcaMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;
    public UzyTavConsolcaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavConsolca entityToDto(ModelUzyTavConsolca entity) {
        return modelMapper.map(entity, DtoUzyTavConsolca.class);
    }

    public ModelUzyTavConsolca dtoToEntity(DtoUzyTavConsolca dto) {
        ModelUzyTavConsolca entity = modelMapper.map(dto, ModelUzyTavConsolca.class);
        Long proyecID = dto.getUzytavproyec_id();
        ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyecID );
        entity.setUzytavproyec(proyec);
        return entity;
    }

    public List<DtoUzyTavConsolca> entitiesToDtos(List<ModelUzyTavConsolca> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavConsolca, DtoUzyTavConsolca>() {
            @Override
            protected void configure() {
                map().setUzytavconsolca_id(source.getUzytavconsolca_id());
                map().setUzytavproyec_id(source.getUzytavproyec().getUzytavproyec_id());
            }
        });
    }
}
