package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConvoca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConvoca;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavConvocaMapper {
    private final ModelMapper modelMapper;

    public UzyTavConvocaMapper(ModelMapper modelMapper) {
        this.modelMapper = modelMapper;
        configureMappings();
    }

    public DtoUzyTavConvoca entityToDto(ModelUzyTavConvoca entity) {
        return modelMapper.map(entity, DtoUzyTavConvoca.class);
    }

    public ModelUzyTavConvoca dtoToEntity(DtoUzyTavConvoca dto) {
        return modelMapper.map(dto, ModelUzyTavConvoca.class);
    }
    public List<DtoUzyTavConvoca> entitiesToDtos(List<ModelUzyTavConvoca> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavConvoca, DtoUzyTavConvoca>() {
            @Override
            protected void configure() {
                map().setUzytavconvoca_id(source.getUzytavconvoca_id());

            }
        });
    }



}
