package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDesigDoc;
import ec.edu.espe.movilidad.MovilidadWS.Model.*;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavDesigDocMapper {
    private final ModelMapper modelMapper;

    private final EntityManager entityManager;

    public UzyTavDesigDocMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavDesigDoc entityToDto(ModelUzyTavDesigDoc entity) {
        return modelMapper.map(entity, DtoUzyTavDesigDoc.class);
    }

    public ModelUzyTavDesigDoc dtoToEntity(DtoUzyTavDesigDoc dto) {
        ModelUzyTavDesigDoc entity = modelMapper.map(dto, ModelUzyTavDesigDoc.class);
        Long uzytusuario_ID = dto.getDesigdoc_uzytusuario_ID();
        Long uzytusuario_ID_ASIGNADO = dto.getDesigdoc_uzytusuario_ID_ASIGNADO();
        Long proyectID = dto.getUzytavproyec_ID();
        if(uzytusuario_ID != null){
            ModelUzyTUsuario usuario = entityManager.find(ModelUzyTUsuario.class, uzytusuario_ID );
            entity.setUzytusuario(usuario);
        }
        if(uzytusuario_ID_ASIGNADO != null){
            ModelUzyTUsuario usuarioAsignado = entityManager.find(ModelUzyTUsuario.class, uzytusuario_ID_ASIGNADO );
            entity.setUzytusuarioAsignado(usuarioAsignado);
        }
        if(proyectID != null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyectID );
            entity.setUzytavproyec(proyec);
        }
        return entity;
    }

    public List<DtoUzyTavDesigDoc> entitiesToDtos(List<ModelUzyTavDesigDoc> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavDesigDoc, DtoUzyTavDesigDoc>() {
            @Override
            protected void configure() {
                map().setUzytavproyec_ID(source.getUzytavproyec().getUzytavproyec_id());
                map().setDesigdoc_uzytusuario_ID(source.getUzytusuario().getUzytusuario_id());
                map().setDesigdoc_uzytusuario_ID_ASIGNADO(source.getUzytusuarioAsignado().getUzytusuario_id());
            }
        });
    }
}
