package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDesigEstu;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTUsuario;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavDesigEstu;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavDesigEstuMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;
    public UzyTavDesigEstuMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavDesigEstu entityToDto(ModelUzyTavDesigEstu entity) {
        return modelMapper.map(entity, DtoUzyTavDesigEstu.class);
    }

    public ModelUzyTavDesigEstu dtoToEntity(DtoUzyTavDesigEstu dto) {
        ModelUzyTavDesigEstu entity = modelMapper.map(dto, ModelUzyTavDesigEstu.class);
        Long uzytusuario_ID = dto.getDesigestu_uzytusuario_ID();
        Long uzytusuario_ID_ASIGNADO = dto.getDesigestu_uzytusuario_ID_ASIGNADO();
        Long proyectID = dto.getUzytavproyec_ID();
        if(uzytusuario_ID != null){
            ModelUzyTUsuario usuario = entityManager.find(ModelUzyTUsuario.class, uzytusuario_ID );
            entity.setUzytusuario(usuario);
        }
        if(uzytusuario_ID_ASIGNADO != null){
            ModelUzyTUsuario usuarioAsignado = entityManager.find(ModelUzyTUsuario.class, uzytusuario_ID_ASIGNADO );
            entity.setUzytusuarioAsignado(usuarioAsignado);
        }
        if(proyectID != null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyectID );
            entity.setUzytavproyec(proyec);
        }
        return entity;
    }

    public List<DtoUzyTavDesigEstu> entitiesToDtos(List<ModelUzyTavDesigEstu> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavDesigEstu, DtoUzyTavDesigEstu>() {
            @Override
            protected void configure() {
                map().setUzytavproyec_ID(source.getUzytavproyec().getUzytavproyec_id());
                map().setDesigestu_uzytusuario_ID(source.getUzytusuario().getUzytusuario_id());
                map().setDesigestu_uzytusuario_ID_ASIGNADO(source.getUzytusuarioAsignado().getUzytusuario_id());
            }
        });
    }
}
