package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDetActproy;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavDetActproy;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzytavObjetivoPrograma;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavDetActproyMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavDetActproyMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavDetActproy entityToDto(ModelUzyTavDetActproy entity) {
        return modelMapper.map(entity, DtoUzyTavDetActproy.class);
    }

    public ModelUzyTavDetActproy dtoToEntity(DtoUzyTavDetActproy dto) {
        ModelUzyTavDetActproy entity = modelMapper.map(dto, ModelUzyTavDetActproy.class);
        Long ObjetivoID = dto.getUzytavobjetivo_programa_id();
        if(ObjetivoID != null){
            ModelUzytavObjetivoPrograma objetivoPrograma = entityManager.find(ModelUzytavObjetivoPrograma.class, ObjetivoID );
            entity.setUzytavobjetivoPrograma(objetivoPrograma);
        }
        return entity;
    }

    public List<DtoUzyTavDetActproy> entitiesToDtos(List<ModelUzyTavDetActproy> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavDetActproy, DtoUzyTavDetActproy>() {
            @Override
            protected void configure() {
                map().setUzytavobjetivo_programa_id(source.getUzytavobjetivoPrograma().getUzytavobjetivo_programa_id());
                map().setUzytavactproy_id(source.getUzytavactproy().getUzytavactproy_id());

            }
        });
    }
}
