package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDetComca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabComca;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavDetComca;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavDetComcaMapper {

    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavDetComcaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavDetComca entityToDto(ModelUzyTavDetComca entity) {
        return modelMapper.map(entity, DtoUzyTavDetComca.class);
    }

    public ModelUzyTavDetComca dtoToEntity(DtoUzyTavDetComca dto) {
        if (dto.getUzytusuario_id_asignado() == null) {
            throw new IllegalArgumentException("El campo usuarioIdAsignado es requerido");
        }
        ModelUzyTavDetComca entity = modelMapper.map(dto, ModelUzyTavDetComca.class);
        Long cabcomcaID = dto.getUzytavcabcomca_id();
        ModelUzyTavCabComca cabComca = entityManager.find(ModelUzyTavCabComca.class, cabcomcaID);
        Long usuarioIdAsignado = dto.getUzytusuario_id_asignado();
        entity.setUzytavcabcomca(cabComca);
        entity.setUzytusuario_id_asignado(usuarioIdAsignado);
        return entity;
    }

    public List<DtoUzyTavDetComca> entitiesToDtos(List<ModelUzyTavDetComca> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavDetComca, DtoUzyTavDetComca>() {
            @Override
            protected void configure() {
                map().setUzytavdetcomca_id(source.getUzytavdetcomca_id());
                map().setUzytavcabcomca_id(source.getUzytavcabcomca().getUzytavcabcomca_id());
            }
        });
    }


}
