package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavEvalProy;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavEvalProy;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavEvalProyMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavEvalProyMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavEvalProy entityToDto(ModelUzyTavEvalProy entity) {
        return modelMapper.map(entity, DtoUzyTavEvalProy.class);
    }

    public ModelUzyTavEvalProy dtoToEntity(DtoUzyTavEvalProy dto) {

        ModelUzyTavEvalProy entity = modelMapper.map(dto, ModelUzyTavEvalProy.class);
        Long cabevalpID = dto.getUzytavcabevalp_id();
        Long valorparID = dto.getUzytavaloruzytparametros_id();

        if(cabevalpID !=null){
            ModelUzyTavCabeValp cabeval = entityManager.find(ModelUzyTavCabeValp.class, cabevalpID);
            entity.setUzytavcabevalp(cabeval);
        }
        if(valorparID !=null){
            ModelUzyTaValorPar valorPar = entityManager.find(ModelUzyTaValorPar.class, valorparID);
            entity.setUzytavalorpar(valorPar);
        }
        return entity;
    }

    public List<DtoUzyTavEvalProy> entitiesToDtos(List<ModelUzyTavEvalProy> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavEvalProy, DtoUzyTavEvalProy>() {
            @Override
            protected void configure() {
                map().setUzytavevalproy_id(source.getUzytavevalproy_id());
                map().setUzytavcabevalp_id(source.getUzytavcabevalp().getUzytavcabevalp_id());
                map().setUzytavaloruzytparametros_id(source.getUzytavalorpar().getUzytavaloruzytparametros_id());
            }
        });
    }
}
