package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavInstProy;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavInstProy;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavParametros_Det;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavInstProyMapper {

    private final ModelMapper mapper;

    private final EntityManager entityManager;

    public UzyTavInstProyMapper(ModelMapper mapper, EntityManager entityManager) {
        this.mapper = mapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavInstProy entityToDto(ModelUzyTavInstProy entity) {
        return mapper.map(entity, DtoUzyTavInstProy.class);
    }

    public ModelUzyTavInstProy dtoToEntity(DtoUzyTavInstProy dto) {
        ModelUzyTavInstProy entity = mapper.map(dto, ModelUzyTavInstProy.class);
        Long idEntidad = dto.getUzytparametros_det_id_entidad();
        Long idOrganizacion = dto.getUzytparametros_det_id_organizacion();
        if (idEntidad != null) {
            ModelUzyTavParametros_Det parametrosDetEntidad = entityManager.find(ModelUzyTavParametros_Det.class, idEntidad);
            entity.setUzytparametrosDetIdEntidad(parametrosDetEntidad);
        }
        if (idOrganizacion != null) {
            ModelUzyTavParametros_Det parametrosDetOrganizacion = entityManager.find(ModelUzyTavParametros_Det.class, idOrganizacion);
            entity.setUzytparametrosDetIdOrganizacion(parametrosDetOrganizacion);
        }
        return entity;
    }

    public List<DtoUzyTavInstProy> entitiesToDtos(List<ModelUzyTavInstProy> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        mapper.addMappings(new PropertyMap<ModelUzyTavInstProy, DtoUzyTavInstProy>() {
            @Override
            protected void configure() {
                map().setUzytparametros_det_id_organizacion(source.getUzytparametrosDetIdOrganizacion().getUzytparametros_det_id());
                map().setUzytparametros_det_id_entidad(source.getUzytparametrosDetIdEntidad().getUzytparametros_det_id());
            }
        });
    }

}
