package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavInstituc;
import ec.edu.espe.movilidad.MovilidadWS.Model.*;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavInstitucMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavInstitucMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTavInstituc entityToDto(ModelUzyTavInstituc entity) {
        return modelMapper.map(entity, DtoUzyTavInstituc.class);
    }

    public ModelUzyTavInstituc dtoToEntity(DtoUzyTavInstituc dto) {
        ModelUzyTavInstituc entity = modelMapper.map(dto, ModelUzyTavInstituc.class);
        String parroquiaID = dto.getUzytparroquia_id();
        ModelUzyTParroquia parroquia = entityManager.find(ModelUzyTParroquia.class, parroquiaID);
        entity.setUzytparroquia(parroquia);
        return entity;
    }
    public List<DtoUzyTavInstituc> entitiesToDtos(List<ModelUzyTavInstituc> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
