package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivoBVivir;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivoBVivir;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavObjetivoBVivirMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavObjetivoBVivirMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTavObjetivoBVivir entityToDto(ModelUzyTavObjetivoBVivir entity) {
        DtoUzyTavObjetivoBVivir dto = modelMapper.map(entity, DtoUzyTavObjetivoBVivir.class);
        if (entity.getUzytavobjetivo_b_vivir() != null) {
            DtoUzyTavObjetivoBVivir padreDto = entityToDto(entity.getUzytavobjetivo_b_vivir());
            dto.setObjetivo_b_vivirPadre(padreDto);
            dto.setUzytavobjetivo_b_vivirid_padre(entity.getUzytavobjetivo_b_vivir().getUzytavobjetivo_b_vivir_id());
        }
        return dto;
    }




    public ModelUzyTavObjetivoBVivir dtoToEntity(DtoUzyTavObjetivoBVivir dto) {
        ModelUzyTavObjetivoBVivir entity = modelMapper.map(dto, ModelUzyTavObjetivoBVivir.class);
        if (dto.getObjetivo_b_vivirPadre() != null) {
            ModelUzyTavObjetivoBVivir padreEntity = dtoToEntity(dto.getObjetivo_b_vivirPadre());
            entity.setUzytavobjetivo_b_vivir(padreEntity);
        }
        return entity;
    }


    public List<DtoUzyTavObjetivoBVivir> entitiesToDtos(List<ModelUzyTavObjetivoBVivir> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
