package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivosEstraInsti;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivosEstraInsti;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavObjetivosEstraInstiMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavObjetivosEstraInstiMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();

    }

    public DtoUzyTavObjetivosEstraInsti entityToDto(ModelUzyTavObjetivosEstraInsti entity) {
        DtoUzyTavObjetivosEstraInsti dto = modelMapper.map(entity, DtoUzyTavObjetivosEstraInsti.class);
        if (entity.getUzyTavObjetivosEstraInstiPadre() != null) {
            DtoUzyTavObjetivosEstraInsti padreDto = entityToDto(entity.getUzyTavObjetivosEstraInstiPadre());
            dto.setUzyTavObjetivosEstraInstiPadre(padreDto);
        }
        return dto;
    }

    public ModelUzyTavObjetivosEstraInsti dtoToEntity(DtoUzyTavObjetivosEstraInsti dto) {
        ModelUzyTavObjetivosEstraInsti entity = modelMapper.map(dto, ModelUzyTavObjetivosEstraInsti.class);
        if (dto.getUzyTavObjetivosEstraInstiPadre() != null) {
            ModelUzyTavObjetivosEstraInsti padre = entityManager.find(
                    ModelUzyTavObjetivosEstraInsti.class, dto.getUzyTavObjetivosEstraInstiPadre().getUZYTAVOBJETIVOS_ESTRA_INSTI_ID());
            entity.setUzyTavObjetivosEstraInstiPadre(padre);
        }
        return entity;
    }

    public List<DtoUzyTavObjetivosEstraInsti> entitiesToDtos(List<ModelUzyTavObjetivosEstraInsti> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavObjetivosEstraInsti, DtoUzyTavObjetivosEstraInsti>() {
            @Override
            protected void configure() {
                map().setUZYTAVOBJETIVOS_ESTRA_INSTI_ID(source.getUZYTAVOBJETIVOS_ESTRA_INSTI_ID());
                map().setUZYTAVOBJETIVOS_ESTRA_INSTI_PADRE(source.getUzyTavObjetivosEstraInstiPadre().getUZYTAVOBJETIVOS_ESTRA_INSTI_ID());
                map().setUZYTAVCONFOBJ_ID(source.getUzytavconfobj().getUzytavconfobj_id());

            }
        });
    }
}
