package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavOpcionInstitucion;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTProvincia;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavOpcionInstitucion;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_V;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavOpcionInstitucionMapper {
    private final EntityManager entityManager;
    private final ModelMapper modelMapper;

    public UzyTavOpcionInstitucionMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavOpcionInstitucion entityToDto(ModelUzyTavOpcionInstitucion entity) {
        return modelMapper.map(entity, DtoUzyTavOpcionInstitucion.class);
    }

    public ModelUzyTavOpcionInstitucion dtoToEntity(DtoUzyTavOpcionInstitucion dto) {
        ModelUzyTavOpcionInstitucion entity = modelMapper.map(dto, ModelUzyTavOpcionInstitucion.class);

        String uzytprovincia_id = dto.getUzytprovincia_id();

        Long programaID = dto.getUzytavprograma_v_id();

        if(uzytprovincia_id != null){
            ModelUzyTProvincia provincia = entityManager.find(ModelUzyTProvincia.class, uzytprovincia_id);
            entity.setUzytprovincia(provincia);
        }
        if(programaID !=null){
            ModelUzyTavPrograma_V programa = entityManager.find(ModelUzyTavPrograma_V.class,programaID);
            entity.setUzytavprograma_v(programa);
        }



        return entity;
    }

    public List<DtoUzyTavOpcionInstitucion> entitiesToDtos(List<ModelUzyTavOpcionInstitucion> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavOpcionInstitucion, DtoUzyTavOpcionInstitucion>() {
            @Override
            protected void configure() {
                map().setUzytavopcion_institucion_id(source.getUzytavopcion_institucion_id());
                map().setUzytavprograma_v_id(source.getUzytavprograma_v().getUzytavprograma_v_id());
                map().setUzytprovincia_id(source.getUzytprovincia().getUzytprovincia_id());
            }
        });
    }

}
