package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavParaEva;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConparaEva;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavParaEva;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavParaEvaMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;
    public UzyTavParaEvaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager=entityManager;
        configureMappings();
    }

    public DtoUzyTavParaEva entityToDto(ModelUzyTavParaEva entity) {
        return modelMapper.map(entity, DtoUzyTavParaEva.class);
    }

    public ModelUzyTavParaEva dtoToEntity(DtoUzyTavParaEva dto) {
        ModelUzyTavParaEva entity = modelMapper.map(dto, ModelUzyTavParaEva.class);
        Long conparaevaId = dto.getUzytavconparaeva_id();
        ModelUzyTavConparaEva lineaOperativa = entityManager.find(ModelUzyTavConparaEva.class, conparaevaId);
        entity.setUzytavconparaeva(lineaOperativa);
        return entity;
    }
    public List<DtoUzyTavParaEva> entitiesToDtos(List<ModelUzyTavParaEva> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavParaEva, DtoUzyTavParaEva>() {
            @Override
            protected void configure() {
                map().setUzytavparaeva_id(source.getUzytavparaeva_id());
                map().setUzytavconparaeva_id(source.getUzytavconparaeva().getUzytavconparaeva_id());
                map().setUzytavcabparaevaf_id((source.getUzytavcabparaevaf_id()));
            }
        });
    }
}
