package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPlanVPrograma;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjPlanVinvula;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPlanVPrograma;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavPlanVProgramaMapper {

    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavPlanVProgramaMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }


    public DtoUzyTavPlanVPrograma entityToDto(ModelUzyTavPlanVPrograma entity) {
        return modelMapper.map(entity, DtoUzyTavPlanVPrograma.class);
    }

    public ModelUzyTavPlanVPrograma dtoToEntity(DtoUzyTavPlanVPrograma dto) {
        ModelUzyTavPlanVPrograma entity = modelMapper.map(dto, ModelUzyTavPlanVPrograma.class);
        Long objplanvin = dto.getUzytavobj_plan_vinvula_id();
        ModelUzyTavObjPlanVinvula planVinvula = entityManager.find(ModelUzyTavObjPlanVinvula.class, objplanvin);
        entity.setUzytavobjPlanVinvula(planVinvula);
        return entity;
    }

    public List<DtoUzyTavPlanVPrograma> entitiesToDtos(List<ModelUzyTavPlanVPrograma> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }


}
