package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPresup;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavClasPre;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPresup;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavPresupMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavPresupMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavPresup entityToDto(ModelUzyTavPresup entity) {
        return modelMapper.map(entity, DtoUzyTavPresup.class);
    }

    public ModelUzyTavPresup dtoToEntity(DtoUzyTavPresup dto) {
        ModelUzyTavPresup entity = modelMapper.map(dto, ModelUzyTavPresup.class);
        Long proyecID = dto.getUzytavproyec_id();
        Long classpreID = dto.getUzytavclaspre_id();

        if(proyecID !=null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyecID);
            entity.setUzytavproyec(proyec);
        }
        if(classpreID != null){
            ModelUzyTavClasPre clasPre = entityManager.find(ModelUzyTavClasPre.class, classpreID);
            entity.setUzytavclaspre(clasPre);
        }
        return entity;
    }
    public List<DtoUzyTavPresup> entitiesToDtos(List<ModelUzyTavPresup> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavPresup, DtoUzyTavPresup>() {
            @Override
            protected void configure() {
                map().setUzytavpresup_id(source.getUzytavpresup_id());
                map().setUzytavproyec_id(source.getUzytavproyec().getUzytavproyec_id());
                map().setUzytavclaspre_id(source.getUzytavclaspre().getUzytavclaspre_id());
            }
        });
    }
}
