package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavProgObjEstartegico;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivosEstraInsti;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProgObjEstartegico;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProyec;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;
import org.modelmapper.ModelMapper;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;
@Component
public class UzyTavProgObjEstartegicoMapper {

    private final ModelMapper modelMapper;

    private final EntityManager entityManager;
    public UzyTavProgObjEstartegicoMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavProgObjEstartegico entityToDto(ModelUzyTavProgObjEstartegico entity) {
        return modelMapper.map(entity, DtoUzyTavProgObjEstartegico.class);
    }

    public List<DtoUzyTavProgObjEstartegico> entitiesToDtos(List<ModelUzyTavProgObjEstartegico> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

    public ModelUzyTavProgObjEstartegico dtoToEntity(DtoUzyTavProgObjEstartegico dto) {
        ModelUzyTavProgObjEstartegico entity = modelMapper.map(dto, ModelUzyTavProgObjEstartegico.class);
        Long estraInstiID = dto.getUzytavobjetivos_ESTRA_INSTI_ID();
        Long programaID = dto.getUzytavprograma_V_ID();
        Long proyectoID = dto.getUzytavproyec_ID();
        if(estraInstiID != null){
            ModelUzyTavObjetivosEstraInsti estraInsti = entityManager.find(ModelUzyTavObjetivosEstraInsti.class, estraInstiID);
            entity.setUzytavobjetivosEstraInsti(estraInsti);
        }
        if(programaID != null){
            ModelUzyTavPrograma_V programaV = entityManager.find(ModelUzyTavPrograma_V.class, programaID);
            entity.setUzytavprograma_v(programaV);
        }
        if(proyectoID != null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class, proyectoID);
            entity.setUzytavproyec(proyec);
        }
        return entity;
    }

    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavProgObjEstartegico, DtoUzyTavProgObjEstartegico>() {
            @Override
            protected void configure() {
                map().setUzytavproyec_ID(source.getUzytavproyec().getUzytavproyec_id());
                map().setUzytavprograma_V_ID(source.getUzytavprograma_v().getUzytavprograma_v_id());
                map().setUzytavobjetivos_ESTRA_INSTI_ID(source.getUzytavobjetivosEstraInsti().getUZYTAVOBJETIVOS_ESTRA_INSTI_ID());

            }
        });
    }
}
