package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_Eplanv;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavEstrategiasVPlan;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_Eplanv;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavPrograma_EplanvMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavPrograma_EplanvMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }


    public DtoUzyTavPrograma_Eplanv entityToDto(ModelUzyTavPrograma_Eplanv entity) {
        return modelMapper.map(entity, DtoUzyTavPrograma_Eplanv.class);
    }

    public ModelUzyTavPrograma_Eplanv dtoToEntity(DtoUzyTavPrograma_Eplanv dto) {
        ModelUzyTavPrograma_Eplanv entity = modelMapper.map(dto, ModelUzyTavPrograma_Eplanv.class);
        Long estrategiasID = dto.getUzytavestrategias_v_plan_id();
        ModelUzyTavEstrategiasVPlan estrategiasVPlan = entityManager.find(ModelUzyTavEstrategiasVPlan.class, estrategiasID);
        entity.setUzytavestrategiasVPlan(estrategiasVPlan);
        return entity;
    }

    public List<DtoUzyTavPrograma_Eplanv> entitiesToDtos(List<ModelUzyTavPrograma_Eplanv> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
