package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavResponsableProg;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTUsuario;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavResponsableProg;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavResponsableProgMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavResponsableProgMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }

    public DtoUzyTavResponsableProg entityToDto(ModelUzyTavResponsableProg entity) {
        return modelMapper.map(entity, DtoUzyTavResponsableProg.class);
    }

    public ModelUzyTavResponsableProg dtoToEntity(DtoUzyTavResponsableProg dto) {
        ModelUzyTavResponsableProg entity = modelMapper.map(dto, ModelUzyTavResponsableProg.class);
        Long usuarioID = dto.getUzytusuario_id_docente();
        if (usuarioID != null) {
            ModelUzyTUsuario usuario = entityManager.find(ModelUzyTUsuario.class, usuarioID);
            entity.setIddocente(usuario);
        }
        return entity;
    }
    public List<DtoUzyTavResponsableProg> entitiesToDtos(List<ModelUzyTavResponsableProg> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavResponsableProg, DtoUzyTavResponsableProg>() {
            @Override
            protected void configure() {
                map().setUzytusuario_id_docente(source.getIddocente().getUzytusuario_id());


            }
        });
    }
}
