package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavSeguim;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavSeguim;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzytavObjetivoPrograma;
import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;

@Component
public class UzyTavSeguimMapper {
    private final ModelMapper modelMapper;
    private final EntityManager entityManager;

    public UzyTavSeguimMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;

    }

    public DtoUzyTavSeguim entityToDto(ModelUzyTavSeguim entity) {
        return modelMapper.map(entity, DtoUzyTavSeguim.class);
    }

    public ModelUzyTavSeguim dtoToEntity(DtoUzyTavSeguim dto) {
        ModelUzyTavSeguim entity = modelMapper.map(dto, ModelUzyTavSeguim.class);
        Long objetivoPID = dto.getUzytavobjetivo_programa_id();
        if (objetivoPID != null) {
            ModelUzytavObjetivoPrograma objetivoPrograma = entityManager.find(ModelUzytavObjetivoPrograma.class, objetivoPID);
            entity.setUzytavobjetivoPrograma(objetivoPrograma);
        }
        return entity;
    }

    public List<DtoUzyTavSeguim> entitiesToDtos(List<ModelUzyTavSeguim> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }


}
