package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavZonaDetalle;
import ec.edu.espe.movilidad.MovilidadWS.Model.*;

import java.util.List;
import java.util.stream.Collectors;

import org.modelmapper.ModelMapper;
import org.springframework.stereotype.Component;

import javax.persistence.EntityManager;

@Component
public class UzyTavZonaDetalleMapper {
    private final ModelMapper modelMapper;

    private final EntityManager entityManager;

    public UzyTavZonaDetalleMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
    }

    public DtoUzyTavZonaDetalle entityToDto(ModelUzyTavZonaDetalle entity) {
        return modelMapper.map(entity, DtoUzyTavZonaDetalle.class);
    }

    public ModelUzyTavZonaDetalle dtoToEntity(DtoUzyTavZonaDetalle dto) {
        ModelUzyTavZonaDetalle entity = modelMapper.map(dto, ModelUzyTavZonaDetalle.class);

        String uzytprovincia_id = dto.getUzytprovincia_id();
        String canton_id = dto.getUzytcanton_id();
        String parroquiaID = dto.getUzytparroquia_id();
        Long proyectID = dto.getUzytavproyec_id();
        Long programaID = dto.getUzytavprograma_v_id();

        if(uzytprovincia_id != null){
            ModelUzyTProvincia provincia = entityManager.find(ModelUzyTProvincia.class, uzytprovincia_id);
            entity.setUzytprovincia(provincia);
        }
        if(programaID !=null){
            ModelUzyTavPrograma_V programa = entityManager.find(ModelUzyTavPrograma_V.class,programaID);
            entity.setUzytavprograma_v(programa);
        }
        if(canton_id !=null){
            ModelUzyTCanton canton = entityManager.find(ModelUzyTCanton.class,canton_id);
            entity.setUzytcanton(canton);
        }
        if(parroquiaID !=null){
            ModelUzyTParroquia parroquia = entityManager.find(ModelUzyTParroquia.class,parroquiaID);
            entity.setUzytparroquia(parroquia);
        }
        if(proyectID !=null){
            ModelUzyTavProyec proyec = entityManager.find(ModelUzyTavProyec.class,proyectID);
            entity.setUzytavproyec(proyec);
        }

        return entity;
    }

    public List<DtoUzyTavZonaDetalle> entitiesToDtos(List<ModelUzyTavZonaDetalle> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }
}
