package ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTLineaOperativa;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTUsuario;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_V;
import org.modelmapper.ModelMapper;
import org.modelmapper.PropertyMap;
import org.springframework.stereotype.Component;
import javax.persistence.EntityManager;
import java.util.List;
import java.util.stream.Collectors;


@Component
public class Uzytavprograma_VMapper {

    private final EntityManager entityManager;
    private final ModelMapper modelMapper;

    public Uzytavprograma_VMapper(ModelMapper modelMapper, EntityManager entityManager) {
        this.modelMapper = modelMapper;
        this.entityManager = entityManager;
        configureMappings();
    }
    private void configureMappings() {
        modelMapper.addMappings(new PropertyMap<ModelUzyTavPrograma_V, DtoUzyTavPrograma_V>() {
            @Override
            protected void configure() {
                map().setUzytavprograma_v_id(source.getUzytavprograma_v_id());
                map().setUzytavlineaoperativa_ID(source.getUzytlineaoperativa().getUzytavlineaoperativa_ID());
                map().setUzytusuario_id(source.getUzytusuario().getUzytusuario_id());

            }
        });
    }
    //Convierte entidad a dto.
    public DtoUzyTavPrograma_V entityToDto(ModelUzyTavPrograma_V entity) {
        return modelMapper.map(entity, DtoUzyTavPrograma_V.class);
    }
    // Convierte de DTO a Entidad

    public ModelUzyTavPrograma_V  dtoToEntity(DtoUzyTavPrograma_V dto) {
        ModelUzyTavPrograma_V entity = modelMapper.map(dto, ModelUzyTavPrograma_V.class);
        // Obtener el ID de la línea operativa desde el DTO y establecerlo en la entidad
        Long lineaOperativaId = dto.getUzytavlineaoperativa_ID();
        Long usuarioID = dto.getUzytusuario_id();
        if(lineaOperativaId!=null){
            ModelUzyTLineaOperativa lineaOperativa =  entityManager.find(ModelUzyTLineaOperativa.class, lineaOperativaId);
            entity.setUzytlineaoperativa(lineaOperativa);
        }
        if(usuarioID !=null){
            ModelUzyTUsuario usuario =  entityManager.find(ModelUzyTUsuario.class, usuarioID);
            entity.setUzytusuario(usuario);
        }

        return entity;
    }

    public List<DtoUzyTavPrograma_V> entitiesToDtos(List<ModelUzyTavPrograma_V> entities) {
        return entities.stream()
                .map(this::entityToDto)
                .collect(Collectors.toList());
    }

}
