package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytclasificador_presup", schema = "UTIC1")
public class ModelUzyTClasificadorPresup {
    @Id
    @Column(name = "uzytclasificador_presup_id")
    private Long uzytclasificador_presup_id;


    @Column(name = "uzytclasificador_presup_nombre", length = 1000)
    private String uzytclasificador_presup_nombre;

    @Column(name = "uzytclasificador_presup_ejercicio")
    private Integer uzytclasificador_presup_ejercicio;

    @Column(name = "uzytclasificador_presup_estado", length = 1)
    private String uzytclasificador_presup_estado;

    //RELACIÓN PADRE CONSIGO MISMA


    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "uzytclasificador_presup_padre", referencedColumnName = "uzytclasificador_presup_id")
    private ModelUzyTClasificadorPresup clasificadorPresup;



    @JsonIgnore
    @OneToMany(mappedBy = "clasificadorPresup")
    private Set<ModelUzyTClasificadorPresup> clasificadorPresupSet = new LinkedHashSet<>();


    //RELACIÓN CON CLASSPRE-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytclasificador_presup")
    private Set<ModelUzyTavClasPre> modelUzyTavClasPreSet = new LinkedHashSet<>();
}
