package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytparroquia", schema = "UTIC1")
public class ModelUzyTParroquia {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytparroquia_seq")
    @SequenceGenerator(name = "uzytparroquia_seq", sequenceName = "SEQ_UZYTPARROQUIA", allocationSize = 1)
    @Column(name = "uzytparroquia_id")
    private String uzytparroquia_id;



    @Column(name = "uzytparroquia_nombre", nullable = false)
    private String uzytparroquia_nombre;

    @Column(name = "uzytparroquia_tipo")
    private String uzytparroquia_tipo;

    @Column(name = "uzytparroquia_grupo_recinto")
    private Integer uzytparroquia_grupo_recinto;

    //RELACIÓN CON LA TABLA CANTON-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytcanton_id", referencedColumnName = "uzytcanton_id")
    private ModelUzyTCanton uzytcanton;

    //RELACIÓN CON LA TABLA UZYTAVINSTITUC-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytparroquia")
    private Set<ModelUzyTavInstituc> modelUzyTavInstitucSet = new LinkedHashSet<>();

    //Relación con la tabla zonadetalle-tabla hija

    @JsonIgnore
    @OneToMany(mappedBy = "uzytparroquia")
    private Set<ModelUzyTavZonaDetalle> modelUzyTavZonaDetalleSet = new LinkedHashSet<>();

}
