package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytprovincia", schema = "UTIC1")
public class ModelUzyTProvincia {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytprovincia_id_seq")
    @SequenceGenerator(name = "uzytprovincia_id_seq", sequenceName = "SEQ_UZYTPROVINCIA", allocationSize = 1)

    @Column(name = "uzytprovincia_id")
    private String uzytprovincia_id;


    @Column(name = "uzytprovincia_nombre", nullable = false)
    private String uzytprovincia_nombre;

    @Column(name = "uzytprovincia_cod_inen")
    private String uzytprovincia_cod_inen;

    @Column(name = "uzytprovincia_region")
    private String uzytprovincia_region;

    //RELACIÓN CON LA TABLA OpciónInstitución
    @JsonIgnore
    @OneToMany(mappedBy = "uzytprovincia")
    private Set<ModelUzyTavOpcionInstitucion> modelUzyTavOpcionInstitucionSet = new LinkedHashSet<>();

    //RELACIÓN CON LA TABLA CANTON- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytprovincia")
    private Set<ModelUzyTCanton> modelUzyTCantonSet = new LinkedHashSet<>();

    //RELACIÓN CON LA TABLA ZONADETALLE-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytprovincia")
    private Set<ModelUzyTavZonaDetalle> modelUzyTavZonaDetalleSet = new LinkedHashSet<>();

}
