package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytusuario", schema = "UTIC1")
public class ModelUzyTUsuario {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytusuario_id_seq")
    @SequenceGenerator(name = "uzytusuario_id_seq", sequenceName = "SEQ_UZYTUSUARIO", allocationSize = 1)
    @Column(name = "uzytusuario_id")
    private Long uzytusuario_id;

    @Size(max = 20)
    @Column(name = "uzytusuario_cc", length = 20)
    private String uzytusuario_cc;
    @Size(max = 100)
    @Column(name = "uzytusuario_clave", length = 100)
    private String uzytusuario_clave;
    @Size(max = 60)
    @Column(name = "uzytusuario_nombres", length = 60)
    private String uzytusuario_nombres;
    @Size(max = 60)
    @Column(name = "uzytusuario_apellidos", nullable = false, length = 60)
    private String uzytusuario_apellidos;
    @Size(max = 100)
    @Column(name = "uzytusuario_email", length = 100)
    private String uzytusuario_email;

    @Column(name = "uzytusuario_fecharegistro")
    private LocalDate uzytusuario_fecharegistro;
    @Size(max = 1)
    @Column(name = "uzytusuario_estado", length = 1)
    private String uzytusuario_estado;

    @Column(name = "uzytusuario_mail_sinformul")
    private Integer uzytusuario_mail_sinformul;

    @Column(name = "uzytusuario_mail_incompletos")
    private Integer uzytusuario_mail_incompletos;
    @Size(max = 30)
    @Column(name = "uzytusuario_tipo_doc", length = 30)
    private String uzytusuario_tipo_doc;
    @Size(max = 30)
    @Column(name = "uzytusuario_cod_senescyt", length = 30)
    private String uzytusuario_cod_senescyt;

    @Column(name = "uzytusuario_fecha_act_micuenta")
    private LocalDate uzytusuario_fecha_act_micuenta;
    @Size(max = 6)
    @Column(name = "uzytusuario_hexadecimalid", length = 6)
    private String uzytusuario_hexadecimalid;
    @Size(max = 25)
    @Column(name = "uzytusuario_tratamiento", length = 25)
    private String uzytusuario_tratamiento;

    @Column(name = "uzytusuario_modificacion")
    private Integer uzytusuario_modificacion;
    @Size(max = 1)
    @Column(name = "uzytusuario_tipo_user", length = 1)
    private String uzytusuario_tipo_user;
    @Size(max = 100)
    @Column(name = "uzytusuario_email_institucional", length = 100)
    private String uzytusuario_email_institucional;
    @Size(max = 10)
    @Column(name = "uzytusuario_telefono_fijo", length = 10)
    private String uzytusuario_telefono_fijo;
    @Size(max = 10)
    @Column(name = "uzytusuario_telefono_celular", length = 10)
    private String uzytusuario_telefono_celular;
    @Size(max = 9)
    @Column(name = "spriden_id", length = 9)
    private String spriden_id;

    @Column(name = "spriden_pidm")
    private Integer spriden_pidm;
    @Size(max = 200)
    @Column(name = "uzytusuario_clave_tmp", length = 200)
    private String uzytusuario_clave_tmp;
    @Size(max = 20)
    @Column(name = "spbpers_name_prefix", length = 20)
    private String spbpers_name_prefix;

    @Size(max = 1)
    @Column(name = "spbpers_sex", length = 1)
    private String spbpers_sex;
    @Size(max = 40)
    @Column(name = "uzytusuario_campus", length = 40)
    private String uzytusuario_campus;
    @Size(max = 20)
    @Column(name = "uzytusuario_departamento", length = 20)
    private String uzytusuario_departamento;
    @Size(max = 250)
    @Column(name = "uzytusuario_foto", length = 250)
    private String uzytusuario_foto;
    @Size(max = 3)
    @Column(name = "uzytusuario_CAMPUS_CODE", length = 3)
    private String uzytusuario_CAMPUS_CODE;
    @Size(max = 4)
    @Column(name = "uzytusuario_DEPARTAMENTO_CODE", length = 4)
    private String uzytusuario_DEPARTAMENTO_CODE;

    @Size(max = 2)
    @Column(name = "uzytusuario_CAMPUS_ABREV_CODE", length = 2)
    private String uzytusuario_CAMPUS_ABREV_CODE;

    @Size(max = 2)
    @Column(name = "uzytusuario_DPTO_ABREV_CODE", length = 2)
    private String uzytusuario_DPTO_ABREV_CODE;


    //RELACIÓN CON LA TABLA ANEXOSPR-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavAnexoSPR> modelUzyTavAnexoSPRSet = new LinkedHashSet<>();

    //RELACIÓN CON LA TABLA COORDINADOR_VINCULACIÓN- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavCoordinadorVincu> modelUzyTavCoordinadorVincuSet = new LinkedHashSet<>();

    //RELACIÓN CON LA TABLA RESPONSABLEPROG MEDIANTE EL CAMPO uzytusuario_id_docente-TABLA HIJA,
    @JsonIgnore
    @OneToMany(mappedBy = "iddocente")
    private Set<ModelUzyTavResponsableProg> modelUzyTavResponsableProgSet = new LinkedHashSet<>();
    //RELACIÓN CON PROYECTO-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavProyec> modelUzyTavProyecSet = new LinkedHashSet<>();

    //RELACION CON DESIGDOC-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavDesigDoc> modelUzyTavDesigDocSet = new LinkedHashSet<>();

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuarioAsignado")
    private Set<ModelUzyTavDesigDoc> modelUzyTavDesigDocSetAsignado = new LinkedHashSet<>();

    //RELACION CON DESIGESTU-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavDesigEstu> modelUzyTavDesigEstuSet = new LinkedHashSet<>();

    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuarioAsignado")
    private Set<ModelUzyTavDesigEstu> modelUzyTavDesigEstuSetAsignado = new LinkedHashSet<>();

    //RELACIÓN CON PROGRAMA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytusuario")
    private Set<ModelUzyTavPrograma_V> modelUzyTavProgramaVSet = new LinkedHashSet<>();

    //RELACIÓN CON PERFIL

    @ManyToMany(fetch = FetchType.EAGER)
    @JoinTable(name = "UZYTPERFIL_USUARIO",
            joinColumns = @JoinColumn(name = "UZYTUSUARIO_ID"),
            inverseJoinColumns = @JoinColumn(name = "UZYTPERFIL_ID"))
    private Set<ModelUzyTPerfil> uzytperfils = new LinkedHashSet<>();

}
