package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavalorpar", schema = "UTIC1")
public class ModelUzyTaValorPar {


    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavaloruzytparametros_seq")
    @SequenceGenerator(name = "uzytavaloruzytparametros_seq", sequenceName = "SEQ_UZYTARAVALORPAR", allocationSize = 1)
    @Column(name = "uzytavaloruzytparametros_id")
    private Long uzytavaloruzytparametros_id;
    @Size(max = 1000)
    @Column(name = "uzytavalorpar_descrip", length = 1000)
    private String uzytavalorpar_descrip;

    @Column(name = "uzytavalorpar_puntaje")
    private Integer uzytavalorpar_puntaje;

    @Column(name = "uzytavalorpar_orden")
    private Integer uzytavalorpar_orden;


    //RELACIÓN CON TAVPARAEVA- TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavparaeva_id", referencedColumnName = "uzytavparaeva_id")
    private ModelUzyTavParaEva uzyTavParaEva;

    //RELACIÓN CON LA TABLA EVALPROY-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavalorpar")
    private Set<ModelUzyTavEvalProy> modelUzyTavEvalProySet = new LinkedHashSet<>();

}
