package ec.edu.espe.movilidad.MovilidadWS.Model;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "UZYTAVACTPROY", schema = "UTIC1")
public class ModelUzyTavActProy {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavactproy_seq")
    @SequenceGenerator(name = "uzytavactproy_seq", sequenceName = "SEQ_UZYTAVACTPROY", allocationSize = 1)
    @Column(name = "uzytavactproy_id")
    private Long uzytavactproy_id;

    @Column(name = "uzytavactproy_fech_regis")
    private LocalDate uzytavactproy_fech_regis;

    @Size(max = 500)
    @Column(name = "uzytavactproy_observa", length = 500)
    private String uzytavactproy_observa;

    //RELACIÓN CON ModelUzytavObjetivoPrograma- TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavobjetivo_programa_id")
    private ModelUzytavObjetivoPrograma uzytavobjetivoPrograma;

    //RELACIÓN CON Proyecto - TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;
    //RELACIÓN CON ModelUzyTavDetActproy- TABLA PADRE
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavactproy", cascade = CascadeType.ALL)
    private Set<ModelUzyTavDetActproy> uzytavdetactproys = new LinkedHashSet<>();
}
