package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavactaprueba", schema = "UTIC1")
public class ModelUzyTavActaPrueba {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavactaprueba_seq")
    @SequenceGenerator(name = "uzytavactaprueba_seq", sequenceName = "SEQ_UZYTAVACTAPRUEBA", allocationSize = 1)
    @Column(name = "uzytavactaprueba_id")
    private Long uzytavactaprueba_id;

    @Column(name = "uzytusuario_id_aprueba")
    private Long uzytusuario_id_aprueba;

    @Column(name = "uzytavactaprueba_fecha_aprueba")
    private LocalDate uzytavactaprueba_fecha_aprueba;

    @Column(name = "uzytavactaprueba_secuencial_a")
    private Long uzytavactaprueba_secuencial_a;
    @Size(max = 1)
    @Column(name = "uzytavactaprueba_cerrado", length = 1)
    private String uzytavactaprueba_cerrado;
    @Size(max = 100)
    @Column(name = "uzytavactaprueba_doc_nom", length = 100)
    private String uzytavactaprueba_doc_nom;
    @Size(max = 250)
    @Column(name = "uzytavactaprueba_doc_url", length = 250)
    private String uzytavactaprueba_doc_url;


    //RELACION CON PROYECTO - tabla HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzyTavacAprueba")
    private Set<ModelUzyTavProyec> modelUzyTavProyecSet = new LinkedHashSet<>();

}
