package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import java.util.LinkedHashSet;
import java.util.Set;
import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@Table(name = "uzytavactaresponsa", schema = "UTIC1")
public class ModelUzyTavActaResponsa {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavactaresponsa_seq")
    @SequenceGenerator(name = "uzytavactaresponsa_seq", sequenceName = "SEQ_UZYTAVACTARESPONSA", allocationSize = 1)
    @Column(name = "uzytavactaresponsa_code")
    private Long uzytavactaresponsa_code;

    @Column(name = "uzytavactaresponsa_secuencial")
    private Integer uzytavactaresponsa_secuencial;

    @Column(name = "uzytavactaresponsa_fecha_crea")
    private LocalDateTime uzytavactaresponsa_fecha_crea;

    @Column(name = "uzytusuario_id_crea")
    private Integer uzytusuario_id_crea;
    @Size(max = 1)
    @Column(name = "uzytavactaresponsa_cerrado", length = 1)
    private String uzytavactaresponsa_cerrado;
    @Size(max = 250)
    @Column(name = "uzytavactaresponsa_doc_nom", length = 250)
    private String uzytavactaresponsa_doc_nom;
    @Size(max = 100)
    @Column(name = "uzytavactaresponsa_doc_url", length = 100)
    private String uzytavactaresponsa_doc_url;

    //RELACIÓN CON LA TABLA RESPONSABLE_PROG-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavactaresponsa")
    private Set<ModelUzyTavResponsableProg> modelUzyTavResponsableProgSet = new LinkedHashSet<>();

}
