package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.math.BigDecimal;

import java.time.LocalDate;

@Getter
@Setter
@Entity
@Table(name = "UZYTAVACTIVPROG", schema = "UTIC1")
public class ModelUzyTavActivProg {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavactiproy_seq")
    @SequenceGenerator(name = "uzytavactiproy_seq", sequenceName = "SEQ_UZYTAVACTIVPROG", allocationSize = 1)
    @Column(name = "uzytavactivprog_id")
    private Long uzytavactivprog_id;

    //RELACIÓN CON PROGRAMA-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavprograma_v_id")
    private ModelUzyTavPrograma_V uzytavprograma_v;

    //RELACIÓN CON PROYECTO-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;

    @Size(max = 500)
    @Column(name = "uzytavactivprog_descripcion", length = 500)
    private String uzytavactivprog_descripcion;

    @Column(name = "uzytavactivprog_fecha_ini")
    private LocalDate uzytavactivprog_fecha_ini;

    @Column(name = "uzytavactivprog_fecha_fin")
    private LocalDate uzytavactivprog_fecha_fin;

    @Column(name = "uzytavactivprog_presupuesto", precision = 8, scale = 2)
    private BigDecimal uzytavactivprog_presupuesto;

    @Column(name = "uzytavactivprog_beneficiarios")
    private Integer uzytavactivprog_beneficiarios;

    @Column(name = "uzytavactivprog_anio")
    private Long uzytavactivprog_anio;

    @Column(name = "uzytavactivprog_presupuesto2", precision = 8, scale = 2)
    private BigDecimal uzytavactivprog_presupuesto2;


}
