package ec.edu.espe.movilidad.MovilidadWS.Model;


import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;


@Getter
@Setter
@Entity
@Table(name = "uzytavanexospr", schema = "UTIC1")
public class ModelUzyTavAnexoSPR {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavanexospr_seq")
    @SequenceGenerator(name = "uzytavanexospr_seq", sequenceName = "SEQ_UZYTAVANEXOSPR", allocationSize = 1)
    @Column(name = "uzytavanexospr_id")
    private Long uzytavanexospr_id;
    @Size(max = 100)
    @Column(name = "uzytavanexospr_nombre", length = 100)
    private String uzytavanexospr_nombre;
    @Size(max = 250)
    @Column(name = "uzytavanexospr_url", length = 250)
    private String uzytavanexospr_url;

    @Column(name = "uzytavanexospr_fech_subida")
    private LocalDateTime uzytavanexospr_fech_subida;

    @Column(name = "uzytavanexospr_tipo")
    private Integer uzytavanexospr_tipo;

    @Column(name = "uzytavprograma_v_id")
    private Long uzytavprograma_v_id;

    @Column(name = "uzytavanexospr_digital", columnDefinition = "BLOB")
    private byte[] uzytavanexospr_digital;
    @Size(max = 500)
    @Column(name = "uzytavanexospr_descripcion", length = 500)
    private String uzytavanexospr_descripcion;
    //RELACION CON PROYEC-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;

    //RELACIÓN CON USUARIO-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytusuario_id")
    private ModelUzyTUsuario uzytusuario;

}
