package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;

@Getter
@Setter
@Entity
@Table(name = "uzytavanualvalor", schema = "utic1")
public class ModelUzyTavAnualValor {

    @Id
    @SequenceGenerator(name = "uzytavanualvalor_seq", sequenceName = "SEQ_UZYTAVANUALVALOR", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavanualvalor_seq")
    @Column(name = "uzytavanualvalor_id")
    private Long uzytavanualvalor_id;
    @Size(max = 100)
    @Column(name = "uzytavanualvalor_desc", length = 100)
    private String uzytavanualvalor_desc;

    @Column(name = "uzytavanualvalor_valor", precision = 8, scale = 2)
    private Double uzytavanualvalor_valor;

    //RELACIÓN TAVPRESUP-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY )
    @JoinColumn(name = "uzytavpresup_id", referencedColumnName = "uzytavpresup_id")
    private ModelUzyTavPresup uzytavpresup;

}
