package ec.edu.espe.movilidad.MovilidadWS.Model;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavcabcomca", schema = "UTIC1")
public class ModelUzyTavCabComca {


    @Id
    @SequenceGenerator(name = "uzytavcabcomca_seq", sequenceName = "SEQ_UZYTAVCABCOMCA", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavcabcomca_seq")
    @Column(name = "uzytavcabcomca_id")
    private Long uzytavcabcomca_id;
    @Size(max = 500)
    @Column(name = "uzytavcabcomca_decsrip", length = 500)
    private String uzytavcabcomca_decsrip;

    @Column(name = "uzytavcabcomca_fech_crea")
    private LocalDate uzytavcabcomca_fech_crea;


    //RELACION CON PROYECT- cabcomca es el padre
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavcabcomca")
    private Set<ModelUzyTavProyec> modelUzyTavProyecs = new LinkedHashSet<>();

    //RELACION CON DETCOMCA-Tabla Hija

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavcabcomca")
    private Set<ModelUzyTavDetComca> modelUzyTavDetComcas = new LinkedHashSet<>();

    //RELACIÓN CON CONSOLCA- TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconsolca_id")
    private ModelUzyTavConsolca uzytavconsolca;
}
