package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDate;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavcabevalp", schema = "UTIC1")
public class ModelUzyTavCabeValp {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavcabevalp_seq")
    @SequenceGenerator(name = "uzytavcabevalp_seq", sequenceName = "SEQ_UZYTAVCABEVALP", allocationSize = 1)
    @Column(name = "uzytavcabevalp_id")
    private Long uzytavcabevalp_id;

    @Column(name = "uzytavcabevalp_fec_crea")
    private LocalDate uzytavcabevalp_fec_crea;
    @Size(max = 1000)
    @Column(name = "uzytavcabevalp_observa", length=1000)
    private String uzytavcabevalp_observa;

    @Column(name = "uzytusuario_id")
    private Long uzytusuario_id;
    @Size(max = 1)
    @Column(name = "uzytavcabevalp_estadofin", length = 1)
    private String uzytavcabevalp_estadofin;
    @Size(max = 1)
    @Column(name = "uzytavproyec_cumple_req", length = 1)
    private String uzytavproyec_cumple_req;

    //RELACION CON PROYECT- TABLA PADRE
    @ManyToOne
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;

    //RELACIÓN CON CONSOLCA- TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconsolca_id")
    private ModelUzyTavConsolca uzytavconsolca;

    //RELACIÓN CON LA TABLA uzytavconsolca_id- TABLA PADRE


    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavdetcomca_id")
    private ModelUzyTavDetComca uzytavdetcomca;

    //RELACIÓN CON LA TABLA VALPROY- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavcabevalp")
    private Set<ModelUzyTavEvalProy> modelUzyTavEvalProySet = new LinkedHashSet<>();


}
