package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavclaspre", schema = "UTIC1")
public class ModelUzyTavClasPre {

    @Id
    @SequenceGenerator(name = "uzytavclaspre_seq", sequenceName = "SEQ_UZYTAVCLASPRE", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavclaspre_seq")
    @Column(name = "uzytavclaspre_id")
    private Long uzytavclaspre_id;
    @Size(max = 1)
    @Column(name = "uzytavclaspre_estado", length = 1)
    private String uzytavclaspre_estado;
    @Size(max = 1)
    @Column(name = "uzytavclaspre_tipo", length = 1)
    private String uzytavclaspre_tipo;


    //RELACIÓN CON CLASIFICADOR_PRESUP-TABLA PADRE

    @ManyToOne( fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytclasificador_presup_id", referencedColumnName = "uzytclasificador_presup_id")
    private ModelUzyTClasificadorPresup uzytclasificador_presup;

    //RELACION CON TAVPRESUP- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavclaspre")
    private Set<ModelUzyTavPresup> modelUzyTavPresupSet = new LinkedHashSet<>();


}
