package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavconfobj")
public class ModelUzyTavConfObj {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavconfobj_seq")
    @SequenceGenerator(name = "uzytavconfobj_seq", sequenceName = "SEQ_UZYTAVCONFOBJ", allocationSize = 1)
    @Column(name = "uzytavconfobj_id")
    private Long uzytavconfobj_id;

    @Size(max = 100)
    @Column(name = "uzytavconfobj_descripcion", length = 100)
    private String uzytavconfobj_descripcion;

    @Column(name = "uzytavconfobj_fecha")
    private Date uzytavconfobj_fecha;

    @Size(max = 1)
    @Column(name = "uzytavconfobj_estado", length = 1)
    private String uzytavconfobj_estado;

    //RELACIÓN CON uzytavconftipo TABLA HIJA
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconftipo_id")
    private ModelUzyTavConfTipo uzytavconftipo;


    //RELACIÓN CON OBJETIVOS DEL BUEN VIVIR-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconfobj")
    private Set<ModelUzyTavObjetivoBVivir> uzyTavObjetivoBVivirSet = new LinkedHashSet<>();


    //RELACIÓN CON

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconfobj")
    private Set<ModelUzyTavObjetivosEstraInsti> uzyTavObjetivosEstraInstiSet = new LinkedHashSet<>();
}
