package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;
import java.util.LinkedHashSet;
import java.util.Set;


//TABLA PADRE CON LAS TABLAS PARAEVA Y PARAEVAF
@Getter
@Setter
@Entity
@Table(name = "uzytavconparaeva", schema = "UTIC1")
public class ModelUzyTavConparaEva {

    @Id
    @SequenceGenerator(name = "uzytavconparaeva_seq", sequenceName = "SEQ_UZYTAVCONPARAEVA", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavconparaeva_seq")
    @Column(name = "uzytavconparaeva_id")
    private Long uzytavconparaeva_id;


    @Column(name = "uzytavconparaeva_fecha_c")
    private LocalDateTime uzytavconparaeva_fecha_c;
    @Size(max = 100)
    @Column(name = "uzytavconparaeva_descrip", length = 100)
    private String uzytavconparaeva_descrip;

    @Column(name = "uzytavconparaeva_puminire")
    private Integer uzytavconparaeva_puminire;

    @Column(name = "uzytavconparaeva_tipo")
    private Integer uzytavconparaeva_tipo;
    @Size(max = 1)
    @Column(name = "uzytavconparaeva_estado", length = 1)
    private String uzytavconparaeva_estado;


    //RELACION CON PROYECTP de uno a muchos
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconparaeva")
    private Set<ModelUzyTavProyec> modelUzyTavProyecs = new LinkedHashSet<>();

    //RELACION CON PARAEVAF

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconparaeva")
    private Set<ModelUzyTavCabParaevaf> modelUzyTavCabParaevafSet = new LinkedHashSet<>();

    //RELACION CON PARAEVA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconparaeva")
    private Set<ModelUzyTavParaEva> uzytavparaevaSet = new LinkedHashSet<>();


}
