package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavconvoca", schema = "UTIC1")
public class ModelUzyTavConvoca {

    @Id
    @SequenceGenerator(name = "uzytavconvoca_seq", sequenceName = "SEQ_UZYTAVCONVOCA", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavconvoca_seq")
    @Column(name = "uzytavconvoca_id")
    private Long uzytavconvoca_id;

    @Size(max = 100)
    @Column(name = "uzytavconvoca_nombre", length = 100)
    private String uzytavconvoca_nombre;

    @Column(name = "uzytavconvoca_digital", columnDefinition = "BLOB")
    private byte[] uzytavconvoca_digital;

    @Size(max = 150)
    @Column(name = "uzytavconvoca_observacion", length = 150)
    private String uzytavconvoca_observacion;

    @Size(max = 1)
    @Column(name = "uzytavconvoca_estado", length = 1)
    private String uzytavconvoca_estado;

    @Column(name = "uzytavconvoca_fecha_inicio")
    private Date uzytavconvoca_fecha_inicio;

    @Column(name = "uzytavconvoca_fecha_fin")
    private Date uzytavconvoca_fecha_fin;

    @Size(max = 100)
    @Column(name = "uzytavconvoca_digital_nombre", length = 100)
    private String uzytavconvoca_digital_nombre;

    @Size(max = 250)
    @Column(name = "uzytavconvoca_digital_url", length = 250)
    private String uzytavconvoca_digital_url;

    @Size(max = 250)
    @Column(name = "uzytavconvoca_id_file", length = 250)
    private String uzytavconvoca_id_file;


    //RELACION CON PROYECTO-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavconvoca")
    private Set<ModelUzyTavProyec> modelUzyTavProyecSet = new LinkedHashSet<>();
}
