package ec.edu.espe.movilidad.MovilidadWS.Model;
import lombok.Getter;
import lombok.Setter;
import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@Table(name = "UZYTAVDESIGDOC", schema = "UTIC1")
public class ModelUzyTavDesigDoc {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavdesigdoc_seq")
    @SequenceGenerator(name = "uzytavdesigdoc_seq", sequenceName = "SEQ_UZYTAVDESIGDOC", allocationSize = 1)
    @Column(name = "uzytavdesigdoc_ID")
    private Long uzytavdesigdoc_ID;

    @ManyToOne( fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_ID")
    private ModelUzyTavProyec uzytavproyec;
    @Size(max = 9)
    @Column(name = "spriden_ID", length = 9)
    private String spriden_ID;
    @Size(max = 100)
    @Column(name = "uzytavdesigdoc_FUNCION", length = 100)
    private String uzytavdesigdoc_FUNCION;

    @Column(name = "uzytavdesigdoc_HORAS_PLANIFICADAS")
    private Integer uzytavdesigdoc_HORAS_PLANIFICADAS;

    @Column(name = "uzytavdesigdoc_NRO_ACTA")
    private Integer uzytavdesigdoc_NRO_ACTA;

    @Column(name = "uzytavdesigdoc_FECHA_INICIO")
    private LocalDateTime uzytavdesigdoc_FECHA_INICIO;
    @Column(name = "uzytavdesigdoc_FECHA_FIN")
    private LocalDateTime uzytavdesigdoc_FECHA_FIN;
    @Column(name = "uzytavdesigdoc_HORAS_DEDICADAS")
    private Integer uzytavdesigdoc_HORAS_DEDICADAS;

    @Column(name = "uzytavdesigdoc_FECHA_REGISTRO")
    private LocalDateTime uzytavdesigdoc_FECHA_REGISTRO;
    @Size(max = 250)
    @Column(name = "uzytavdesigdoc_ACTA_CREADA", length = 250)
    private String uzytavdesigdoc_ACTA_CREADA;
    @Size(max = 250)
    @Column(name = "uzytavdesigdoc_ACTA_SUBIDA", length = 250)
    private String uzytavdesigdoc_ACTA_SUBIDA;
    @Size(max = 1)
    @Column(name = "uzytavdesigdoc_ESTADO_ACTA", length = 1)
    private String uzytavdesigdoc_ESTADO_ACTA;

    @ManyToOne( fetch = FetchType.LAZY)
    @JoinColumn(name = "desigdoc_uzytusuario_ID")
    private ModelUzyTUsuario uzytusuario;

    @ManyToOne( fetch = FetchType.LAZY)
    @JoinColumn(name = "desigdoc_uzytusuario_ID_ASIGNADO")
    private ModelUzyTUsuario uzytusuarioAsignado;
    @Size(max = 2)
    @Column(name = "desigdoc_UZYTUSUARIO_CAMPUS_ABREV_CODE", length = 2)
    private String desigdoc_UZYTUSUARIO_CAMPUS_ABREV_CODE;
    @Size(max = 2)
    @Column(name = "desigdoc_UZYTUSUARIO_DPTO_ABREV_CODE", length = 2)
    private String desigdoc_UZYTUSUARIO_DPTO_ABREV_CODE;
    @Size(max = 4)
    @Column(name = "desigdoc_UZYTUSUARIO_DEPARTAMENTO_CODE", length = 4)
    private String desigdoc_UZYTUSUARIO_DEPARTAMENTO_CODE;

    @Size(max = 3)
    @Column(name = "desigdoc_UZYTUSUARIO_CAMPUS_CODE", length = 3)
    private String desigdoc_UZYTUSUARIO_CAMPUS_CODE;

}
