package ec.edu.espe.movilidad.MovilidadWS.Model;

import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@Table(name = "UZYTAVDESIGESTU", schema = "UTIC1")
public class ModelUzyTavDesigEstu {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavdesigestu_seq")
    @SequenceGenerator(name = "uzytavdesigestu_seq", sequenceName = "SEQ_UZYTAVDESIGESTU", allocationSize = 1)
    @Column(name = "uzytavdesigestu_ID")
    private Long uzytavdesigestu_ID;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_ID")
    private ModelUzyTavProyec uzytavproyec;

    @Size(max = 9)
    @Column(name = "spriden_ID", length = 9)
    private String spriden_ID;
    @Size(max = 100)
    @Column(name = "uzytavdesigestu_FUNCION", length = 100)
    private String uzytavdesigestu_FUNCION;

    @Column(name = "uzytavdesigestu_HORAS_PLANIFICADAS")
    private Integer uzytavdesigestu_HORAS_PLANIFICADAS;

    @Column(name = "uzytavdesigestu_NRO_ACTA")
    private Integer uzytavdesigestu_NRO_ACTA;

    @Column(name = "uzytavdesigestu_FECHA_INICIO")
    private LocalDateTime uzytavdesigestu_FECHA_INICIO;
    @Column(name = "uzytavdesigestu_FECHA_FIN")
    private LocalDateTime uzytavdesigestu_FECHA_FIN;
    @Column(name = "uzytavdesigestu_HORAS_DEDICADAS")
    private Integer uzytavdesigestu_HORAS_DEDICADAS;
    @Column(name = "uzytavdesigestu_FECHA_REGISTRO")
    private LocalDateTime uzytavdesigestu_FECHA_REGISTRO;
    @Size(max = 250)
    @Column(name = "uzytavdesigestu_ACTA_CREADA", length = 250)
    private String uzytavdesigestu_ACTA_CREADA;
    @Size(max = 250)
    @Column(name = "uzytavdesigestu_ACTA_SUBIDA", length = 250)
    private String uzytavdesigestu_ACTA_SUBIDA;
    @Size(max = 1)
    @Column(name = "uzytavdesigestu_ESTADO_ACTA", length = 1)
    private String uzytavdesigestu_ESTADO_ACTA;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "desigestu_uzytusuario_ID")
    private ModelUzyTUsuario uzytusuario;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "desigestu_uzytusuario_ID_ASIGNADO")
    private ModelUzyTUsuario uzytusuarioAsignado;

    @Size(max = 2)
    @Column(name = "desigestu_UZYTUSUARIO_CAMPUS_ABREV_CODE", length = 2)
    private String desigestu_UZYTUSUARIO_CAMPUS_ABREV_CODE;
    @Size(max = 2)
    @Column(name = "desigestu_UZYTUSUARIO_DPTO_ABREV_CODE", length = 2)
    private String desigestu_UZYTUSUARIO_DPTO_ABREV_CODE;
    @Size(max = 4)
    @Column(name = "desigestu_UZYTUSUARIO_DEPARTAMENTO_CODE", length = 4)
    private String desigestu_UZYTUSUARIO_DEPARTAMENTO_CODE;
    @Size(max = 3)
    @Column(name = "desigestu_UZYTUSUARIO_CAMPUS_CODE", length = 3)
    private String desigestu_UZYTUSUARIO_CAMPUS_CODE;
}
