package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavdetcomca", schema = "UTIC1")
public class ModelUzyTavDetComca {
    @Id
    @SequenceGenerator(name = "uzytavdetcomca_seq", sequenceName = "SEQ_UZYTAVDETCOMCA", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavdetcomca_seq")
    @Column(name = "uzytavdetcomca_id")
    private Long uzytavdetcomca_id;

    @Column(name = "uzytusuario_id_crea")
    private Long uzytusuario_id_crea;

    @Column(name = "uzytusuario_id_asignado")
    private Long uzytusuario_id_asignado;

    @Column(name = "uzytavdetcomca_fech_crea")
    private Date uzytavdetcomca_fech_crea;

    @Column(name = "uzytavdetcomca_estado")
    private String uzytavdetcomca_estado;

    //Relacion con la tabla CabComca-Tabla padre
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavcabcomca_id")
    private ModelUzyTavCabComca uzytavcabcomca;

    //RELACIÓN CON LA TABLA uzytavcabevalp- TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavdetcomca")
    private Set<ModelUzyTavCabeValp> modelUzyTavCabeValpSet = new LinkedHashSet<>();

}
