package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@Table(name = "uzytavdocompar", schema = "UTIC1")
public class ModelUzyTavDoCompar {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavdocompar_seq")
    @SequenceGenerator(name = "uzytavdocompar_seq", sequenceName = "SEQ_UZYTAVDOCOMPAR", allocationSize = 1)
    @Column(name = "uzytavdocompar_code")
    private Long uzytavdocompar_code;

    //RELACIÓN CON ModelUzyTavInstProy TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavinstproy_id")
    private ModelUzyTavInstProy uzytavinstproy;

    @Size(max = 100)
    @Column(name = "uzytavdocompar_nombre_doc", length = 100)
    private String uzytavdocompar_nombre_doc;

    @Size(max = 100)
    @Column(name = "uzytavdocompar_nombre_url", length = 100)
    private String uzytavdocompar_nombre_url;

    @Column(name = "uzytavdocompar_fecha_crea")
    private LocalDateTime uzytavdocompar_fecha_crea;
}
