package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;

@Getter
@Setter
@Entity
@Table(name = "uzytavevalproy", schema = "UTIC1")
public class ModelUzyTavEvalProy {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavevalproy_seq")
    @SequenceGenerator(name = "uzytavevalproy_seq", sequenceName = "SEQ_UZYTAVEVALPROY", allocationSize = 1)
    @Column(name = "uzytavevalproy_id")
    private Long uzytavevalproy_id;

    @Column(name = "uzytavevalproy_puntaje")
    private Integer uzytavevalproy_puntaje;


    @Column(name = "uzytavparaeva_id")
    private Long uzytavparaeva_id;

    @Size(max = 250 )
    @Column(name = "uzytavevalproy_observ", length = 250)
    private String uzytavevalproy_observ;

    //RELACION CON CABEVALP-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavcabevalp_id", referencedColumnName = "uzytavcabevalp_id")
    private ModelUzyTavCabeValp uzytavcabevalp;


    //RELACIÓN CON PARAMETROS_ID- TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavaloruzytparametros_id", referencedColumnName = "uzytavaloruzytparametros_id")
    private ModelUzyTaValorPar uzytavalorpar;
}
