package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.math.BigDecimal;
import java.time.LocalDateTime;

@Getter
@Setter
@Entity
@Table(name = "uzytavhorejec", schema = "UTIC1")
public class ModelUzyTavHorEjec {

    @Id
    @SequenceGenerator(name = "uzytavhorejec_seq", sequenceName = "SEQ_UZYTAVHOREJEC", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavhorejec_seq")
    @Column(name = "uzytavhorejec_code")
    private Long uzytavhorejec_code;
    @Column(name = "uzytavhorejec_fec_ini")
    private LocalDateTime uzytavhorejec_fec_ini;

    @Column(name = "uzytavhorejec_fec_fin")
    private LocalDateTime uzytavhorejec_fec_fin;

    @Column(name = "uzytavhorejec_total", precision = 22, scale = 2)
    private BigDecimal uzytavhorejec_total;

    @Column(name = "uzytavhorejec_calificacion", precision = 22, scale = 2)
    private BigDecimal uzytavhorejec_calificacion;

    //RELACIÓN CON RESPONSABLE PROGRAMA-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavresponsable_prog_id")
    private ModelUzyTavResponsableProg uzytavresponsable_prog;
}
