package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.time.LocalDateTime;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavinstproy", schema = "UTIC1")
public class ModelUzyTavInstProy {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavinstproy_seq")
    @SequenceGenerator(name = "uzytavinstproy_seq", sequenceName = "SEQ_UZYTAVINSTPROY", allocationSize = 1)
    @Column(name = "uzytavinstproy_id")
    private Long uzytavinstproy_id;

    //RELACION CON PROYECTO- TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;


    //RELACION CON TavInstituc- TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavinstituc_id")
    private ModelUzyTavInstituc uzytavinstituc;

    //RELACIÓN CON PARAMETROS_DET- TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytparametros_det_id_organizacion")
    private ModelUzyTavParametros_Det uzytparametrosDetIdOrganizacion;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytparametros_det_id_entidad")
    private ModelUzyTavParametros_Det uzytparametrosDetIdEntidad;

    @Size(max = 100)
    @Column(name = "uzytavinstproy_detaotro", length = 100)
    private String uzytavinstproy_detaotro;

    @Size(max = 2000)
    @Column(name = "uzytavinstproy_declaracion", length = 2000)
    private String uzytavinstproy_declaracion;

    @Column(name = "uzytavinstproy_fecha_crea")
    private LocalDateTime uzytavinstproy_fecha_crea;

    @Column(name = "uzytavinstproy_dir_hombres")
    private Integer uzytavinstproy_dir_hombres;

    @Column(name = "uzytavinstproy_dir_mujeres")
    private Integer uzytavinstproy_dir_mujeres;

    @Column(name = "uzytavinstproy_dir_ninios")
    private Integer uzytavinstproy_dir_ninios;

    @Column(name = "uzytavinstproy_dir_discapacidad")
    private Integer uzytavinstproy_dir_discapacidad;

    @Column(name = "uzytavinstproy_indirectos")
    private Integer uzytavinstproy_indirectos;

    @Size(max = 150)
    @Column(name = "uzytavinstproy_desc_benefic", length = 150)
    private String uzytavinstproy_desc_benefic;

    @Column(name = "uzytavinstproy_DIRECTOS")
    private Integer uzytavinstproy_DIRECTOS;

    @Column(name = "uzytavinstproy_TOTAL")
    private Integer uzytavinstproy_TOTAL;

    //RELACIÓN CON uzytavinstproy- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavinstproy")
    private Set<ModelUzyTavDoCompar> uzyTavDoComparSet = new LinkedHashSet<>();

}
