package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavinstituc", schema = "UTIC1")
public class ModelUzyTavInstituc {
    @Id
    @SequenceGenerator(name = "uzytavinstituc_seq", sequenceName = "SEQ_UZYTAVINSTITUC", allocationSize = 1)
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavinstituc_seq")
    @Column(name = "uzytavinstituc_id")
    private Long uzytavinstituc_id;
    @Size(max = 1000)
    @Column(name = "uzytavinstituc_nombre", length = 1000)
    private String uzytavinstituc_nombre;
    @Size(max = 200)
    @Column(name = "uzytavinstituc_calle", length = 200)
    private String uzytavinstituc_calle;
    @Size(max = 30)
    @Column(name = "uzytavinstituc_telefono", length = 30)
    private String uzytavinstituc_telefono;
    @Size(max = 200)
    @Column(name = "uzytavinstituc_nomrepl", length = 200)
    private String uzytavinstituc_nomrepl;
    @Size(max = 100)
    @Column(name = "uzytavinstituc_cargorl", length = 100)
    private String uzytavinstituc_cargorl;
    @Size(max = 200)
    @Column(name = "uzytavinstituc_apellirl",length = 200)
    private String uzytavinstituc_apellirl;
    @Size(max = 30)
    @Column(name = "uzytavinstituc_telrepl", length = 30)
    private String uzytavinstituc_telrepl;
    @Size(max = 50)
    @Column(name = "uzytavinstituc_mailrl1", length = 50)
    private String uzytavinstituc_mailrl1;

    @Column(name = "uzytavinstituc_fecha_crea")
    private Date uzytavinstituc_fecha_crea;
    @Size(max = 1)
    @Column(name = "uzytavinstituc_estado", length = 1)
    private String uzytavinstituc_estado;

    //RELACIÓN CON PARROQUIA-TABLA PADRE
    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "uzytparroquia_id", referencedColumnName = "uzytparroquia_id")
    private ModelUzyTParroquia uzytparroquia;



    //RELACIÓN CON ModelUzyTavInstProy TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavinstituc")
    private Set<ModelUzyTavInstProy> modelUzyTavInstProySet = new LinkedHashSet<>();
}
