package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "UZYTAVLINEA", schema = "UTIC1")
public class ModelUzyTavLinea {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavlinea_seq")
    @SequenceGenerator(name = "uzytavlinea_seq", sequenceName = "SEQ_UZYTAVLINEA", allocationSize = 1)
    @Column(name = "uzytavlinea_ID")
    private Long uzytavlinea_ID;

    @Size(max = 250)
    @Column(name = "uzytavlinea_DESCRIPCION", length = 250)
    private String uzytavlinea_DESCRIPCION;


    //RELACIÓN CON SubLinea-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "UZYTAVLINEA")
    private Set<ModelUzyTavSubLinea> modelUzyTavSubLineaSet  = new LinkedHashSet<>();

}
