package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavobjetivo_b_vivir")
public class ModelUzyTavObjetivoBVivir {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavobjetivo_b_vivir_seq")
    @SequenceGenerator(name = "uzytavobjetivo_b_vivir_seq", sequenceName = "SEQ_UZYTAVOBJETIVO_B_VIVIR", allocationSize = 1)
    @Column(name = "uzytavobjetivo_b_vivir_id")
    private Long uzytavobjetivo_b_vivir_id;

    @Size(max = 500)
    @Column(name = "uzytavobjetivo_b_vivirdescripcion", length = 500)
    private String uzytavobjetivo_b_vivirdescripcion;

    @Column(name = "uzytavobjetivo_b_vivirorden")
    private Long uzytavobjetivo_b_vivirorden;

    //RELACIÓN CON UzyTavConfObj TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconfobj_id")
    private ModelUzyTavConfObj uzytavconfobj;

    //RELACIÓN PADRE CONSIGO MISMA

    @ManyToOne(fetch = FetchType.EAGER)
    @JoinColumn(name = "uzytavobjetivo_b_vivirid_padre", referencedColumnName = "uzytavobjetivo_b_vivir_id")
    private ModelUzyTavObjetivoBVivir uzytavobjetivo_b_vivir;

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavobjetivo_b_vivir")
    private Set<ModelUzyTavObjetivoBVivir> modelUzyTavObjetivoBVivirSet = new LinkedHashSet<>();

    //RELACION CON UzyTavProgObj TABLA HIJA

    @OneToMany(mappedBy = "uzytavobjetivo_b_vivir")
    private Set<ModelUzyTavProgObj> modelUzyTavProgObjSet = new LinkedHashSet<>();
}
