package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;
import javax.persistence.*;
import java.util.Date;

@Getter
@Setter
@Entity
@Table(name = "uzytavopcion_institucion", schema = "UTIC1")
public class ModelUzyTavOpcionInstitucion {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavopcion_institucion_seq")
    @SequenceGenerator(name = "uzytavopcion_institucion_seq", sequenceName = "SEQ_UZYTAVOPCION_INSTITUCION", allocationSize = 1)
    @Column(name = "uzytavopcion_institucion_id")
    private Long uzytavopcion_institucion_id;

    @Column(name = "uzytavopcion_institucionorden")
    private Integer uzytavopcion_institucionorden;

    @Column(name = "uzytavopcion_institucionnombre", length = 100)
    private String uzytavopcion_institucionnombre;

    @Column(name = "uzytavopcion_institucionfecha_crea")
    private Date uzytavopcion_institucionfecha_crea;

    @Column(name = "uzytavopcion_instituciondireccion", length = 100)
    private String uzytavopcion_instituciondireccion;

    @Column(name = "uzytavopcion_institucionciudad", length = 25)
    private String uzytavopcion_institucionciudad;

    @Column(name = "uzytavopcion_instituciontelefono", length = 15)
    private String uzytavopcion_instituciontelefono;

    @Column(name = "uzytavopcion_institucionpaguina_web", length = 25)
    private String uzytavopcion_institucionpaguina_web;

    @Column(name = "uzytavopcion_institucionmail", length = 25)
    private String uzytavopcion_institucionmail;

    @Column(name = "uzytavopcion_institucionfax", length = 15)
    private String uzytavopcion_institucionfax;

    @Column(name = "uzytavopcion_institucionrepresenta_legal", length = 50)
    private String uzytavopcion_institucionrepresenta_legal;

    @Column(name = "uzytavopcion_institucioncedula_rl", length = 10)
    private String uzytavopcion_institucioncedula_rl;

    @Column(name = "uzytavopcion_institucionorgano_ejecutor", length = 200)
    private String uzytavopcion_institucionorgano_ejecutor;

    //RELACIÓN CON PROGRAMA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavprograma_v_id")
    private ModelUzyTavPrograma_V uzytavprograma_v;

    //RELACIÓN CON PROVINCIA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytprovincia_id")
    private ModelUzyTProvincia uzytprovincia;

}
