package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.util.LinkedHashSet;
import java.util.Set;


@Getter
@Setter
@Entity
@Table(name = "uzytparametros_det", schema = "UTIC1")
public class ModelUzyTavParametros_Det {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytparametros_det_seq")
    @SequenceGenerator(name = "uzytparametros_det_seq", sequenceName = "SEQ_UZYPARAMETROS_DET", allocationSize = 1)
    @Column(name = "uzytparametros_det_id")
    private Long uzytparametros_det_id;

    //RELACIÓN CON PROYECTO MEDIANTE EL CAMPO PARAMETROS DET_ID- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytparametros_detID")
    private Set<ModelUzyTavProyec> modelUzyTavProyecs = new LinkedHashSet<>();

    @JsonIgnore
    @OneToMany(mappedBy = "uzytparametros_detCobertura")
    private Set<ModelUzyTavProyec> modelUzyTavProyecsC = new LinkedHashSet<>();

    @Column(name = "uzytparametros_det_id_alt")
    private String uzytparametros_det_id_alt;

    @Column(name = "uzytparametros_det_descripcion")
    private String uzytparametros_det_descripcion;

    @Column(name = "uzytparametros_det_estado")
    private String uzytparametros_det_estado;

    @Column(name = "uzytparametros_det_orden")
    private Integer uzytparametros_det_orden;

    //RELACIÓN CON UZYTAVINSTPROY TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytparametrosDetIdOrganizacion")
    private Set<ModelUzyTavInstProy> modelUzyTavInstProySetOrganizacion = new LinkedHashSet<>();


    @JsonIgnore
    @OneToMany(mappedBy = "uzytparametrosDetIdEntidad")
    private Set<ModelUzyTavInstProy> modelUzyTavInstProySetEntidad = new LinkedHashSet<>();


    //RELACIÓN CON POBLAPROY

    @JsonIgnore
    @OneToMany(mappedBy = "uzytparametros_det")
    private Set<ModelUzyTavPoblaProy> modelUzyTavPoblaProySet = new LinkedHashSet<>();
}
