package ec.edu.espe.movilidad.MovilidadWS.Model;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@Entity
@Table(name = "uzytavprog_obj")
public class ModelUzyTavProgObj {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavprog_obj_seq")
    @SequenceGenerator(name = "uzytavprog_obj_seq", sequenceName = "SEQ_UZYTAVPROG_OBJ", allocationSize = 1)
    @Column(name = "uzytavprog_obj_code")
    private Long uzytavprog_obj_code;

    //RELACION CON OBJETIVOS DEL BUEN VIVIR-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavobjetivo_b_vivir_id")
    private ModelUzyTavObjetivoBVivir uzytavobjetivo_b_vivir;

    //RELACIÓN CON PROGRAMA-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavprograma_v_id")
    private ModelUzyTavPrograma_V uzytavprograma_v;

    //RELACIÓN CON PROYECTO-TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;
}
