package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavprograma_v", schema = "UTIC1")
public class ModelUzyTavPrograma_V {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavprograma_seq")
    @SequenceGenerator(name = "uzytavprograma_seq", sequenceName = "SEQ_UZYTAVPROGRAMA", allocationSize = 1)
    @Column(name = "uzytavprograma_v_id")
    private Long uzytavprograma_v_id;

    @Size(max = 500)
    @Column(name = "uzytavprograma_vnombre", length = 500)
    private String uzytavprograma_vnombre;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vresumen", length = 3000)
    private String uzytavprograma_vresumen;


    @Column(name = "uzytavprograma_vfecha_presenta")
    private Date uzytavprograma_vfecha_presenta;

    @Column(name = "uzytavprograma_vfecha_inicio")
    private Date uzytavprograma_vfecha_inicio;

    @Column(name = "uzytavprograma_vfecha_fin")
    private Date uzytavprograma_vfecha_fin;

    @Size(max = 4)
    @Column(name = "stvsubj_code", length = 4)
    private String stvsubj_code;
    @Size(max = 25)
    @Column(name = "uzytavprograma_vmonto_nombre", length = 25)
    private String uzytavprograma_vmonto_nombre;

    @Lob
    @Column(name = "uzytavprograma_vmonto_digi")
    private Byte[] uzytavprograma_vmonto_digi;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vsituacion_actual", length = 3000)
    private String uzytavprograma_vsituacion_actual;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vmetas", length = 3000)
    private String uzytavprograma_vmetas;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vpoliticas", length = 3000)
    private String uzytavprograma_vpoliticas;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vviavilidad_tecnica", length = 3000)
    private String uzytavprograma_vviavilidad_tecnica;
    @Size(max = 3000)
    @Column(name = "uzytavprograma_vperderia_no_ejecuta", length = 3000)
    private String uzytavprograma_vperderia_no_ejecuta;
    @Size(max = 3000)
    @Column(name = "uzytavprograma_vresultados_impacto", length = 3000)
    private String uzytavprograma_vresultados_impacto;
    @Size(max = 25)
    @Column(name = "uzytavprograma_vproyecto_nombre", length = 25)
    private String uzytavprograma_vproyecto_nombre;

    @Lob
    @Column(name = "uzytavprograma_vproyecto_digi")
    private Byte[] uzytavprograma_vproyecto_digi;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vfactor_c_exito", length = 3000)
    private String uzytavprograma_vfactor_c_exito;
    @Size(max = 3000)
    @Column(name = "uzytavprograma_vubicacion", length = 3000)
    private String uzytavprograma_vubicacion;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vdiagnostico", length = 3000)
    private String uzytavprograma_vdiagnostico;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vlinea_base", length = 3000)
    private String uzytavprograma_vlinea_base;

    @Size(max = 3000)
    @Column(name = "uzytavprograma_vbeneficios", length = 3000)
    private String uzytavprograma_vbeneficios;

    @Column(name = "uzytavprograma_vduracion_anios")
    private Integer uzytavprograma_vduracion_anios;

    @Column(name = "uzytavprograma_vdiuracion_meses")
    private Integer uzytavprograma_vdiuracion_meses;
    @Size(max = 3)
    @Column(name = "stvcamp_code", length = 3)
    private String stvcamp_code;

    @Column(name = "uzytavprograma_vfecha_finr")
    private Date uzytavprograma_vfecha_finr;

    @Size(max = 4)
    @Column(name = "uzytavprograma_vestado", length = 4)
    private String uzytavprograma_vestado;

    @Column(name = "uzytavprograma_vcobertura")
    private Integer uzytavprograma_vcobertura;

    @Lob
    @Column(name = "uzytavprograma_vubicacion2", columnDefinition = "CLOB")
    private String uzytavprograma_vubicacion2;

    @Lob
    @Column(name = "uzytavprograma_vdiagnostico2", columnDefinition = "CLOB")
    private String uzytavprograma_vdiagnostico2;

    @Size(max = 1)
    @Column(name = "uzytavprograma_vestado_activo", length = 1)
    private String uzytavprograma_vestado_activo;

    @Size(max = 1000)
    @Column(name = "uzytavprograma_vevaluacion_cual", length = 1000)
    private String uzytavprograma_vevaluacion_cual;

    @Column(name = "uzytavprograma_vfecha_cierre")
    private Date uzytavprograma_vfecha_cierre;

    @Column(name = "uzytavprograma_vfecha_evaluacion")
    private Date uzytavprograma_vfecha_evaluacion;

    @Lob
    @Column(name = "uzytavprograma_vresumen2", columnDefinition = "CLOB")
    private String uzytavprograma_vresumen2;

    @Lob
    @Column(name = "uzytavprograma_vlinea_base2", columnDefinition = "CLOB")
    private String uzytavprograma_vlinea_base2;

    @Lob
    @Column(name = "uzytavprograma_vbeneficios2", columnDefinition = "CLOB")
    private String uzytavprograma_vbeneficios2;

    @Lob
    @Column(name = "uzytavprograma_vfactor_c_exito2", columnDefinition = "CLOB")
    private String uzytavprograma_vfactor_c_exito2;


    //RELACION CON PROYECTO de UNO A MUCHOS

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavProyec> modelUzyTavProyecSet = new LinkedHashSet<>();


    //RELACION CON OPCIÓN INSTITUCIÓN

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavOpcionInstitucion> modelUzyTavOpcionInstitucionSet = new LinkedHashSet<>();

    //Relación con la tabla zonadetalle-tabla hija

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavZonaDetalle> modelUzyTavZonaDetalleSet = new LinkedHashSet<>();

    //RELACIÓN CON LINEA OPERATIVA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavlineaoperativa_ID")
    private ModelUzyTLineaOperativa uzytlineaoperativa;

    //RELACIÓN CON USUARIO
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytusuario_id")
    private ModelUzyTUsuario uzytusuario;

    //RELACIÓN CON uzytavprog_obj-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavProgObj> modelUzyTavProgObjSet = new LinkedHashSet<>();

    //RELACIÓN CON OBJETIVO PROGRAMA-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzytavObjetivoPrograma> modelUzytavObjetivoProgramaSet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavActivProg TABLA hija
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavActivProg> modelUzyTavActivProgSet = new LinkedHashSet<>();
    //RELACIÓN CON ModelUzyTavDepCenProy TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavDepCenProy> modelUzyTavDepCenProySet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavCaprog- TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavCaprog> modelUzyTavCaprogSet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavPlanVPrograma-TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavPlanVPrograma> modelUzyTavPlanVProgramaSet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavProgramaEplanv- TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavPrograma_Eplanv> modelUzyTavProgramaEplanvSet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavLecaPren-tabla hija

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavLecaPren> modelUzyTavLecaPrenSet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavProgObjEstartegico-tabla hija
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavprograma_v")
    private Set<ModelUzyTavProgObjEstartegico> modelUzyTavProgObjEstartegicoSet = new LinkedHashSet<>();
}
