package ec.edu.espe.movilidad.MovilidadWS.Model;


import com.fasterxml.jackson.annotation.JsonIgnore;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;
import java.util.LinkedHashSet;
import java.util.Set;

@Getter
@Setter
@Entity
@Table(name = "uzytavproyec", schema = "UTIC1")
public class ModelUzyTavProyec {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "proyec_seq")
    @SequenceGenerator(name = "proyec_seq", sequenceName = "SEQ_PROYEC", allocationSize = 1)
    @Column(name = "uzytavproyec_id")
    private Long uzytavproyec_id;
    @Size(max = 500)
    @Column(name = "uzytavproyec_nombre", length = 500)
    private String uzytavproyec_nombre;

    @Column(name = "uzytavproyec_aporuni")
    private Integer uzytavproyec_aporuni;

    @Column(name = "uzytavproyec_aporuni_valor")
    private Integer uzytavproyec_aporuni_valor;

    @Column(name = "uzytavproyec_entiaupi")
    private Integer uzytavproyec_entiaupi;

    @Column(name = "uzytavproyec_contraparte")
    private Integer uzytavproyec_contraparte;

    @Column(name = "uzytavproyec_fecha_presenta")
    private Date uzytavproyec_fecha_presenta;

    @Column(name = "uzytavproyec_fecha_inicio")
    private Date uzytavproyec_fecha_inicio;

    @Column(name = "uzytavproyec_fecha_finaliza")
    private Date uzytavproyec_fecha_finaliza;

    @Size(max = 3000)
    @Column(name = "uzytavproyec_bienes", length = 3000)
    private String uzytavproyec_bienes;

    @Size(max = 3000)
    @Column(name = "uzytavproyec_servicios", length = 3000)
    private String uzytavproyec_servicios;

    @Size(max = 3000)
    @Column(name = "uzytavproyec_bien_servicio", length = 3000)
    private String uzytavproyec_bien_servicio;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_situactual", length = 3000)
    private String uzytavproyec_situactual;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_diagnostico", length = 3000)
    private String uzytavproyec_diagnostico;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_lineabase", length = 3000)
    private String uzytavproyec_lineabase;

    @Column(name = "uzytavproyec_directos_hombres")
    private Integer uzytavproyec_directos_hombres;

    @Column(name = "uzytavproyec_directos_mujeres")
    private Integer uzytavproyec_directos_mujeres;

    @Column(name = "uzytavproyec_directos_discapac")
    private Integer uzytavproyec_directos_discapac;

    @Column(name = "uzytavproyec_inidirectos_hombres")
    private Integer uzytavproyec_inidirectos_hombres;

    @Column(name = "uzytavproyec_inidirectos_mujeres")
    private Integer uzytavproyec_inidirectos_mujeres;

    @Size(max = 3000)
    @Column(name = "uzytavproyec_factoresc", length = 3000)
    private String uzytavproyec_factoresc;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_restricion", length = 3000)
    private String uzytavproyec_restricion;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_viabilidad", length = 3000)
    private String uzytavproyec_viabilidad;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_perderia", length = 3000)
    private String uzytavproyec_perderia;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_resultados", length = 3000)
    private String uzytavproyec_resultados;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_impactoa", length = 3000)
    private String uzytavproyec_impactoa;
    @Size(max = 3000)
    @Column(name = "uzytavproyec_sostenibilidad", length = 3000)
    private String uzytavproyec_sostenibilidad;

    @Column(name = "uzytavproyec_inidirectos_discapa")
    private Integer uzytavproyec_inidirectos_discapa;
    @Size(max = 1)
    @Column(name = "uzytavproyec_tipo_proy", length = 1)
    private String uzytavproyec_tipo_proy;

    @Size(max = 4)
    @Column(name = "stvsubj_code", length = 4)
    private String stvsubj_code;
    @Size(max = 20)
    @Column(name = "uzytavproyec_codigo", length = 20)
    private String uzytavproyec_codigo;

    @Size(max = 100)
    @Column(name = "uzytavproyec_aprob_con_dep_nom", length = 100)
    private String uzytavproyec_aprob_con_dep_nom;

    @Size(max = 250)
    @Column(name = "uzytavproyec_aprob_con_dep_url", length = 250)
    private String uzytavproyec_aprob_con_dep_url;

    @Size(max = 5)
    @Column(name = "uzytavproyec_estado", length = 5)
    private String uzytavproyec_estado;


    @Column(name = "uzytavproyec_fecha_c")
    private Date uzytavproyec_fecha_c;
    @Size(max = 100)
    @Column(name = "uzytavproyec_nombre_pdf_acta", length = 100)
    private String uzytavproyec_nombre_pdf_acta;
    @Size(max = 250)
    @Column(name = "uzytavproyec_url_pdf_acta", length = 250)
    private String uzytavproyec_url_pdf_acta;
    @Size(max = 250)
    @Column(name = "uzytavproyec_observacio_c", length = 250)
    private String uzytavproyec_observacio_c;
    @Size(max = 1000)
    @Column(name = "uzytavproyec_mensaje_correo", length = 1000)
    private String uzytavproyec_mensaje_correo;
    @Size(max = 500)
    @Column(name = "uzytavproyec_asunto_correo", length = 500)
    private String uzytavproyec_asunto_correo;
    @Size(max = 100)
    @Column(name = "uzytavproyec_direccion_correo", length = 100)
    private String uzytavproyec_direccion_correo;

    @Column(name = "uzytavproyec_directos_ejec")
    private Integer uzytavproyec_directos_ejec;

    @Lob
    @Column(name = "uzytavproyec_situactual2",  columnDefinition = "CLOB")
    private String uzytavproyec_situactual2;

    @Lob
    @Column(name = "uzytavproyec_diagnostico2",  columnDefinition = "CLOB")
    private String uzytavproyec_diagnostico2;
    @Size(max = 100)
    @Column(name = "uzytavproyec_nombre_pdf_memo", length = 100)
    private String uzytavproyec_nombre_pdf_memo;
    @Size(max = 250)
    @Column(name = "uzytavproyec_url_pdf_memo", length = 250)
    private String uzytavproyec_url_pdf_memo;
    @Size(max = 1)
    @Column(name = "uzytavconparaeva_adjunto_acta", length = 1)
    private String uzytavconparaeva_adjunto_acta;
    @Size(max = 1)
    @Column(name = "uzytavconparaeva_adjunto_memo", length = 1)
    private String uzytavconparaeva_adjunto_memo;

    @Column(name = "uzytavproyec_cobertura")
    private Integer uzytavproyec_cobertura;

    @Column(name = "uzytavproyec_directos_ninios")
    private Integer uzytavproyec_directos_ninios;

    @Column(name = "uzytavproyec_indirectos_ninios")
    private Integer uzytavproyec_indirectos_ninios;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_prod", length = 500)
    private String uzytavproyec_cierre_prod;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_bien", length = 500)
    private String uzytavproyec_cierre_bien;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_resul", length = 500)
    private String uzytavproyec_cierre_resul;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_aplic", length = 500)
    private String uzytavproyec_cierre_aplic;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_imp", length = 500)
    private String uzytavproyec_cierre_imp;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_rest", length = 500)
    private String uzytavproyec_cierre_rest;
    @Size(max = 500)
    @Column(name = "uzytavproyec_cierre_comen", length = 500)
    private String uzytavproyec_cierre_comen;

    @Column(name = "uzytavconparaevaf_code")
    private Integer uzytavconparaevaf_code;

    @Column(name = "uzytavproyec_fecha_v")
    private Date uzytavproyec_fecha_v;
    @Size(max = 250)
    @Column(name = "uzytavproyec_observacio_v", length = 250)
    private String uzytavproyec_observacio_v;
    @Size(max = 1)
    @Column(name = "uzytavproyec_estado_activo", length = 1)
    private String uzytavproyec_estado_activo;


    @Column(name = "uzytavproyec_fecha_cierre")
    private Date uzytavproyec_fecha_cierre;

    @Column(name = "uzytavproyec_fecha_evaluacion")
    private Date uzytavproyec_fecha_evaluacion;

    @Column(name = "uzytavproyec_fecha_mail_avance")
    private Date uzytavproyec_fecha_mail_avance;
    @Lob
    @Column(name = "uzytavproyec_lineabase2", columnDefinition = "CLOB")
    private String uzytavproyec_lineabase2;

    @Column(name = "uzytavproyec_indirectos")
    private Integer uzytavproyec_indirectos;

    @Size(max = 3)
    @Column(name = "stvcamp_code", length = 3)
    private String stvcamp_code;


    @Size(max = 4)
    @Column(name = "stvmajr_code", length = 4)
    private String stvmajr_code;
    @Size(max = 100)
    @Column(name = "uzytavproyec_com_part1_nom", length = 100)
    private String uzytavproyec_com_part1_nom;
    @Size(max = 250)
    @Column(name = "uzytavproyec_com_part1_url", length = 250)
    private String uzytavproyec_com_part1_url;
    @Size(max = 100)
    @Column(name = "uzytavproyec_com_part2_nom", length = 100)
    private String uzytavproyec_com_part2_nom;
    @Size(max = 250)
    @Column(name = "uzytavproyec_com_part2_url", length = 250)
    private String uzytavproyec_com_part2_url;

    @Column(name = "uzytavproyec_fecha_finp")
    private Date uzytavproyec_fecha_finp;
    @Size(max = 25)
    @Column(name = "uzytavproyec_aprob_con_dep_nro", length = 25)
    private String uzytavproyec_aprob_con_dep_nro;

    @Column(name = "uzytavproyec_aprob_con_dep_fec")
    private Date uzytavproyec_aprob_con_dep_fec;
    @Size(max = 100)
    @Column(name = "uzytavproyec_aprob_viitt_nom", length = 100)
    private String uzytavproyec_aprob_viitt_nom;
    @Size(max = 250)
    @Column(name = "uzytavproyec_aprob_viitt_url", length = 250)
    private String uzytavproyec_aprob_viitt_url;
    @Size(max = 25)
    @Column(name = "uzytavproyec_aprob_viitt_nro", length = 25)
    private String uzytavproyec_aprob_viitt_nro;

    @Column(name = "uzytavproyec_aprob_viitt_fec")
    private Date uzytavproyec_aprob_viitt_fec;
    @Size(max = 25)
    @Column(name = "uzytavproyec_cons_acad_nroacta", length = 25)
    private String uzytavproyec_cons_acad_nroacta;
    @Size(max = 250)
    @Column(name = "uzytavproyec_carta_com_url", length = 250)
    private String uzytavproyec_carta_com_url;
    @Size(max = 100)
    @Column(name = "uzytavproyec_carta_com_nom", length = 100)
    private String uzytavproyec_carta_com_nom;

    @Column(name = "uzytavproyec_fecha_fin_ejec")
    private Date uzytavproyec_fecha_fin_ejec;

    @Column(name = "UZYTAVPROYEC_FECMAX_CORREC")
    private Date UZYTAVPROYEC_FECMAX_CORREC;


    @Column(name = "uzytavproyec_secuencial")
    private Integer uzytavproyec_secuencial;

    @Size(max = 3000)
    @Column(name = "uzytavproyec_efecto_esperado", length = 3000)
    private String uzytavproyec_efecto_esperado;

    @Column(name = "uzytavproyec_tipo")
    private Integer uzytavproyec_tipo;
    @Size(max = 1000)
    @Column(name = "uzytavproyec_descripcion_pobl", length = 1000)
    private String uzytavproyec_descripcion_pobl;
    @Size(max = 100)
    @Column(name = "uzytavproyec_com_part3_nom", length = 100)
    private String uzytavproyec_com_part3_nom;

    @Size(max = 250)
    @Column(name = "uzytavproyec_com_part3_url", length = 250)
    private String uzytavproyec_com_part3_url;

    //RELACIÓN CON PROGRAMA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavprograma_v_id")
    private ModelUzyTavPrograma_V uzytavprograma_v;


    //RELACIÓN CON PARAMETROS_DET TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytparametros_det_id")
    private ModelUzyTavParametros_Det uzytparametros_detID;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytparametros_det_id_cobertura")
    private ModelUzyTavParametros_Det uzytparametros_detCobertura;


    //RELACIÓN CON LA TABLA TAVAPRUEBA-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavactaprueba_id")
    private ModelUzyTavActaPrueba uzyTavacAprueba;


    //RELACION CON CONVOCATORIA////////

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconvoca_id", referencedColumnName = "uzytavconvoca_id")
    private ModelUzyTavConvoca uzytavconvoca;


    // CONSOLCA RELACION consolca
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavConsolca> modelUzyTavConsolcas = new LinkedHashSet<>();

    //RELACIÓN CON CABCOMCA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavcabcomca_id")
    private ModelUzyTavCabComca uzytavcabcomca;


    ///RELACION CON CONPARAEVA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavconparaeva_id")
    private ModelUzyTavConparaEva uzytavconparaeva;
    //RELACIÓN CON LA TABLA ZONADETALLE-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavZonaDetalle> modelUzyTavZonaDetalleSet = new LinkedHashSet<>();

    //RELACION CON LA TABLA uzytavcabevalp- tabla hija
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavCabeValp> modelUzyTavCabeValpSet = new LinkedHashSet<>();

    //RELACIÓN CON LA TABLA PRESUP- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavPresup> modelUzyTavPresupSet = new LinkedHashSet<>();

    //RELACIÓN CON CATALOGOS GENERALES-TABLA APDRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "UZYTCATA_GEN_ID")
    private ModelUzyTCatalogosGenerales uzytcataGen;
    //RELACIÓN CON UzyTavProgObj
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavProgObj> modelUzyTavProgObjSet = new LinkedHashSet<>();

    //RELACIÓN CON OBJETIVO PROGRAMA TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzytavObjetivoPrograma> modelUzytavObjetivoProgramaSet = new LinkedHashSet<>();

    //RELACION CON ModelUzyTavDocParti - TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavDocParti> modelUzyTavDocPartiSet = new LinkedHashSet<>();
    //RELACION CON ModelUzyTavEstuParti- TABLA HIJA


    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavEstuParti> modelUzyTavEstuPartiSet = new LinkedHashSet<>();

    //RELACIÓN CON UZYTAVINSTPROY- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavInstProy> modelUzyTavInstProySet = new LinkedHashSet<>();

    //RELACIÓN CON ModelUzyTavAnexoSPR TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavAnexoSPR> modelUzyTavAnexoSPRSet = new LinkedHashSet<>();

    //RELACIPON CON ModelUzyTavActivProg TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavActivProg> modelUzyTavActivProgSet = new LinkedHashSet<>();

    //RELACIPON CON ModelUzyTavProgObjEstartegico TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavProgObjEstartegico> modelUzyTavProgObjEstartegicoSet = new LinkedHashSet<>();


    //RELACIPON CON ModelUzyTavSeguim TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavSeguim> modelUzyTavSeguimSet = new LinkedHashSet<>();

    //RELACIÓN CON USUARIO-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytusuario_id")
    private ModelUzyTUsuario uzytusuario;

    //RELACIÓN CON ModelUzyTavCabeValpf TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavCabeValpf> modelUzyTavCabeValpfSet = new LinkedHashSet<>();


    //RELACIÓN CON ModelUzyTavImpacto TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavImpacto> modelUzyTavImpactoSet = new LinkedHashSet<>();


    //RELACIÓN CON ModelUzyTavImpacto TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavProlin> modelUzyTavProlinSet = new LinkedHashSet<>();
    // CONSOLCA RELACION ACTPROY
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavActProy> modelUzyTavActProySet = new LinkedHashSet<>();


    //RELACIÓN CON ACTASPERFIL_PROYEC-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavactasperfil_PROYEC_ID")
    private ModelUzyTavActasPerfil_Proyec uzytavactasperfil_PROYEC;

    //RELACIÓN CON DESIGDOC- TABLA HIJA
    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavDesigDoc> modelUzyTavDesigDocSet = new LinkedHashSet<>();

    //RELACIÓN CON DESIGESTU- TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavproyec")
    private Set<ModelUzyTavDesigEstu> modelUzyTavDesigEstuSet = new LinkedHashSet<>();

}
