package ec.edu.espe.movilidad.MovilidadWS.Model;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import java.time.LocalDateTime;
import java.util.LinkedHashSet;
import java.util.Set;
@Getter
@Setter
@Entity
@Table(name = "uzytavresponsable_prog", schema = "UTIC1")
public class ModelUzyTavResponsableProg {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavresponsable_prog_seq")
    @SequenceGenerator(name = "uzytavresponsable_prog_seq", sequenceName = "SEQ_UZYTAVRESPONSABLEPROG", allocationSize = 1)
    @Column(name = "uzytavresponsable_prog_id")
    private Long uzytavresponsable_prog_id;



    @Column(name = "stvsubj_code_dpto", length = 4)
    private String stvsubj_code_dpto;



    @Column(name = "uzytavresponsable_prog_g_orden")
    private Integer uzytavresponsable_prog_g_orden;


    @Column(name = "uzytavresponsable_prog_g_horas_planif")
    private Integer uzytavresponsable_prog_g_horas_planif;

    @Column(name = "stvmajr_code", length = 4)
    private String stvmajr_code;

    @Column(name = "uzytavresponsable_prog_g_nro_certificados")
    private Integer uzytavresponsable_prog_g_nro_certificados;

    @Column(name = "uzytavresponsable_prog_g_fecha_creacion")
    private LocalDateTime uzytavresponsable_prog_g_fecha_creacion;

    @Column(name = "uzytavresponsable_prog_g_estado", length = 1)
    private String uzytavresponsable_prog_g_estado;


    @Column(name = "uzytavresponsable_prog_g_verificar", length = 2)
    private String uzytavresponsable_prog_g_verificar;

    @Column(name = "uzytavresponsable_prog_g_verfecha")
    private LocalDateTime uzytavresponsable_prog_g_verfecha;

    @Column(name = "uzytavresponsable_prog_g_responsable", length = 500)
    private String uzytavresponsable_prog_g_responsable;

    @Column(name = "uzytavresponsable_prog_g_calificacion")
    private Integer uzytavresponsable_prog_g_calificacion;

    //RELACIÓN CON USUARIO-TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytusuario_id_docente", referencedColumnName = "uzytusuario_id")
    private ModelUzyTUsuario iddocente;

    //RELACIÓN CON LA TABLA TIPRESS- TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavtipres_id", referencedColumnName = "uzytavtipres_id")
    private ModelUzyTavTipres uzytavtipres;

    //RELACIÓN CON PROGRAMA- TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavprograma_v_id")
    private ModelUzyTavPrograma_V uzytavprograma_v;

    //RELACIÓN CON PROYECTO
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;

    //RELACIÓN CON LA TABLA- RESPONSA

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavactaresponsa_code")
    private ModelUzyTavActaResponsa uzytavactaresponsa;

    //RELACIÓN CON LA TABLA HOREJEC-TABLA HIJA

    @JsonIgnore
    @OneToMany(mappedBy = "uzytavresponsable_prog")
    private Set<ModelUzyTavHorEjec> modelUzyTavHorEjecSet = new LinkedHashSet<>();


}
