package ec.edu.espe.movilidad.MovilidadWS.Model;

import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;
import javax.validation.constraints.Size;
import java.util.Date;


@Getter
@Setter
@Entity
@Table(name = "UZYTAVSEGUIM", schema = "UTIC1")
public class ModelUzyTavSeguim {
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "uzytavseguim_seq")
    @SequenceGenerator(name = "uzytavseguim_seq", sequenceName = "SEQ_UZYTAVSEGUIM", allocationSize = 1)
    @Column(name = "uzytavseguim_id")
    private Long uzytavseguim_id;

    //RELACIÓN CON ModelUzyTavProyec TABLA PADRE
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavproyec_id")
    private ModelUzyTavProyec uzytavproyec;

    @Size(max = 100)
    @Column(name = "uzytavseguim_descrip", length = 100)
    private String uzytavseguim_descrip;

    //RELACIÓN CON ModelUzytavObjetivoPrograma TABLA PADRE

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "uzytavobjetivo_programa_id")
    private ModelUzytavObjetivoPrograma uzytavobjetivoPrograma;

    @Column(name = "uzytavseguim_fecha_logro")
    private Date uzytavseguim_fecha_logro;

    @Size(max = 1000)
    @Column(name = "uzytavseguim_logro", length = 1000)
    private String uzytavseguim_logro;
}
