package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTaValorPar;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTaValorPar;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTaValorParMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTaValorPar;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;
import java.util.List;

@Service
public class ServiceUzyTaValorPar implements IServiceUzyTaValorPar {


    private final DaoUzyTaValorPar daoUzyTaValorPar;


    private final UzyTaValorParMapper mapper;

    public ServiceUzyTaValorPar(DaoUzyTaValorPar daoUzyTaValorPar, UzyTaValorParMapper mapper) {
        this.daoUzyTaValorPar = daoUzyTaValorPar;
        this.mapper = mapper;
    }


    @Override
    public DtoUzyTaValorPar ListarPorID(@PathVariable Long id) {
        ModelUzyTaValorPar entity = daoUzyTaValorPar.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }


    public List<DtoUzyTaValorPar> getAllDatosRelacionadosParaEva() {
        List<ModelUzyTaValorPar> entities  = daoUzyTaValorPar.getAllDatosRelacionadosParaEva();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTaValorPar> findByIdDatosRelacionadosConParaEva(Long id) {
        List<ModelUzyTaValorPar> entities  = daoUzyTaValorPar.findByIdDatosRelacionadosConParaEva(id);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTaValorPar> ListarRegistros() {
        List<ModelUzyTaValorPar> entities = daoUzyTaValorPar.findAll();
        return mapper.entitiesToDtos(entities);
    }


    @Override
    public DtoUzyTaValorPar guardar(DtoUzyTaValorPar dtoUzyTaValorPar) {
        ModelUzyTaValorPar entity = mapper.dtoToEntity(dtoUzyTaValorPar);
        ModelUzyTaValorPar nuevoEntity = daoUzyTaValorPar.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTaValorPar editar(@PathVariable Long id, DtoUzyTaValorPar dtoUzyTaValorPar) {
        try {
            ModelUzyTaValorPar entity = daoUzyTaValorPar.findById(id).get();

            //Seteamos los nuevos datos del registro
            if (entity != null) {
                entity.setUzytavalorpar_descrip(dtoUzyTaValorPar.getUzytavalorpar_descrip());
                entity.setUzytavalorpar_orden(dtoUzyTaValorPar.getUzytavalorpar_orden());
                entity.setUzytavalorpar_puntaje(dtoUzyTaValorPar.getUzytavalorpar_puntaje());

                ModelUzyTaValorPar updatedEntity = daoUzyTaValorPar.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTaValorPar entity = daoUzyTaValorPar.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTaValorPar.delete(entity);
            return true;
        }
        return false;
    }
}
