package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActaPrueba;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavActaPrueba;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActaPrueba;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavActaPruebaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavActaPrueba;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service
public class ServiceUzyTavActaPrueba implements IServiceUzyTavActaPrueba {

    private final DaoUzyTavActaPrueba daoUzyTavActaPrueba;
    private final UzyTavActaPruebaMapper mapper;

    public ServiceUzyTavActaPrueba(DaoUzyTavActaPrueba daoUzyTavActaPrueba, UzyTavActaPruebaMapper mapper) {
        this.daoUzyTavActaPrueba = daoUzyTavActaPrueba;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavActaPrueba ListarPorID(@PathVariable Long id) {
        ModelUzyTavActaPrueba entity = daoUzyTavActaPrueba.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavActaPrueba> ListarRegistros() {
        List<ModelUzyTavActaPrueba> entities = daoUzyTavActaPrueba.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavActaPrueba guardar(DtoUzyTavActaPrueba dtoUzyTavActaPrueba) {
        ModelUzyTavActaPrueba entity = mapper.dtoToEntity(dtoUzyTavActaPrueba);
        ModelUzyTavActaPrueba nuevoEntity = daoUzyTavActaPrueba.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavActaPrueba editar(@PathVariable Long id, DtoUzyTavActaPrueba dtoUzyTavActaPrueba) {
        try {
            ModelUzyTavActaPrueba entity = daoUzyTavActaPrueba.findById(id).get();
            if (entity != null) {
                entity.setUzytusuario_id_aprueba(dtoUzyTavActaPrueba.getUzytusuario_id_aprueba());
                entity.setUzytavactaprueba_fecha_aprueba(dtoUzyTavActaPrueba.getUzytavactaprueba_fecha_aprueba());
                entity.setUzytavactaprueba_secuencial_a(dtoUzyTavActaPrueba.getUzytavactaprueba_secuencial_a());
                entity.setUzytavactaprueba_cerrado(dtoUzyTavActaPrueba.getUzytavactaprueba_cerrado());
                entity.setUzytavactaprueba_doc_nom(dtoUzyTavActaPrueba.getUzytavactaprueba_doc_nom());
                entity.setUzytavactaprueba_doc_url(dtoUzyTavActaPrueba.getUzytavactaprueba_doc_url());
                ModelUzyTavActaPrueba updatedEntity = daoUzyTavActaPrueba.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavActaPrueba entity = daoUzyTavActaPrueba.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavActaPrueba.delete(entity);
            return true;
        }
        return false;
    }
}

