package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavActasPerfil_Proyec;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavActasPerfil_Proyec;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavActasPerfil_Proyec;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavActasPerfil_ProyecMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavActasPerfil_Proyec;
import org.springframework.stereotype.Service;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;

import java.util.List;

@Service
public class ServiceUzyTavActasPerfil_Proyec implements IServiceUzyTavActasPerfil_Proyec {

    private final DaoUzyTavActasPerfil_Proyec daoUzyTavActasPerfilProyec;

    private final UzyTavActasPerfil_ProyecMapper mapper;

    public ServiceUzyTavActasPerfil_Proyec(DaoUzyTavActasPerfil_Proyec daoUzyTavActasPerfilProyec, UzyTavActasPerfil_ProyecMapper mapper) {
        this.daoUzyTavActasPerfilProyec = daoUzyTavActasPerfilProyec;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavActasPerfil_Proyec ListarPorID(Long id) {
        ModelUzyTavActasPerfil_Proyec entity = daoUzyTavActasPerfilProyec.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavActasPerfil_Proyec> ListarRegistros() {
        List<ModelUzyTavActasPerfil_Proyec> entities = daoUzyTavActasPerfilProyec.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavActasPerfil_Proyec guardar(DtoUzyTavActasPerfil_Proyec dtoUzyTavActasPerfilProyec) {
        ModelUzyTavActasPerfil_Proyec entity = mapper.dtoToEntity(dtoUzyTavActasPerfilProyec);
        ModelUzyTavActasPerfil_Proyec nuevoEntity = daoUzyTavActasPerfilProyec.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavActasPerfil_Proyec editar(Long id, DtoUzyTavActasPerfil_Proyec dtoUzyTavActasPerfilProyec) {
        try {
            ModelUzyTavActasPerfil_Proyec entity = daoUzyTavActasPerfilProyec.findById(id).get();
            if (entity != null) {
                if(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_TIPO()!=null){
                    entity.setUzytavactasperfil_PROYEC_TIPO(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_TIPO());
                }

                if(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_FECHA_CREA()!=null){
                    entity.setUzytavactasperfil_PROYEC_FECHA_CREA(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_FECHA_CREA());
                }

                if(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_NOMBRE_URL()!=null){
                    entity.setUzytavactasperfil_PROYEC_NOMBRE_URL(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_NOMBRE_URL());
                }

                if(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_NOMBRE_DOC()!=null){
                    entity.setUzytavactasperfil_PROYEC_NOMBRE_DOC(dtoUzyTavActasPerfilProyec.getUzytavactasperfil_PROYEC_NOMBRE_DOC());
                }


                ModelUzyTavActasPerfil_Proyec updatedEntity = daoUzyTavActasPerfilProyec.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavActasPerfil_Proyec entity = daoUzyTavActasPerfilProyec.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavActasPerfilProyec.delete(entity);
            return true;
        }
        return false;
    }
}
