package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavAnualValor;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavAnualValor;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavAnualValor;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavAnualValorMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavAnualValor;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service
public class ServiceUzyTavAnualValor implements IServiceUzyTavAnualValor {

    private final DaoUzyTavAnualValor daoUzyTavAnualValor;
    private final UzyTavAnualValorMapper mapper;

    public ServiceUzyTavAnualValor(DaoUzyTavAnualValor daoUzyTavAnualValor, UzyTavAnualValorMapper mapper) {
        this.daoUzyTavAnualValor = daoUzyTavAnualValor;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavAnualValor ListarPorID(@PathVariable Long id) {
        ModelUzyTavAnualValor entity = daoUzyTavAnualValor.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavAnualValor> ListarRegistros() {
        List<ModelUzyTavAnualValor> entities = daoUzyTavAnualValor.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavAnualValor guardar(DtoUzyTavAnualValor dtoUzyTavAnualValor) {
        ModelUzyTavAnualValor entity = mapper.dtoToEntity(dtoUzyTavAnualValor);
        ModelUzyTavAnualValor nuevoEntity = daoUzyTavAnualValor.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavAnualValor editar(@PathVariable Long id, DtoUzyTavAnualValor dtoUzyTavAnualValor) {
        try {
        ModelUzyTavAnualValor entity = daoUzyTavAnualValor.findById(id).get();
            if (entity != null) {
                entity.setUzytavanualvalor_desc(dtoUzyTavAnualValor.getUzytavanualvalor_desc());
                entity.setUzytavanualvalor_valor(dtoUzyTavAnualValor.getUzytavanualvalor_valor());
                ModelUzyTavAnualValor updatedEntity = daoUzyTavAnualValor.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }


    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavAnualValor entity = daoUzyTavAnualValor.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavAnualValor.delete(entity);
            return true;
        }
        return false;
    }
}
