package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabComca;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavCabComca;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabComca;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavCabComcaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabComca;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;
@Service
public class ServiceUzyTavCabComca implements IServiceUzyTavCabComca{

    private final DaoUzyTavCabComca daoUzyTavCabComca;
    private final UzyTavCabComcaMapper mapper;

    public ServiceUzyTavCabComca(DaoUzyTavCabComca daoUzyTavCabComca, UzyTavCabComcaMapper mapper) {
        this.daoUzyTavCabComca = daoUzyTavCabComca;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavCabComca ListarPorID(@PathVariable Long id) {
        ModelUzyTavCabComca entity = daoUzyTavCabComca.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavCabComca> ListarRegistros() {
        List<ModelUzyTavCabComca> entities = daoUzyTavCabComca.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavCabComca guardar(DtoUzyTavCabComca dtoUzyTavCabComca) {
        ModelUzyTavCabComca entity = mapper.dtoToEntity(dtoUzyTavCabComca);
        ModelUzyTavCabComca nuevoEntity = daoUzyTavCabComca.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavCabComca editar(@PathVariable Long id, DtoUzyTavCabComca dtoUzyTavCabComca) {
        try {
        ModelUzyTavCabComca entity = daoUzyTavCabComca.findById(id).get();

            if (entity != null) {
                entity.setUzytavcabcomca_decsrip(dtoUzyTavCabComca.getUzytavcabcomca_decsrip());
                entity.setUzytavcabcomca_fech_crea(dtoUzyTavCabComca.getUzytavcabcomca_fech_crea());
                ModelUzyTavCabComca updatedEntity = daoUzyTavCabComca.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavCabComca entity = daoUzyTavCabComca.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavCabComca.delete(entity);
            return true;
        }
        return false;
    }
}
