package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabParaevaf;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabParaevaf;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavCabParaevafMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabParaevaf;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;
import java.util.List;

@Service
public class ServiceUzyTavCabParaevaf implements IServiceUzyTavCabParaevaf {

    private final DaoUzyTavCabParaevaf daoUzyTavCabParaevaf;
    private final UzyTavCabParaevafMapper mapper;

    public ServiceUzyTavCabParaevaf(DaoUzyTavCabParaevaf daoUzyTavCabParaevaf, UzyTavCabParaevafMapper mapper) {
        this.daoUzyTavCabParaevaf = daoUzyTavCabParaevaf;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavCabParaevaf ListarPorID(@PathVariable Long id) {
        ModelUzyTavCabParaevaf entity = daoUzyTavCabParaevaf.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavCabParaevaf> ListarRegistros() {
        List<ModelUzyTavCabParaevaf> entities = daoUzyTavCabParaevaf.findAll();
        return mapper.entitiesToDtos(entities);
    }


    @Override
    public DtoUzyTavCabParaevaf guardar(DtoUzyTavCabParaevaf dtoUzyTavEvalProy) {
        ModelUzyTavCabParaevaf entity = mapper.dtoToEntity(dtoUzyTavEvalProy);
        ModelUzyTavCabParaevaf nuevoEntity = daoUzyTavCabParaevaf.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }


    @Override
    public List<DtoUzyTavCabParaevaf> findByIdDatosConParaEvaTipo2(Long id) {
        List<ModelUzyTavCabParaevaf> entities = daoUzyTavCabParaevaf.findByIdDatosConParaEvaTipo2(id);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavCabParaevaf editar(Long id, DtoUzyTavCabParaevaf dtoUzyTavCabParaevaf) {
        try {
        ModelUzyTavCabParaevaf entity = daoUzyTavCabParaevaf.findById(id).orElse(null);
            if (entity != null) {
                entity.setUzytavcabparaevaf_nombre(dtoUzyTavCabParaevaf.getUzytavcabparaevaf_nombre());
                entity.setUzytavcabparaevaf_desc1(dtoUzyTavCabParaevaf.getUzytavcabparaevaf_desc1());
                entity.setUzytavcabparaevaf_desc2(dtoUzyTavCabParaevaf.getUzytavcabparaevaf_desc2());
                entity.setUzytavcabparaevaf_orden(dtoUzyTavCabParaevaf.getUzytavcabparaevaf_orden());
                entity.setUzytavcabparaevaf_tipo(dtoUzyTavCabParaevaf.getUzytavcabparaevaf_tipo());
                ModelUzyTavCabParaevaf updatedEntity = daoUzyTavCabParaevaf.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavCabParaevaf entity = daoUzyTavCabParaevaf.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavCabParaevaf.delete(entity);
            return true;
        }
        return false;
    }
}
