package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavCabeValp;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavCabeValpMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavCabeValp;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service

public class ServiceUzyTavCabeValp implements IServiceUzyTavCabeValp {


    private final DaoUzyTavCabeValp daoUzyTavCabeValp;

    private final UzyTavCabeValpMapper mapper;

    public ServiceUzyTavCabeValp(DaoUzyTavCabeValp daoUzyTavCabeValp, UzyTavCabeValpMapper mapper) {
        this.daoUzyTavCabeValp = daoUzyTavCabeValp;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavCabeValp ListarPorID(@PathVariable Long id) {
        ModelUzyTavCabeValp entity = daoUzyTavCabeValp.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavCabeValp> ListarRegistros() {
        List<ModelUzyTavCabeValp> entities = daoUzyTavCabeValp.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTavCabeValp> findByIdDatosPorProyecID(Long uzytavproyec_id) {
        List<ModelUzyTavCabeValp> entities = daoUzyTavCabeValp.findByIdDatosPorProyecID(uzytavproyec_id);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavCabeValp guardar(DtoUzyTavCabeValp dtoUzyTavCabeValp) {
        ModelUzyTavCabeValp entity = mapper.dtoToEntity(dtoUzyTavCabeValp);
        ModelUzyTavCabeValp nuevoEntity = daoUzyTavCabeValp.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavCabeValp editar(@PathVariable Long id, DtoUzyTavCabeValp dtoUzyTavCabeValp) {
        try {

            ModelUzyTavCabeValp entity = daoUzyTavCabeValp.findById(id).get();
            if (entity != null) {
                entity.setUzytavcabevalp_fec_crea(dtoUzyTavCabeValp.getUzytavcabevalp_fec_crea());
                entity.setUzytavcabevalp_observa(dtoUzyTavCabeValp.getUzytavcabevalp_observa());
                entity.setUzytavcabevalp_estadofin(dtoUzyTavCabeValp.getUzytavcabevalp_estadofin());
                entity.setUzytavproyec_cumple_req(dtoUzyTavCabeValp.getUzytavproyec_cumple_req());

                ModelUzyTavCabeValp updatedEntity = daoUzyTavCabeValp.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavCabeValp entity = daoUzyTavCabeValp.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavCabeValp.delete(entity);
            return true;
        }
        return false;
    }
}
