package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavClasPre;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavClasPre;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavClasPre;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoClaspreClassPresupNombre;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavClasPreMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavClasPre;
import org.springframework.stereotype.Service;
import java.util.List;

@Service
public class ServiceUzyTavClasPre implements IServiceUzyTavClasPre{

    private final DaoUzyTavClasPre daoUzyTavClasPre;
    private final UzyTavClasPreMapper mapper;

    public ServiceUzyTavClasPre(DaoUzyTavClasPre daoUzyTavClasPre, UzyTavClasPreMapper mapper) {
        this.daoUzyTavClasPre = daoUzyTavClasPre;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavClasPre ListarPorID(Long id) {
        ModelUzyTavClasPre entity = daoUzyTavClasPre.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }


    @Override
    public List<DtoUzyTavClasPre> ListarRegistros() {
        List<ModelUzyTavClasPre> entities = daoUzyTavClasPre.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoClaspreClassPresupNombre> obtenerClasificadorPresupNombre(Long presupID) {
        return  daoUzyTavClasPre.obtenerClasificadorPresupNombre(presupID);
    }

    @Override
    public List<DtoClaspreClassPresupNombre> obtenerTodosClasificadorPresupNombre() {
        return  daoUzyTavClasPre.obtenerTodosClasificadorPresupNombre();
    }


    @Override
    public List<DtoUzyTavClasPre> obtenerClasificadorPresup(Long claspreID) {
        List<ModelUzyTavClasPre> entities = daoUzyTavClasPre.obtenerClasificadorPresup(claspreID);
        return mapper.entitiesToDtos(entities);
    }


    @Override
    public DtoUzyTavClasPre guardar(DtoUzyTavClasPre dtoUzyTavClasPre) {
        ModelUzyTavClasPre entity = mapper.dtoToEntity(dtoUzyTavClasPre);
        ModelUzyTavClasPre nuevoEntity = daoUzyTavClasPre.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavClasPre editar(Long id, DtoUzyTavClasPre dtoUzyTavClasPre) {
        try {
        ModelUzyTavClasPre entity = daoUzyTavClasPre.findById(id).get();
            if (entity != null) {
                entity.setUzytavclaspre_estado(dtoUzyTavClasPre.getUzytavclaspre_estado());
                entity.setUzytavclaspre_tipo(dtoUzyTavClasPre.getUzytavclaspre_tipo());
                ModelUzyTavClasPre updatedEntity = daoUzyTavClasPre.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavClasPre entity = daoUzyTavClasPre.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavClasPre.delete(entity);
            return true;
        }
        return false;
    }
}
