package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConfTipo;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavConfTipo;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConfTipo;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavConfTipoMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConfTipo;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavConfTipo implements IServiceUzyTavConfTipo{

    private final DaoUzyTavConfTipo daoUzyTavConfTipo;
    private final UzyTavConfTipoMapper mapper;

    public ServiceUzyTavConfTipo(DaoUzyTavConfTipo daoUzyTavConfTipo, UzyTavConfTipoMapper mapper) {
        this.daoUzyTavConfTipo = daoUzyTavConfTipo;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavConfTipo ListarPorID(Long id) {
        ModelUzyTavConfTipo entity = daoUzyTavConfTipo.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavConfTipo> ListarRegistros() {
        List<ModelUzyTavConfTipo> entities = daoUzyTavConfTipo.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavConfTipo guardar(DtoUzyTavConfTipo dtoUzyTavConfTipo) {
        ModelUzyTavConfTipo entity = mapper.dtoToEntity(dtoUzyTavConfTipo);
        ModelUzyTavConfTipo nuevoEntity = daoUzyTavConfTipo.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavConfTipo editar(Long id, DtoUzyTavConfTipo dtoUzyTavConfTipo) {
        try {
            ModelUzyTavConfTipo entity = daoUzyTavConfTipo.findById(id).get();
            // Seteamos los nuevos datos del registro
            if (entity != null) {
                // Aquí realizas la asignación de los nuevos datos a la entidad
                ModelUzyTavConfTipo updatedEntity = daoUzyTavConfTipo.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavConfTipo entity = daoUzyTavConfTipo.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavConfTipo.delete(entity);
            return true;
        }
        return false;
    }

   
}
