package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavConsolca;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavConsolca;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavConsolcaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavConsolca;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service
public class ServiceUzyTavConsolca implements IServiceUzyTavConsolca{

    private final DaoUzyTavConsolca daoUzyTavConsolca;
    private final UzyTavConsolcaMapper mapper;

    public ServiceUzyTavConsolca(DaoUzyTavConsolca daoUzyTavConsolca, UzyTavConsolcaMapper mapper) {
        this.daoUzyTavConsolca = daoUzyTavConsolca;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavConsolca ListarPorID(@PathVariable Long id) {
        ModelUzyTavConsolca entity = daoUzyTavConsolca.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavConsolca> ListarRegistros() {
        List<ModelUzyTavConsolca> entities = daoUzyTavConsolca.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavConsolca guardar(DtoUzyTavConsolca dtoUzyTavConsolca) {
        ModelUzyTavConsolca entity = mapper.dtoToEntity(dtoUzyTavConsolca);
        ModelUzyTavConsolca nuevoEntity = daoUzyTavConsolca.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavConsolca editar(@PathVariable Long id, DtoUzyTavConsolca dtoUzyTavConsolca) {
        try {
        ModelUzyTavConsolca entity = daoUzyTavConsolca.findById(id).get();
            if (entity != null) {
        //Seteamos los nuevos datos del registro

                entity.setUzytavconsolca_fecha_crea(dtoUzyTavConsolca.getUzytavconsolca_fecha_crea());
                entity.setUzytavconsolca_observa(dtoUzyTavConsolca.getUzytavconsolca_observa());
                entity.setUzytavconsolca_mensaje_correo(dtoUzyTavConsolca.getUzytavconsolca_mensaje_correo());
                entity.setUzytavconsolca_asunto_correo(dtoUzyTavConsolca.getUzytavconsolca_asunto_correo());
                entity.setUzytavconsolca_direccion_correo(dtoUzyTavConsolca.getUzytavconsolca_direccion_correo());
                entity.setUzytavconsolca_estadofin(dtoUzyTavConsolca.getUzytavconsolca_estadofin());
                entity.setUzytavconsolca_fecha_fin(dtoUzyTavConsolca.getUzytavconsolca_fecha_fin());
                ModelUzyTavConsolca updatedEntity = daoUzyTavConsolca.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavConsolca entity = daoUzyTavConsolca.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavConsolca.delete(entity);
            return true;
        }
        return false;
    }
}
