package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavDetComca;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavDetComca;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavDetComca;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavDetComcaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavDetComca;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service
public class ServiceUzyTavDetComca implements IServiceUzyTavDetComca{

    private final DaoUzyTavDetComca daoUzyTavDetComca;
    private final UzyTavDetComcaMapper mapper;

    public ServiceUzyTavDetComca(DaoUzyTavDetComca daoUzyTavDetComca, UzyTavDetComcaMapper mapper) {
        this.daoUzyTavDetComca = daoUzyTavDetComca;
        this.mapper = mapper;
    }


    @Override
    public DtoUzyTavDetComca ListarPorID(@PathVariable Long id) {
        ModelUzyTavDetComca entity = daoUzyTavDetComca.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavDetComca> ListarRegistros() {
        List<ModelUzyTavDetComca> entities = daoUzyTavDetComca.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavDetComca guardar(DtoUzyTavDetComca dtoUzyTavDetComca) {
        ModelUzyTavDetComca entity = mapper.dtoToEntity(dtoUzyTavDetComca);
        ModelUzyTavDetComca nuevoEntity = daoUzyTavDetComca.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public List<DtoUzyTavDetComca> findByIdconDatosCabComca(Long id) {
        List<ModelUzyTavDetComca> entities = daoUzyTavDetComca.findByIdconDatosCabComca(id);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavDetComca editar(@PathVariable Long id, DtoUzyTavDetComca dtoUzyTavDetComca) {
        try {
        ModelUzyTavDetComca entity = daoUzyTavDetComca.findById(id).get();
            if (entity != null) {

                entity.setUzytusuario_id_crea(dtoUzyTavDetComca.getUzytusuario_id_crea());
                entity.setUzytusuario_id_asignado(dtoUzyTavDetComca.getUzytusuario_id_asignado());
                entity.setUzytavdetcomca_fech_crea(dtoUzyTavDetComca.getUzytavdetcomca_fech_crea());
                entity.setUzytavdetcomca_estado(dtoUzyTavDetComca.getUzytavdetcomca_estado());
                ModelUzyTavDetComca updatedEntity = daoUzyTavDetComca.save(entity);
                return mapper.entityToDto(updatedEntity);

            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavDetComca entity = daoUzyTavDetComca.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavDetComca.delete(entity);
            return true;
        }
        return false;
    }
}
