package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavEstrategiasVPlan;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavEstrategiasVPlan;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavEstrategiasVPlan;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavEstrategiasVPlanMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavEstrategiasVPlan;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavEstrategiasVPlan implements IServiceUzyTavEstrategiasVPlan {

    private final DaoUzyTavEstrategiasVPlan daoUzyTavEstrategiasVPlan;
    private final UzyTavEstrategiasVPlanMapper mapper;

    public ServiceUzyTavEstrategiasVPlan(DaoUzyTavEstrategiasVPlan daoUzyTavEstrategiasVPlan, UzyTavEstrategiasVPlanMapper mapper) {
        this.daoUzyTavEstrategiasVPlan = daoUzyTavEstrategiasVPlan;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavEstrategiasVPlan ListarPorID(Long id) {
        ModelUzyTavEstrategiasVPlan entity = daoUzyTavEstrategiasVPlan.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavEstrategiasVPlan> ListarRegistros() {
        List<ModelUzyTavEstrategiasVPlan> entities = daoUzyTavEstrategiasVPlan.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavEstrategiasVPlan guardar(DtoUzyTavEstrategiasVPlan dtoUzyTavEstrategiasVPlan) {
        ModelUzyTavEstrategiasVPlan entity = mapper.dtoToEntity(dtoUzyTavEstrategiasVPlan);
        ModelUzyTavEstrategiasVPlan nuevoEntity = daoUzyTavEstrategiasVPlan.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavEstrategiasVPlan editar(Long id, DtoUzyTavEstrategiasVPlan dtoUzyTavEstrategiasVPlan) {
        try {
            ModelUzyTavEstrategiasVPlan entity = daoUzyTavEstrategiasVPlan.findById(id).get();

            //Seteamos los nuevos datos del registro
            if (entity != null) {
                entity.setUzytavestrategias_v_plan_descripcion(dtoUzyTavEstrategiasVPlan.getUzytavestrategias_v_plan_descripcion());
                entity.setUzytavestrategias_v_plan_orden(dtoUzyTavEstrategiasVPlan.getUzytavestrategias_v_plan_orden());


                ModelUzyTavEstrategiasVPlan updatedEntity = daoUzyTavEstrategiasVPlan.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavEstrategiasVPlan entity = daoUzyTavEstrategiasVPlan.findById(id).orElse(null);

        if (entity != null) {
            daoUzyTavEstrategiasVPlan.delete(entity);
            return true;
        }
        return false;
    }
}
