package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavEvalProy;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavEvalProy;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavEvalProy;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavEvalProyMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavEvalProy;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;

@Service
public class ServiceUzyTavEvalProy implements IServiceUzyTavEvalProy{

    private final DaoUzyTavEvalProy daoUzyTavEvalProy;

    private final UzyTavEvalProyMapper mapper;

    public ServiceUzyTavEvalProy(DaoUzyTavEvalProy daoUzyTavEvalProy, UzyTavEvalProyMapper mapper) {
        this.daoUzyTavEvalProy = daoUzyTavEvalProy;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavEvalProy ListarPorID(@PathVariable  Long id) {
        ModelUzyTavEvalProy entity = daoUzyTavEvalProy.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavEvalProy> ListarRegistros() {
        List<ModelUzyTavEvalProy> entities = daoUzyTavEvalProy.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTavEvalProy> findByIdDatosPorCabeValpID(Long uzytavcabevalp_id) {
        List<ModelUzyTavEvalProy> entities = daoUzyTavEvalProy.findByIdDatosPorCabeValpID(uzytavcabevalp_id);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavEvalProy guardar(DtoUzyTavEvalProy dtoUzyTavEvalProy) {
        ModelUzyTavEvalProy entity = mapper.dtoToEntity(dtoUzyTavEvalProy);
        ModelUzyTavEvalProy nuevoEntity = daoUzyTavEvalProy.save(entity);
        return mapper.entityToDto(nuevoEntity);

    }


    @Override
    public DtoUzyTavEvalProy editar(@PathVariable Long id, DtoUzyTavEvalProy dtoUzyTavEvalProy) {
        try {
        ModelUzyTavEvalProy entity = daoUzyTavEvalProy.findById(id).get();
        //Seteamos los nuevos datos del registro
            if (entity != null) {
                entity.setUzytavevalproy_puntaje(dtoUzyTavEvalProy.getUzytavevalproy_puntaje());
                entity.setUzytavparaeva_id(dtoUzyTavEvalProy.getUzytavparaeva_id());
                entity.setUzytavevalproy_observ(dtoUzyTavEvalProy.getUzytavevalproy_observ());
                ModelUzyTavEvalProy updatedEntity = daoUzyTavEvalProy.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }
    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavEvalProy entity = daoUzyTavEvalProy.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavEvalProy.delete(entity);
            return true;
        }
        return false;
    }
}
