package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavLinea;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavLinea;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavLinea;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavLineaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavLinea;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class ServiceUzyTavLinea implements IServiceUzyTavLinea {
    @Autowired
    private DaoUzyTavLinea daoUzyTavLinea;
     @Autowired
     private UzyTavLineaMapper mapper;
    @Override
    public DtoUzyTavLinea ListarPorID(Long id) {
        ModelUzyTavLinea entity = daoUzyTavLinea.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavLinea> ListarRegistros() {
        List<ModelUzyTavLinea> entities = daoUzyTavLinea.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavLinea guardar(DtoUzyTavLinea dtoUzyTavLinea) {
        ModelUzyTavLinea entity = mapper.dtoToEntity(dtoUzyTavLinea);
        ModelUzyTavLinea nuevoEntity = daoUzyTavLinea.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavLinea editar(Long id, DtoUzyTavLinea dtoUzyTavLinea) {
        try {
            ModelUzyTavLinea entity = daoUzyTavLinea.findById(id).get();
            if (entity != null) {
                //Seteamos los nuevos datos del registro
                entity.setUzytavlinea_DESCRIPCION(dtoUzyTavLinea.getUzytavlinea_DESCRIPCION());

                ModelUzyTavLinea updatedEntity = daoUzyTavLinea.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavLinea entity = daoUzyTavLinea.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavLinea.delete(entity);
            return true;
        }
        return false;
    }
}
