package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavObjPlanVinvula;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavObjPlanVinvula;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjPlanVinvula;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavObjPlanVinvulaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjPlanVinvula;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavObjPlanVinvula implements IServiceUzyTavObjPlanVinvula {

    private final UzyTavObjPlanVinvulaMapper mapper;

    private final DaoUzyTavObjPlanVinvula daoUzyTavObjPlanVinvula;

    public ServiceUzyTavObjPlanVinvula(UzyTavObjPlanVinvulaMapper mapper, DaoUzyTavObjPlanVinvula daoUzyTavObjPlanVinvula) {
        this.mapper = mapper;
        this.daoUzyTavObjPlanVinvula = daoUzyTavObjPlanVinvula;
    }


    @Override
    public DtoUzyTavObjPlanVinvula ListarPorID(Long id) {
        ModelUzyTavObjPlanVinvula entity = daoUzyTavObjPlanVinvula.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavObjPlanVinvula> ListarRegistros() {
        List<ModelUzyTavObjPlanVinvula> entities = daoUzyTavObjPlanVinvula.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavObjPlanVinvula guardar(DtoUzyTavObjPlanVinvula dtoUzyTavObjPlanVinvula) {
        ModelUzyTavObjPlanVinvula entity = mapper.dtoToEntity(dtoUzyTavObjPlanVinvula);
        ModelUzyTavObjPlanVinvula nuevoEntity = daoUzyTavObjPlanVinvula.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavObjPlanVinvula editar(Long id, DtoUzyTavObjPlanVinvula dtoUzyTavObjPlanVinvula) {
        try {
            ModelUzyTavObjPlanVinvula entity = daoUzyTavObjPlanVinvula.findById(id).get();

            //Seteamos los nuevos datos del registro
            if (entity != null) {
                entity.setUzytavobj_plan_vinvula_descripcion(dtoUzyTavObjPlanVinvula.getUzytavobj_plan_vinvula_descripcion());
                entity.setUzytavobj_plan_vinvula_orden(dtoUzyTavObjPlanVinvula.getUzytavobj_plan_vinvula_orden());


                ModelUzyTavObjPlanVinvula updatedEntity = daoUzyTavObjPlanVinvula.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavObjPlanVinvula entity = daoUzyTavObjPlanVinvula.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavObjPlanVinvula.delete(entity);
            return true;
        }
        return false;
    }
}
