package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavObjetivoBVivir;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavObjetivoBVivir;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivoBVivir;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavObjetivoBVivirMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivoBVivir;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavObjetivoBVivir implements IServiceUzyTavObjetivoBVivir{
    private final DaoUzyTavObjetivoBVivir daoUzyTavObjetivoBVivir;
    private final UzyTavObjetivoBVivirMapper mapper;

    public ServiceUzyTavObjetivoBVivir(DaoUzyTavObjetivoBVivir daoUzyTavObjetivoBVivir, UzyTavObjetivoBVivirMapper mapper) {
        this.daoUzyTavObjetivoBVivir = daoUzyTavObjetivoBVivir;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavObjetivoBVivir ListarPorID(Long id) {
        ModelUzyTavObjetivoBVivir entity = daoUzyTavObjetivoBVivir.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavObjetivoBVivir> ListarRegistros() {
        List<ModelUzyTavObjetivoBVivir> entities = daoUzyTavObjetivoBVivir.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTavObjetivoBVivir> findByUzytavobjetivo_b_vivirid_padre(Long parentId) {
        List<ModelUzyTavObjetivoBVivir> entities = daoUzyTavObjetivoBVivir.findByUzytavobjetivo_b_vivirid_padre(parentId);
        return mapper.entitiesToDtos(entities);

    }

    @Override
    public DtoUzyTavObjetivoBVivir guardar(DtoUzyTavObjetivoBVivir dtoUzyTavObjetivoBVivir) {
        ModelUzyTavObjetivoBVivir entity = mapper.dtoToEntity(dtoUzyTavObjetivoBVivir);
        ModelUzyTavObjetivoBVivir nuevoEntity = daoUzyTavObjetivoBVivir.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavObjetivoBVivir editar(Long id, DtoUzyTavObjetivoBVivir dtoUzyTavObjetivoBVivir) {
        try {
            ModelUzyTavObjetivoBVivir entity = daoUzyTavObjetivoBVivir.findById(id).get();
            //Seteamos los nuevos datos del registro
            if (entity != null) {
                entity.setUzytavobjetivo_b_vivirdescripcion(dtoUzyTavObjetivoBVivir.getUzytavobjetivo_b_vivirdescripcion());
                entity.setUzytavobjetivo_b_vivirorden(dtoUzyTavObjetivoBVivir.getUzytavobjetivo_b_vivirorden());

                ModelUzyTavObjetivoBVivir updatedEntity = daoUzyTavObjetivoBVivir.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavObjetivoBVivir entity = daoUzyTavObjetivoBVivir.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavObjetivoBVivir.delete(entity);
            return true;
        }
        return false;
    }
}
