package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavObjetivosEstraInsti;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavObjetivosEstraInsti;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavObjetivosEstraInsti;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavObjetivosEstraInstiMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavObjetivosEstraInsti;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavObjetivosEstraInsti implements IServiceUzyTavObjetivosEstraInsti {

    private final DaoUzyTavObjetivosEstraInsti daoUzyTavObjetivosEstraInsti;

    private final UzyTavObjetivosEstraInstiMapper mapper;

    public ServiceUzyTavObjetivosEstraInsti(DaoUzyTavObjetivosEstraInsti daoUzyTavObjetivosEstraInsti, UzyTavObjetivosEstraInstiMapper mapper) {
        this.daoUzyTavObjetivosEstraInsti = daoUzyTavObjetivosEstraInsti;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavObjetivosEstraInsti ListarPorID(Long id) {
        ModelUzyTavObjetivosEstraInsti entity = daoUzyTavObjetivosEstraInsti.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavObjetivosEstraInsti> ListarRegistros() {
        List<ModelUzyTavObjetivosEstraInsti> entities = daoUzyTavObjetivosEstraInsti.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTavObjetivosEstraInsti> obtenerPorPadreId(Long padreId) {
        List<ModelUzyTavObjetivosEstraInsti> entities = daoUzyTavObjetivosEstraInsti.obtenerPorPadreId(padreId);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public List<DtoUzyTavObjetivosEstraInsti> obtenerEstraInstiPadre() {
        List<ModelUzyTavObjetivosEstraInsti> entities = daoUzyTavObjetivosEstraInsti.obtenerEstraInstiPadre();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavObjetivosEstraInsti guardar(DtoUzyTavObjetivosEstraInsti dtoUzyTavObjetivosEstraInsti) {
        ModelUzyTavObjetivosEstraInsti entity = mapper.dtoToEntity(dtoUzyTavObjetivosEstraInsti);
        ModelUzyTavObjetivosEstraInsti nuevoEntity = daoUzyTavObjetivosEstraInsti.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavObjetivosEstraInsti editar(Long id, DtoUzyTavObjetivosEstraInsti dtoUzyTavObjetivosEstraInsti) {
        try {
            ModelUzyTavObjetivosEstraInsti entity = daoUzyTavObjetivosEstraInsti.findById(id).get();
            if (entity != null) {
                entity.setUZYTAVOBJETIVOS_ESTRA_INSTI_DESCRIPCION(dtoUzyTavObjetivosEstraInsti.getUZYTAVOBJETIVOS_ESTRA_INSTI_DESCRIPCION());
                entity.setUZYTTIPESTR_CODE(dtoUzyTavObjetivosEstraInsti.getUZYTTIPESTR_CODE());
                ModelUzyTavObjetivosEstraInsti updatedEntity = daoUzyTavObjetivosEstraInsti.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavObjetivosEstraInsti entity = daoUzyTavObjetivosEstraInsti.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavObjetivosEstraInsti.delete(entity);
            return true;
        }
        return false;
    }
}
