package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavParametros_Det;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavParametros_Det;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavParametros_Det;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavParametrosDetMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavParametros_Det;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavParametros_Det implements IServiceUzyTavParametros_Det{

    private final UzyTavParametrosDetMapper mapper;

    private final DaoUzyTavParametros_Det daoUzyTavParametrosDet;

    public ServiceUzyTavParametros_Det(UzyTavParametrosDetMapper mapper, DaoUzyTavParametros_Det daoUzyTavParametrosDet) {
        this.mapper = mapper;
        this.daoUzyTavParametrosDet = daoUzyTavParametrosDet;
    }

    @Override
    public DtoUzyTavParametros_Det ListarPorID(Long id) {
        ModelUzyTavParametros_Det entity = daoUzyTavParametrosDet.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavParametros_Det> ListarRegistros() {
        List<ModelUzyTavParametros_Det> entities = daoUzyTavParametrosDet.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavParametros_Det guardar(DtoUzyTavParametros_Det dtoUzyTavParametrosDet) {
        ModelUzyTavParametros_Det entity = mapper.dtoToEntity(dtoUzyTavParametrosDet);
        ModelUzyTavParametros_Det nuevoEntity = daoUzyTavParametrosDet.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavParametros_Det editar(Long id, DtoUzyTavParametros_Det dtoUzyTavParametrosDet) {
        try {
            ModelUzyTavParametros_Det entity = daoUzyTavParametrosDet.findById(id).get();
            if (entity != null) {
                entity.setUzytparametros_det_id_alt(dtoUzyTavParametrosDet.getUzytparametros_det_id_alt());
                entity.setUzytparametros_det_descripcion(dtoUzyTavParametrosDet.getUzytparametros_det_descripcion());
                entity.setUzytparametros_det_estado(dtoUzyTavParametrosDet.getUzytparametros_det_estado());
                entity.setUzytparametros_det_orden(dtoUzyTavParametrosDet.getUzytparametros_det_orden());

                ModelUzyTavParametros_Det updatedEntity = daoUzyTavParametrosDet.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavParametros_Det entity = daoUzyTavParametrosDet.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavParametrosDet.delete(entity);
            return true;
        }
        return false;
    }
}

