package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPlanVPrograma;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavPlanVPrograma;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPlanVPrograma;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavPlanVProgramaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPlanVPrograma;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavPlanVPrograma implements IServiceUzyTavPlanVPrograma {

    private final UzyTavPlanVProgramaMapper mapper;
    private final DaoUzyTavPlanVPrograma daoUzyTavPlanVPrograma;

    public ServiceUzyTavPlanVPrograma(UzyTavPlanVProgramaMapper mapper, DaoUzyTavPlanVPrograma daoUzyTavPlanVPrograma) {
        this.mapper = mapper;
        this.daoUzyTavPlanVPrograma = daoUzyTavPlanVPrograma;
    }

    @Override
    public DtoUzyTavPlanVPrograma ListarPorID(Long id) {
        ModelUzyTavPlanVPrograma entity = daoUzyTavPlanVPrograma.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavPlanVPrograma> ListarRegistros() {
        List<ModelUzyTavPlanVPrograma> entities = daoUzyTavPlanVPrograma.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavPlanVPrograma guardar(DtoUzyTavPlanVPrograma dtoUzyTavPlanVPrograma) {
        ModelUzyTavPlanVPrograma entity = mapper.dtoToEntity(dtoUzyTavPlanVPrograma);
        ModelUzyTavPlanVPrograma nuevoEntity = daoUzyTavPlanVPrograma.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavPlanVPrograma editar(Long id, DtoUzyTavPlanVPrograma dtoUzyTavPlanVPrograma) {
        return null;
    }

    @Override
    public List<DtoUzyTavPlanVPrograma> obtenerRegistrosPorProgramaID(Long programaId) {
        List<ModelUzyTavPlanVPrograma> entities = daoUzyTavPlanVPrograma.obtenerRegistrosPorProgramaID(programaId);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavPlanVPrograma entity = daoUzyTavPlanVPrograma.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavPlanVPrograma.delete(entity);
            return true;
        }
        return false;
    }
}
