package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPobla;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavPobla;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPobla;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavPoblaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPobla;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;
import java.util.List;


@Service
public class ServiceUzyTavPobla implements IServiceUzyTavPobla {

    private final DaoUzyTavPobla daoUzyTavPobla;
    private final UzyTavPoblaMapper mapper;

    public ServiceUzyTavPobla(DaoUzyTavPobla daoUzyTavPobla, UzyTavPoblaMapper mapper) {
        this.daoUzyTavPobla = daoUzyTavPobla;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavPobla ListarPorID(@PathVariable Long id) {
        ModelUzyTavPobla entity = daoUzyTavPobla.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavPobla> ListarRegistros() {
        List<ModelUzyTavPobla> entities = daoUzyTavPobla.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavPobla guardar(DtoUzyTavPobla dtoUzyTavPobla) {
        ModelUzyTavPobla entity = mapper.dtoToEntity(dtoUzyTavPobla);
        ModelUzyTavPobla nuevoEntity = daoUzyTavPobla.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavPobla editar(Long id, DtoUzyTavPobla dtoUzyTavPobla) {
        try {
            ModelUzyTavPobla entity = daoUzyTavPobla.findById(id).get();
            entity.setUzytavpobla_tipo(dtoUzyTavPobla.getUzytavpobla_tipo());

            ModelUzyTavPobla updatedEntity = daoUzyTavPobla.save(entity);
            return mapper.entityToDto(updatedEntity);
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }


}