package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPoblaProy;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavPoblaProy;

import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPoblaProy;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavPoblaProyMapper;

import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPoblaProy;

import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PathVariable;

import java.util.List;


@Service
public class ServiceUzyTavPoblaProy implements IServiceUzyTavPoblaProy {

    private final DaoUzyTavPoblaProy daoUzyTavPoblaProy;
    private final UzyTavPoblaProyMapper mapper;

    public ServiceUzyTavPoblaProy(DaoUzyTavPoblaProy daoUzyTavPoblaProy, UzyTavPoblaProyMapper mapper) {
        this.daoUzyTavPoblaProy = daoUzyTavPoblaProy;
        this.mapper = mapper;
    }

    public List<DtoUzyTavPoblaProy> ListarpoblaproyPorProyec(Long proyecId) {
        List<ModelUzyTavPoblaProy> entidades = daoUzyTavPoblaProy.obtenerPoblaProyPorProyec(proyecId);
        return mapper.entitiesToDtos(entidades);
    }







    @Override
    public DtoUzyTavPoblaProy ListarPorID(@PathVariable Long id) {
        ModelUzyTavPoblaProy entity = daoUzyTavPoblaProy.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavPoblaProy> ListarRegistros() {
        List<ModelUzyTavPoblaProy> entities = daoUzyTavPoblaProy.findAll();
        return mapper.entitiesToDtos(entities);
    }



    @Override
    public DtoUzyTavPoblaProy guardar(DtoUzyTavPoblaProy dtoUzyTavPoblaProy) {
        ModelUzyTavPoblaProy entity = mapper.dtoToEntity(dtoUzyTavPoblaProy);
        ModelUzyTavPoblaProy nuevoEntity = daoUzyTavPoblaProy.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavPoblaProy editar(Long id, DtoUzyTavPoblaProy dtoUzyTavPoblaProy) {
        try {
            ModelUzyTavPoblaProy entity = daoUzyTavPoblaProy.findById(id).get();



            ModelUzyTavPoblaProy updatedEntity = daoUzyTavPoblaProy.save(entity);
            return mapper.entityToDto(updatedEntity);
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }


}
