package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavProgObjEstartegico;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavProgObjEstartegico;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavProgObjEstartegico;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavProgObjEstartegicoMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavProgObjEstartegico;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavProgObjEstartegico implements IServiceUzyTavProgObjEstartegico{

    private final DaoUzyTavProgObjEstartegico daoUzyTavProgObjEstartegico;
    private final UzyTavProgObjEstartegicoMapper mapper;

    public ServiceUzyTavProgObjEstartegico(DaoUzyTavProgObjEstartegico daoUzyTavProgObjEstartegico, UzyTavProgObjEstartegicoMapper mapper) {
        this.daoUzyTavProgObjEstartegico = daoUzyTavProgObjEstartegico;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavProgObjEstartegico ListarPorID(Long id) {
        ModelUzyTavProgObjEstartegico entity = daoUzyTavProgObjEstartegico.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavProgObjEstartegico> ListarRegistros() {
        List<ModelUzyTavProgObjEstartegico> entities = daoUzyTavProgObjEstartegico.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavProgObjEstartegico guardar(DtoUzyTavProgObjEstartegico dtoUzyTavProgObjEstartegico) {
        ModelUzyTavProgObjEstartegico entity = mapper.dtoToEntity(dtoUzyTavProgObjEstartegico);
        ModelUzyTavProgObjEstartegico nuevoEntity = daoUzyTavProgObjEstartegico.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavProgObjEstartegico editar(Long id, DtoUzyTavProgObjEstartegico dtoUzyTavProgObjEstartegico) {
       return null;
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavProgObjEstartegico entity = daoUzyTavProgObjEstartegico.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavProgObjEstartegico.delete(entity);
            return true;
        }
        return false;
    }
}
