package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPrograma_Eplanv;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavPrograma_Eplanv;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_Eplanv;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavPrograma_EplanvMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_Eplanv;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavPrograma_Eplanv implements IServiceUzyTavPrograma_Eplanv {

    private final DaoUzyTavPrograma_Eplanv daoUzyTavProgramaEplanv;

    private final UzyTavPrograma_EplanvMapper mapper;

    public ServiceUzyTavPrograma_Eplanv(DaoUzyTavPrograma_Eplanv daoUzyTavProgramaEplanv, UzyTavPrograma_EplanvMapper mapper) {
        this.daoUzyTavProgramaEplanv = daoUzyTavProgramaEplanv;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavPrograma_Eplanv ListarPorID(Long id) {
        ModelUzyTavPrograma_Eplanv entity = daoUzyTavProgramaEplanv.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavPrograma_Eplanv> ListarRegistros() {
        List<ModelUzyTavPrograma_Eplanv> entities = daoUzyTavProgramaEplanv.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavPrograma_Eplanv guardar(DtoUzyTavPrograma_Eplanv dtoUzyTavProgramaEplanv) {
        ModelUzyTavPrograma_Eplanv entity = mapper.dtoToEntity(dtoUzyTavProgramaEplanv);
        ModelUzyTavPrograma_Eplanv nuevoEntity = daoUzyTavProgramaEplanv.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavPrograma_Eplanv editar(Long id, DtoUzyTavPrograma_Eplanv dtoUzyTavProgramaEplanv) {
        try {
            ModelUzyTavPrograma_Eplanv entity = daoUzyTavProgramaEplanv.findById(id).get();

            //Seteamos los nuevos datos del registro
            if (entity != null) {

                ModelUzyTavPrograma_Eplanv updatedEntity = daoUzyTavProgramaEplanv.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavPrograma_Eplanv entity = daoUzyTavProgramaEplanv.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavProgramaEplanv.delete(entity);
            return true;
        }
        return false;
    }
}
