package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavPrograma_V;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavPrograma_V;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.Uzytavprograma_VMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavPrograma_V;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service

public class ServiceUzyTavPrograma_V implements IServiceUzyTavPrograma_V {

    private final DaoUzyTavPrograma_V daoUzyTavProgramaV;
    private final Uzytavprograma_VMapper mapper;

    @Autowired
    public ServiceUzyTavPrograma_V(DaoUzyTavPrograma_V daoUzyTavProgramaV, Uzytavprograma_VMapper mapper) {
        this.daoUzyTavProgramaV = daoUzyTavProgramaV;
        this.mapper = mapper;

    }

    @Override
    public DtoUzyTavPrograma_V ListarPorID(Long id) {
        ModelUzyTavPrograma_V entity = daoUzyTavProgramaV.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavPrograma_V> ListarRegistros() {
        List<ModelUzyTavPrograma_V> entities = daoUzyTavProgramaV.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavPrograma_V guardar(DtoUzyTavPrograma_V dtoUzyTavProgramaV) {
        ModelUzyTavPrograma_V entity = mapper.dtoToEntity(dtoUzyTavProgramaV);
        ModelUzyTavPrograma_V nuevoEntity = daoUzyTavProgramaV.save(entity);

        // Obtén el ID generado
        Long idGuardado = nuevoEntity.getUzytavprograma_v_id();

        // Establece el ID en el DTO
        dtoUzyTavProgramaV.setUzytavprograma_v_id(idGuardado);

        return dtoUzyTavProgramaV;
    }

    @Override
    public DtoUzyTavPrograma_V editar(Long id, DtoUzyTavPrograma_V dtoUzyTavProgramaV) {
        try {
            ModelUzyTavPrograma_V entity = daoUzyTavProgramaV.findById(id).orElse(null);
            // Seteamos los nuevos datos del registro
            if (entity != null) {
                if (dtoUzyTavProgramaV.getUzytavprograma_vnombre() != null) {
                    entity.setUzytavprograma_vnombre(dtoUzyTavProgramaV.getUzytavprograma_vnombre());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vresumen() != null) {
                    entity.setUzytavprograma_vresumen(dtoUzyTavProgramaV.getUzytavprograma_vresumen());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_presenta() != null) {
                    entity.setUzytavprograma_vfecha_presenta(dtoUzyTavProgramaV.getUzytavprograma_vfecha_presenta());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_inicio() != null) {
                    entity.setUzytavprograma_vfecha_inicio(dtoUzyTavProgramaV.getUzytavprograma_vfecha_inicio());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_fin() != null) {
                    entity.setUzytavprograma_vfecha_fin(dtoUzyTavProgramaV.getUzytavprograma_vfecha_fin());
                }
                if (dtoUzyTavProgramaV.getStvsubj_code() != null) {
                    entity.setStvsubj_code(dtoUzyTavProgramaV.getStvsubj_code());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vmonto_nombre() != null) {
                    entity.setUzytavprograma_vmonto_nombre(dtoUzyTavProgramaV.getUzytavprograma_vmonto_nombre());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vmonto_digi() != null) {
                    entity.setUzytavprograma_vmonto_digi(dtoUzyTavProgramaV.getUzytavprograma_vmonto_digi());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vmetas() != null) {
                    entity.setUzytavprograma_vmetas(dtoUzyTavProgramaV.getUzytavprograma_vmetas());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vsituacion_actual() != null) {
                    entity.setUzytavprograma_vsituacion_actual(dtoUzyTavProgramaV.getUzytavprograma_vsituacion_actual());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vpoliticas() != null) {
                    entity.setUzytavprograma_vpoliticas(dtoUzyTavProgramaV.getUzytavprograma_vpoliticas());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vviabilidad_tecnica() != null) {
                    entity.setUzytavprograma_vviavilidad_tecnica(dtoUzyTavProgramaV.getUzytavprograma_vviabilidad_tecnica());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vperderia_no_ejecuta() != null) {
                    entity.setUzytavprograma_vperderia_no_ejecuta(dtoUzyTavProgramaV.getUzytavprograma_vperderia_no_ejecuta());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vresultados_impacto() != null) {
                    entity.setUzytavprograma_vresultados_impacto(dtoUzyTavProgramaV.getUzytavprograma_vresultados_impacto());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vproyecto_nombre() != null) {
                    entity.setUzytavprograma_vproyecto_nombre(dtoUzyTavProgramaV.getUzytavprograma_vproyecto_nombre());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vproyecto_digi() != null) {
                    entity.setUzytavprograma_vproyecto_digi(dtoUzyTavProgramaV.getUzytavprograma_vproyecto_digi());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfactor_c_exito() != null) {
                    entity.setUzytavprograma_vfactor_c_exito(dtoUzyTavProgramaV.getUzytavprograma_vfactor_c_exito());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vubicacion() != null) {
                    entity.setUzytavprograma_vubicacion(dtoUzyTavProgramaV.getUzytavprograma_vubicacion());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vdiagnostico() != null) {
                    entity.setUzytavprograma_vdiagnostico(dtoUzyTavProgramaV.getUzytavprograma_vdiagnostico());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vlinea_base() != null) {
                    entity.setUzytavprograma_vlinea_base(dtoUzyTavProgramaV.getUzytavprograma_vlinea_base());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vbeneficios() != null) {
                    entity.setUzytavprograma_vbeneficios(dtoUzyTavProgramaV.getUzytavprograma_vbeneficios());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vduracion_anios() != null) {
                    entity.setUzytavprograma_vduracion_anios(dtoUzyTavProgramaV.getUzytavprograma_vduracion_anios());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vdiuracion_meses() != null) {
                    entity.setUzytavprograma_vdiuracion_meses(dtoUzyTavProgramaV.getUzytavprograma_vdiuracion_meses());
                }
                if (dtoUzyTavProgramaV.getStvcamp_code() != null) {
                    entity.setStvcamp_code(dtoUzyTavProgramaV.getStvcamp_code());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_finr() != null) {
                    entity.setUzytavprograma_vfecha_finr(dtoUzyTavProgramaV.getUzytavprograma_vfecha_finr());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vestado() != null) {
                    entity.setUzytavprograma_vestado(dtoUzyTavProgramaV.getUzytavprograma_vestado());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vcobertura() != null) {
                    entity.setUzytavprograma_vcobertura(dtoUzyTavProgramaV.getUzytavprograma_vcobertura());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vubicacion2() != null) {
                    entity.setUzytavprograma_vubicacion2(dtoUzyTavProgramaV.getUzytavprograma_vubicacion2());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vdiagnostico2() != null) {
                    entity.setUzytavprograma_vdiagnostico2(dtoUzyTavProgramaV.getUzytavprograma_vdiagnostico2());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vestado_activo() != null) {
                    entity.setUzytavprograma_vestado_activo(dtoUzyTavProgramaV.getUzytavprograma_vestado_activo());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vevaluacion_cual() != null) {
                    entity.setUzytavprograma_vevaluacion_cual(dtoUzyTavProgramaV.getUzytavprograma_vevaluacion_cual());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_cierre() != null) {
                    entity.setUzytavprograma_vfecha_cierre(dtoUzyTavProgramaV.getUzytavprograma_vfecha_cierre());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfecha_evaluacion() != null) {
                    entity.setUzytavprograma_vfecha_evaluacion(dtoUzyTavProgramaV.getUzytavprograma_vfecha_evaluacion());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vresumen2() != null) {
                    entity.setUzytavprograma_vresumen2(dtoUzyTavProgramaV.getUzytavprograma_vresumen2());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vlinea_base2() != null) {
                    entity.setUzytavprograma_vlinea_base2(dtoUzyTavProgramaV.getUzytavprograma_vlinea_base2());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vbeneficios2() != null) {
                    entity.setUzytavprograma_vbeneficios2(dtoUzyTavProgramaV.getUzytavprograma_vbeneficios2());
                }
                if (dtoUzyTavProgramaV.getUzytavprograma_vfactor_c_exito2() != null) {
                    entity.setUzytavprograma_vfactor_c_exito2(dtoUzyTavProgramaV.getUzytavprograma_vfactor_c_exito2());
                }
                ModelUzyTavPrograma_V updatedEntity = daoUzyTavProgramaV.save(entity);
                return mapper.entityToDto(updatedEntity);
            } else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavPrograma_V entity = daoUzyTavProgramaV.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavProgramaV.delete(entity);
            return true;
        }
        return false;
    }
}
