package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavResponsableProg;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavResponsableProg;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavResponsableProg;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavResponsableProgMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavResponsableProg;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavResponsableProg implements IServiceUzyTavResponsableProg{
    private final DaoUzyTavResponsableProg daoUzyTavResponsableProg;
    private final UzyTavResponsableProgMapper mapper;

    public ServiceUzyTavResponsableProg(DaoUzyTavResponsableProg daoUzyTavResponsableProg, UzyTavResponsableProgMapper mapper) {
        this.daoUzyTavResponsableProg = daoUzyTavResponsableProg;
        this.mapper = mapper;
    }

    @Override
    public DtoUzyTavResponsableProg ListarPorID(Long id) {
        if (id <= 0) {
            throw new IllegalArgumentException("El parámetro 'id' debe ser un valor positivo.");
        }
        try {
            ModelUzyTavResponsableProg entity = daoUzyTavResponsableProg.findById(id)
                    .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
            return mapper.entityToDto(entity);
        } catch (ResourceNotFoundException ex) {
            throw ex;
        } catch (Exception ex) { // Manejo de cualquier error en el servidor
            throw new RuntimeException("Error al buscar el registro con ID: " + id);
        }
    }

    @Override
    public List<DtoUzyTavResponsableProg> obtenerRegistrosPorUsuarioIDandProyectID(Long iddocente, Long uzytavproyec_id) {
        try {
            List<ModelUzyTavResponsableProg> entities = daoUzyTavResponsableProg.obtenerRegistrosPorUsuarioIDandProyectID(iddocente,uzytavproyec_id );
            return mapper.entitiesToDtos(entities);
        } catch (Exception ex) {
            throw new RuntimeException("Error al listar los registros: " + ex.getMessage());
        }
    }

    @Override
    public List<DtoUzyTavResponsableProg> obtenerRegistrosPorProyectID(Long uzytavproyec_id) {
        try {
            List<ModelUzyTavResponsableProg> entities = daoUzyTavResponsableProg.obtenerRegistrosPorProyectID(uzytavproyec_id );
            return mapper.entitiesToDtos(entities);
        } catch (Exception ex) {
            throw new RuntimeException("Error al listar los registros: " + ex.getMessage());
        }
    }

    @Override
    public List<DtoUzyTavResponsableProg> ListarRegistros() {
        try {
            List<ModelUzyTavResponsableProg> entities = daoUzyTavResponsableProg.findAll();
            return mapper.entitiesToDtos(entities);
        } catch (Exception ex) {
            throw new RuntimeException("Error al listar los registros: " + ex.getMessage());
        }
    }

    @Override
    public DtoUzyTavResponsableProg guardar(DtoUzyTavResponsableProg dtoUzyTavResponsableProg) {
        try {
            ModelUzyTavResponsableProg entity = mapper.dtoToEntity(dtoUzyTavResponsableProg);
            ModelUzyTavResponsableProg nuevoEntity = daoUzyTavResponsableProg.save(entity);
            return mapper.entityToDto(nuevoEntity);
        }
        catch (Exception ex) {
            throw new RuntimeException("Error al guardar el registro: " + ex.getMessage());
        }
    }

    @Override
    public DtoUzyTavResponsableProg editar(Long id, DtoUzyTavResponsableProg dtoUzyTavResponsableProg) {
        if (id <= 0) {
            throw new IllegalArgumentException("El ID del registro debe ser válido y mayor que cero.");
        }
        try {
            ModelUzyTavResponsableProg entity = daoUzyTavResponsableProg.findById(id).get();
            if (entity != null) {
                if(dtoUzyTavResponsableProg.getStvsubj_code_dpto()!=null){
                    entity.setStvsubj_code_dpto(dtoUzyTavResponsableProg.getStvsubj_code_dpto());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_orden()!=null){
                    entity.setUzytavresponsable_prog_g_orden(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_orden());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_horas_planif()!=null){
                    entity.setUzytavresponsable_prog_g_horas_planif(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_horas_planif());
                }
                if(dtoUzyTavResponsableProg.getStvmajr_code()!=null){
                    entity.setStvmajr_code(dtoUzyTavResponsableProg.getStvmajr_code());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_nro_certificados()!=null){
                    entity.setUzytavresponsable_prog_g_nro_certificados(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_nro_certificados());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_fecha_creacion()!=null){
                    entity.setUzytavresponsable_prog_g_fecha_creacion(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_fecha_creacion());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_estado()!=null){
                    entity.setUzytavresponsable_prog_g_estado(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_estado());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_verificar()!=null){
                    entity.setUzytavresponsable_prog_g_verificar(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_verificar());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_verfecha()!=null){
                    entity.setUzytavresponsable_prog_g_verfecha(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_verfecha());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_responsable()!=null){
                    entity.setUzytavresponsable_prog_g_responsable(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_responsable());
                }
                if(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_calificacion()!=null){
                    entity.setUzytavresponsable_prog_g_calificacion(dtoUzyTavResponsableProg.getUzytavresponsable_prog_g_calificacion());
                }

                ModelUzyTavResponsableProg updatedEntity = daoUzyTavResponsableProg.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public boolean eliminar(Long id) {
        if (id == null || id <= 0) {
            throw new IllegalArgumentException("El ID del registro debe ser válido y mayor que cero.");
        }
        try {

            ModelUzyTavResponsableProg entity = daoUzyTavResponsableProg.findById(id).orElseThrow(() -> new ResourceNotFoundException("Registro no encontrado con ID: " + id));
            if (entity != null) {
                daoUzyTavResponsableProg.delete(entity);
                return true;
            }
            return false;
        } catch (ResourceNotFoundException ex) {
            throw ex;
        } catch (Exception ex) {
            throw new RuntimeException("Error al eliminar el registro: " + ex.getMessage());
        }
    }
}
