package ec.edu.espe.movilidad.MovilidadWS.Service.UzyTavSubLinea;

import ec.edu.espe.movilidad.MovilidadWS.Dao.DaoUzyTavSubLinea;
import ec.edu.espe.movilidad.MovilidadWS.Dto.DtoUzyTavSubLinea;
import ec.edu.espe.movilidad.MovilidadWS.Exceptions.ResourceNotFoundException;
import ec.edu.espe.movilidad.MovilidadWS.Mapper.Components_Class.UzyTavSubLineaMapper;
import ec.edu.espe.movilidad.MovilidadWS.Model.ModelUzyTavSubLinea;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class ServiceUzyTavSubLinea implements IServiceUzyTavSubLinea{

    @Autowired
    private DaoUzyTavSubLinea daoUzyTavSubLinea;

    @Autowired
    private UzyTavSubLineaMapper mapper;
    @Override
    public DtoUzyTavSubLinea ListarPorID(Long id) {
        ModelUzyTavSubLinea entity = daoUzyTavSubLinea.findById(id)
                .orElseThrow(() -> new ResourceNotFoundException("No se encontró el registro con ID: " + id));
        return mapper.entityToDto(entity);
    }

    @Override
    public List<DtoUzyTavSubLinea> ListarRegistros() {
        List<ModelUzyTavSubLinea> entities = daoUzyTavSubLinea.findAll();
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public DtoUzyTavSubLinea guardar(DtoUzyTavSubLinea dtoUzyTavSubLinea) {
        ModelUzyTavSubLinea entity = mapper.dtoToEntity(dtoUzyTavSubLinea);
        ModelUzyTavSubLinea nuevoEntity = daoUzyTavSubLinea.save(entity);
        return mapper.entityToDto(nuevoEntity);
    }

    @Override
    public DtoUzyTavSubLinea editar(Long id, DtoUzyTavSubLinea dtoUzyTavSubLinea) {
        try {
            ModelUzyTavSubLinea entity = daoUzyTavSubLinea.findById(id).get();
            if (entity != null) {
                //Seteamos los nuevos datos del registro
                entity.setUzytavlinea_UNESCO(dtoUzyTavSubLinea.getUzytavlinea_UNESCO());
                entity.setUzytavsublinea_DESCRIPCION(dtoUzyTavSubLinea.getUzytavsublinea_DESCRIPCION());
                ModelUzyTavSubLinea updatedEntity = daoUzyTavSubLinea.save(entity);
                return mapper.entityToDto(updatedEntity);
            }else {
                throw new ResourceNotFoundException("No se encontró el registro con ID: " + id);
            }
        } catch (Exception e) {
            throw new ResourceNotFoundException("Error al editar el registro: " + e.getMessage());
        }
    }

    @Override
    public List<DtoUzyTavSubLinea> obtenerRegistrosPorLinea(Long lineaID) {
        List<ModelUzyTavSubLinea> entities = daoUzyTavSubLinea.obtenerRegistrosPorLinea(lineaID);
        return mapper.entitiesToDtos(entities);
    }

    @Override
    public boolean eliminar(Long id) {
        ModelUzyTavSubLinea entity = daoUzyTavSubLinea.findById(id).orElse(null);
        if (entity != null) {
            daoUzyTavSubLinea.delete(entity);
            return true;
        }
        return false;
    }
}
